<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * UBV\SurUbvBundle\Entity\AldeaMallaCurricula
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\AldeaMallaCurriculaRepository")
 * @ORM\Table(name="aldea_malla_curricula", indexes={@ORM\Index(name="fk_aldea_malla_curricula_aldea1_idx", columns={"aldea_id"}), @ORM\Index(name="fk_aldea_malla_curricula_malla_curricular1_idx", columns={"malla_curricular_id"}), @ORM\Index(name="fk_aldea_malla_curricula_turno1_idx", columns={"turno_id"})}, uniqueConstraints={@ORM\UniqueConstraint(name="id_aldea_malla_curricular_UNIQUE", columns={"id"})})
 */
class AldeaMallaCurricula
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="aldea_malla_curricula_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="string", length=2, nullable=true)
     */
    protected $estatus;

    /**
     * @ORM\OneToMany(targetEntity="EstudianteDetalle", mappedBy="aldeaMallaCurricula")
     * @ORM\JoinColumn(name="id", referencedColumnName="aldea_malla_curricula_id", nullable=false)
     */
    protected $estudianteDetalles;

    /**
     * @ORM\OneToMany(targetEntity="OfertaAcademica", mappedBy="aldeaMallaCurricula")
     * @ORM\JoinColumn(name="id", referencedColumnName="aldea_malla_curricula_id", nullable=false)
     */
    protected $ofertaAcademicas;

    /**
     * @ORM\ManyToOne(targetEntity="Aldea", inversedBy="aldeaMallaCurriculas")
     * @ORM\JoinColumn(name="aldea_id", referencedColumnName="id", nullable=false)
     */
    protected $aldea;

    /**
     * @ORM\ManyToOne(targetEntity="MallaCurricular", inversedBy="aldeaMallaCurriculas")
     * @ORM\JoinColumn(name="malla_curricular_id", referencedColumnName="id", nullable=false)
     */
    protected $mallaCurricular;

    /**
     * @ORM\ManyToOne(targetEntity="Turno", inversedBy="aldeaMallaCurriculas")
     * @ORM\JoinColumn(name="turno_id", referencedColumnName="id", nullable=false)
     */
    protected $turno;

    public function __construct()
    {
        $this->estudianteDetalles = new ArrayCollection();
        $this->ofertaAcademicas = new ArrayCollection();
    }

    public function __sleep()
    {
        return array('id', 'estatus', 'aldea_id', 'malla_curricular_id', 'turno_id');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set estatus
     *
     * @param string $estatus
     * @return AldeaMallaCurricula
     */
    public function setEstatus($estatus)
    {
        $this->estatus = $estatus;

        return $this;
    }

    /**
     * Get estatus
     *
     * @return string 
     */
    public function getEstatus()
    {
        return $this->estatus;
    }

    /**
     * Add estudianteDetalles
     *
     * @param \UBV\SurUbvBundle\Entity\EstudianteDetalle $estudianteDetalles
     * @return AldeaMallaCurricula
     */
    public function addEstudianteDetalle(\UBV\SurUbvBundle\Entity\EstudianteDetalle $estudianteDetalles)
    {
        $this->estudianteDetalles[] = $estudianteDetalles;

        return $this;
    }

    /**
     * Remove estudianteDetalles
     *
     * @param \UBV\SurUbvBundle\Entity\EstudianteDetalle $estudianteDetalles
     */
    public function removeEstudianteDetalle(\UBV\SurUbvBundle\Entity\EstudianteDetalle $estudianteDetalles)
    {
        $this->estudianteDetalles->removeElement($estudianteDetalles);
    }

    /**
     * Get estudianteDetalles
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getEstudianteDetalles()
    {
        return $this->estudianteDetalles;
    }

    /**
     * Add ofertaAcademicas
     *
     * @param \UBV\SurUbvBundle\Entity\OfertaAcademica $ofertaAcademicas
     * @return AldeaMallaCurricula
     */
    public function addOfertaAcademica(\UBV\SurUbvBundle\Entity\OfertaAcademica $ofertaAcademicas)
    {
        $this->ofertaAcademicas[] = $ofertaAcademicas;

        return $this;
    }

    /**
     * Remove ofertaAcademicas
     *
     * @param \UBV\SurUbvBundle\Entity\OfertaAcademica $ofertaAcademicas
     */
    public function removeOfertaAcademica(\UBV\SurUbvBundle\Entity\OfertaAcademica $ofertaAcademicas)
    {
        $this->ofertaAcademicas->removeElement($ofertaAcademicas);
    }

    /**
     * Get ofertaAcademicas
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getOfertaAcademicas()
    {
        return $this->ofertaAcademicas;
    }

    /**
     * Set aldea
     *
     * @param \UBV\SurUbvBundle\Entity\Aldea $aldea
     * @return AldeaMallaCurricula
     */
    public function setAldea(\UBV\SurUbvBundle\Entity\Aldea $aldea)
    {
        $this->aldea = $aldea;

        return $this;
    }

    /**
     * Get aldea
     *
     * @return \UBV\SurUbvBundle\Entity\Aldea 
     */
    public function getAldea()
    {
        return $this->aldea;
    }

    /**
     * Set mallaCurricular
     *
     * @param \UBV\SurUbvBundle\Entity\MallaCurricular $mallaCurricular
     * @return AldeaMallaCurricula
     */
    public function setMallaCurricular(\UBV\SurUbvBundle\Entity\MallaCurricular $mallaCurricular)
    {
        $this->mallaCurricular = $mallaCurricular;

        return $this;
    }

    /**
     * Get mallaCurricular
     *
     * @return \UBV\SurUbvBundle\Entity\MallaCurricular 
     */
    public function getMallaCurricular()
    {
        return $this->mallaCurricular;
    }

    /**
     * Set turno
     *
     * @param \UBV\SurUbvBundle\Entity\Turno $turno
     * @return AldeaMallaCurricula
     */
    public function setTurno(\UBV\SurUbvBundle\Entity\Turno $turno)
    {
        $this->turno = $turno;

        return $this;
    }

    /**
     * Get turno
     *
     * @return \UBV\SurUbvBundle\Entity\Turno 
     */
    public function getTurno()
    {
        return $this->turno;
    }
}
