<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;


/**
 * UBV\SurUbvBundle\Entity\AldeaPrograma
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\AldeaProgramaRepository")
 * @ORM\Table(name="aldea_programa", indexes={@ORM\Index(name="fk_aldea_programa_aldea1_idx", columns={"aldea_id"}), @ORM\Index(name="fk_aldea_programa_programa1_idx", columns={"programa_id"})}, uniqueConstraints={@ORM\UniqueConstraint(name="codigo_opsu_UNIQUE", columns={"codigo_opsu"}), @ORM\UniqueConstraint(name="id_aldea_programa_UNIQUE", columns={"id"})})
 */
class AldeaPrograma
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="aldea_programa_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="integer", nullable=true)
     */
    protected $codigo_opsu;

    /**
     * @ORM\ManyToOne(targetEntity="Aldea", inversedBy="aldeaProgramas")
     * @ORM\JoinColumn(name="aldea_id", referencedColumnName="id", nullable=false)
     */
    protected $aldea;

    /**
     * @ORM\ManyToOne(targetEntity="Programa", inversedBy="aldeaProgramas")
     * @ORM\JoinColumn(name="programa_id", referencedColumnName="id", nullable=false)
     */
    protected $programa;

    public function __construct()
    {
    }

    public function __sleep()
    {
        return array('id', 'codigo_opsu', 'aldea_id', 'programa_id');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set codigo_opsu
     *
     * @param integer $codigoOpsu
     * @return AldeaPrograma
     */
    public function setCodigoOpsu($codigoOpsu)
    {
        $this->codigo_opsu = $codigoOpsu;

        return $this;
    }

    /**
     * Get codigo_opsu
     *
     * @return integer 
     */
    public function getCodigoOpsu()
    {
        return $this->codigo_opsu;
    }

    /**
     * Set aldea
     *
     * @param \UBV\SurUbvBundle\Entity\Aldea $aldea
     * @return AldeaPrograma
     */
    public function setAldea(\UBV\SurUbvBundle\Entity\Aldea $aldea)
    {
        $this->aldea = $aldea;

        return $this;
    }

    /**
     * Get aldea
     *
     * @return \UBV\SurUbvBundle\Entity\Aldea 
     */
    public function getAldea()
    {
        return $this->aldea;
    }

    /**
     * Set programa
     *
     * @param \UBV\SurUbvBundle\Entity\Programa $programa
     * @return AldeaPrograma
     */
    public function setPrograma(\UBV\SurUbvBundle\Entity\Programa $programa)
    {
        $this->programa = $programa;

        return $this;
    }

    /**
     * Get programa
     *
     * @return \UBV\SurUbvBundle\Entity\Programa 
     */
    public function getPrograma()
    {
        return $this->programa;
    }
}
