<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * UBV\SurUbvBundle\Entity\AldeaTelefono
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\AldeaTelefonoRepository")
 * @ORM\Table(name="aldea_telefono", indexes={@ORM\Index(name="fk_aldea_telefono_telefono_codigo_area1_idx", columns={"telefono_codigo_area_id"}), @ORM\Index(name="fk_aldea_telefono_aldea1_idx", columns={"aldea_id"})}, uniqueConstraints={@ORM\UniqueConstraint(name="id_aldea_telefono_UNIQUE", columns={"id"})})
 */
class AldeaTelefono
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="aldea_telefono_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="integer")
     */
    protected $descripcion;

    /**
     * @ORM\ManyToOne(targetEntity="TelefonoCodigoArea", inversedBy="aldeaTelefonos")
     * @ORM\JoinColumn(name="telefono_codigo_area_id", referencedColumnName="id", nullable=false)
     */
    protected $telefonoCodigoArea;

    /**
     * @ORM\ManyToOne(targetEntity="Aldea", inversedBy="aldeaTelefonos")
     * @ORM\JoinColumn(name="aldea_id", referencedColumnName="id", nullable=false)
     */
    protected $aldea;

    public function __construct()
    {
    }

    public function __sleep()
    {
        return array('id', 'descripcion', 'telefono_codigo_area_id', 'aldea_id');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set descripcion
     *
     * @param integer $descripcion
     * @return AldeaTelefono
     */
    public function setDescripcion($descripcion)
    {
        $this->descripcion = $descripcion;

        return $this;
    }

    /**
     * Get descripcion
     *
     * @return integer 
     */
    public function getDescripcion()
    {
        return $this->descripcion;
    }

    /**
     * Set telefonoCodigoArea
     *
     * @param \UBV\SurUbvBundle\Entity\TelefonoCodigoArea $telefonoCodigoArea
     * @return AldeaTelefono
     */
    public function setTelefonoCodigoArea(\UBV\SurUbvBundle\Entity\TelefonoCodigoArea $telefonoCodigoArea)
    {
        $this->telefonoCodigoArea = $telefonoCodigoArea;

        return $this;
    }

    /**
     * Get telefonoCodigoArea
     *
     * @return \UBV\SurUbvBundle\Entity\TelefonoCodigoArea 
     */
    public function getTelefonoCodigoArea()
    {
        return $this->telefonoCodigoArea;
    }

    /**
     * Set aldea
     *
     * @param \UBV\SurUbvBundle\Entity\Aldea $aldea
     * @return AldeaTelefono
     */
    public function setAldea(\UBV\SurUbvBundle\Entity\Aldea $aldea)
    {
        $this->aldea = $aldea;

        return $this;
    }

    /**
     * Get aldea
     *
     * @return \UBV\SurUbvBundle\Entity\Aldea 
     */
    public function getAldea()
    {
        return $this->aldea;
    }
}
