<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * UBV\SurUbvBundle\Entity\AreaConocimiento
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\AreaConocimientoRepository")
 * @ORM\Table(name="area_conocimiento", uniqueConstraints={@ORM\UniqueConstraint(name="id_area_conocimiento_UNIQUE", columns={"id"})})
 */
class AreaConocimiento
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="area_conocimiento_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="string", length=45)
     */
    protected $descripcion;

    /**
     * @ORM\OneToOne(targetEntity="CentroEstudio", mappedBy="areaConocimiento")
     */
    protected $centroEstudio;

    public function __construct()
    {
        $this->centroEstudios = new ArrayCollection();
    }

    public function __sleep()
    {
        return array('id', 'descripcion');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set descripcion
     *
     * @param string $descripcion
     * @return AreaConocimiento
     */
    public function setDescripcion($descripcion)
    {
        $this->descripcion = $descripcion;

        return $this;
    }

    /**
     * Get descripcion
     *
     * @return string 
     */
    public function getDescripcion()
    {
        return $this->descripcion;
    }

    /**
     * Set centroEstudio
     *
     * @param \UBV\SurUbvBundle\Entity\CentroEstudio $centroEstudio
     * @return AreaConocimiento
     */
    public function setCentroEstudio(\UBV\SurUbvBundle\Entity\CentroEstudio $centroEstudio = null)
    {
        $this->centroEstudio = $centroEstudio;

        return $this;
    }

    /**
     * Get centroEstudio
     *
     * @return \UBV\SurUbvBundle\Entity\CentroEstudio 
     */
    public function getCentroEstudio()
    {
        return $this->centroEstudio;
    }
}
