<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * UBV\SurUbvBundle\Entity\AspiranteEstatus
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\AspiranteEstatusRepository")
 * @ORM\Table(name="aspirante_estatus", uniqueConstraints={@ORM\UniqueConstraint(name="id_aspirante_estatus_UNIQUE", columns={"id"})})
 */
class AspiranteEstatus
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="aspirante_estatus_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="string", length=45)
     */
    protected $descripcion;

    /**
     * @ORM\OneToMany(targetEntity="Aspirante", mappedBy="aspiranteEstatus")
     * @ORM\JoinColumn(name="id", referencedColumnName="aspirante_estatus_id", nullable=false)
     */
    protected $aspirantes;
    
    /**
     * @ORM\OneToMany(targetEntity="Candidato", mappedBy="aspiranteEstatus")
     * @ORM\JoinColumn(name="id", referencedColumnName="aspirante_estatus_id", nullable=false)
     */
    protected $candidatos;

    public function __construct()
    {
        $this->candidatos = new ArrayCollection();
        $this->aspirantes = new ArrayCollection();
    }

    public function __sleep()
    {
        return array('id', 'descripcion');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set descripcion
     *
     * @param string $descripcion
     * @return AspiranteEstatus
     */
    public function setDesripcion($descripcion)
    {
        $this->descripcion = $descripcion;

        return $this;
    }

    /**
     * Get descripcion
     *
     * @return string 
     */
    public function getDesripcion()
    {
        return $this->descripcion;
    }

    /**
     * Add aspirantes
     *
     * @param \UBV\SurUbvBundle\Entity\Aspirante $aspirantes
     * @return AspiranteEstatus
     */
    public function addAspirante(\UBV\SurUbvBundle\Entity\Aspirante $aspirantes)
    {
        $this->aspirantes[] = $aspirantes;

        return $this;
    }

    /**
     * Remove aspirantes
     *
     * @param \UBV\SurUbvBundle\Entity\Aspirante $aspirantes
     */
    public function removeAspirante(\UBV\SurUbvBundle\Entity\Aspirante $aspirantes)
    {
        $this->aspirantes->removeElement($aspirantes);
    }

    /**
     * Get aspirantes
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getAspirantes()
    {
        return $this->aspirantes;
    }
				
    public function __toString(){
            return $this->getDesripcion();
    }

    /**
     * Set descripcion
     *
     * @param string $descripcion
     * @return AspiranteEstatus
     */
    public function setDescripcion($descripcion)
    {
        $this->descripcion = $descripcion;

        return $this;
    }

    /**
     * Get descripcion
     *
     * @return string 
     */
    public function getDescripcion()
    {
        return $this->descripcion;
    }

    /**
     * Add candidatos
     *
     * @param \UBV\SurUbvBundle\Entity\Candidato $candidatos
     * @return AspiranteEstatus
     */
    public function addCandidato(\UBV\SurUbvBundle\Entity\Candidato $candidatos)
    {
        $this->candidatos[] = $candidatos;

        return $this;
    }

    /**
     * Remove candidatos
     *
     * @param \UBV\SurUbvBundle\Entity\Candidato $candidatos
     */
    public function removeCandidato(\UBV\SurUbvBundle\Entity\Candidato $candidatos)
    {
        $this->candidatos->removeElement($candidatos);
    }

    /**
     * Get candidatos
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getCandidatos()
    {
        return $this->candidatos;
    }
}
