<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * UBV\SurUbvBundle\Entity\AspiranteTipo
 *
 * @ORM\Entity()
 * @ORM\Table(name="aspirante_tipo", uniqueConstraints={@ORM\UniqueConstraint(name="id_aspirante_tipo_UNIQUE", columns={"id"})})
 */
class AspiranteTipo
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="aspirante_tipo_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="string", length=45)
     */
    protected $descripcion;

    /**
     * @ORM\OneToMany(targetEntity="Aspirante", mappedBy="aspiranteTipo")
     * @ORM\JoinColumn(name="id", referencedColumnName="aspirante_tipo_id", nullable=false)
     */
    protected $aspirantes;
    
    /**
     * @ORM\OneToMany(targetEntity="Candidato", mappedBy="aspiranteTipo")
     * @ORM\JoinColumn(name="id", referencedColumnName="aspirante_tipo_id", nullable=false)
     */
    protected $candidatos;

    /**
     * @ORM\OneToMany(targetEntity="Estudiante", mappedBy="aspiranteTipo")
     * @ORM\JoinColumn(name="id", referencedColumnName="aspirante_tipo_id", nullable=false)
     */
    protected $estudiantes;

    public function __construct()
    {
        $this->aspirantes = new ArrayCollection();
        $this->candidatos = new ArrayCollection();
        $this->estudiantes = new ArrayCollection();
    }

    public function __sleep()
    {
        return array('id', 'descripcion');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set descripcion
     *
     * @param string $descripcion
     * @return AspiranteTipo
     */
    public function setDescripcion($descripcion)
    {
        $this->descripcion = $descripcion;

        return $this;
    }

    /**
     * Get descripcion
     *
     * @return string 
     */
    public function getDescripcion()
    {
        return $this->descripcion;
    }

    /**
     * Add aspirantes
     *
     * @param \UBV\SurUbvBundle\Entity\Aspirante $aspirantes
     * @return AspiranteTipo
     */
    public function addAspirante(\UBV\SurUbvBundle\Entity\Aspirante $aspirantes)
    {
        $this->aspirantes[] = $aspirantes;

        return $this;
    }

    /**
     * Remove aspirantes
     *
     * @param \UBV\SurUbvBundle\Entity\Aspirante $aspirantes
     */
    public function removeAspirante(\UBV\SurUbvBundle\Entity\Aspirante $aspirantes)
    {
        $this->aspirantes->removeElement($aspirantes);
    }

    /**
     * Get aspirantes
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getAspirantes()
    {
        return $this->aspirantes;
    }

    /**
     * Add estudiantes
     *
     * @param \UBV\SurUbvBundle\Entity\Estudiante $estudiantes
     * @return AspiranteTipo
     */
    public function addEstudiante(\UBV\SurUbvBundle\Entity\Estudiante $estudiantes)
    {
        $this->estudiantes[] = $estudiantes;

        return $this;
    }

    /**
     * Remove estudiantes
     *
     * @param \UBV\SurUbvBundle\Entity\Estudiante $estudiantes
     */
    public function removeEstudiante(\UBV\SurUbvBundle\Entity\Estudiante $estudiantes)
    {
        $this->estudiantes->removeElement($estudiantes);
    }

    /**
     * Get estudiantes
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getEstudiantes()
    {
        return $this->estudiantes;
    }
				
				public function __toString(){
						return $this->getDescripcion();
				}

    /**
     * Add candidatos
     *
     * @param \UBV\SurUbvBundle\Entity\Candidato $candidatos
     * @return AspiranteTipo
     */
    public function addCandidato(\UBV\SurUbvBundle\Entity\Candidato $candidatos)
    {
        $this->candidatos[] = $candidatos;

        return $this;
    }

    /**
     * Remove candidatos
     *
     * @param \UBV\SurUbvBundle\Entity\Candidato $candidatos
     */
    public function removeCandidato(\UBV\SurUbvBundle\Entity\Candidato $candidatos)
    {
        $this->candidatos->removeElement($candidatos);
    }

    /**
     * Get candidatos
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getCandidatos()
    {
        return $this->candidatos;
    }
}
