<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * UBV\SurUbvBundle\Entity\Candidato
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\CandidatoRepository")
 * @ORM\Table(name="candidato", indexes={@ORM\Index(name="fk_candidato_aspirante_tipo_idx", columns={"aspirante_tipo_id"}), @ORM\Index(name="fk_candidato_aspirante_estatus_idx", columns={"aspirante_estatus_id"}), @ORM\Index(name="fk_candidato_documento_identidad_tipo_idx", columns={"documento_identidad_tipo_id"}), @ORM\Index(name="fk_candidato_genero_idx", columns={"genero_id"}), @ORM\Index(name="fk_candidato_estado_civil_idx", columns={"estado_civil_id"}), @ORM\Index(name="fk_candidato_telefono_codigo_area_idx", columns={"telefono_codigo_area_id"}), @ORM\Index(name="fk_candidato_estado_idx", columns={"estado_residencia_id"}), @ORM\Index(name="fk_candidato_etnia_idx", columns={"etnia_id"}), @ORM\Index(name="fk_candidato_programa_idx", columns={"programa_id"}), @ORM\Index(name="fk_candidato_aldea_idx", columns={"aldea_id"}), @ORM\Index(name="fk_candidato_convenio_idx", columns={"convenio_id"})}, uniqueConstraints={@ORM\UniqueConstraint(name="id_candidato_UNIQUE", columns={"id"})})
 */
class Candidato
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="candidato_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="string", length=45)
     */
    protected $primer_nombre;

    /**
     * @ORM\Column(type="string", length=45, nullable=true)
     */
    protected $segundo_nombre;

    /**
     * @ORM\Column(type="string", length=45)
     */
    protected $primer_apellido;

    /**
     * @ORM\Column(type="string", length=45, nullable=true)
     */
    protected $segundo_apellido;

    /**
     * @ORM\Column(type="string", length=45)
     */
    protected $identificacion;

    /**
     * @ORM\Column(type="date")
     */
    protected $fecha_nacimiento;

    /**
     * @ORM\Column(type="string", length=45)
     */
    protected $telefono;

    /**
     * @ORM\Column(type="string", length=45)
     */
    protected $correo;

    /**
     * @ORM\Column(type="string", length=45, nullable=true)
     */
    protected $id_opsu;

    /**
     * @ORM\Column(type="date", nullable=true)
     */
    protected $ano_grado;

    /**
     * @ORM\Column(type="boolean")
     */
    protected $trabaja;

    /**
     * @ORM\Column(type="string", length=45, nullable=true)
     */
    protected $promedio_nota;

    /**
     * @ORM\ManyToOne(targetEntity="AspiranteTipo", inversedBy="candidatos")
     * @ORM\JoinColumn(name="aspirante_tipo_id", referencedColumnName="id", nullable=false)
     */
    protected $aspiranteTipo;

    /**
     * @ORM\ManyToOne(targetEntity="AspiranteEstatus", inversedBy="candidatos")
     * @ORM\JoinColumn(name="aspirante_estatus_id", referencedColumnName="id", nullable=false)
     */
    protected $aspiranteEstatus;

    /**
     * @ORM\ManyToOne(targetEntity="DocumentoIdentidadTipo", inversedBy="candidatos")
     * @ORM\JoinColumn(name="documento_identidad_tipo_id", referencedColumnName="id", nullable=false)
     */
    protected $documentoIdentidadTipo;

    /**
     * @ORM\ManyToOne(targetEntity="Genero", inversedBy="candidatos")
     * @ORM\JoinColumn(name="genero_id", referencedColumnName="id", nullable=false)
     */
    protected $genero;

    /**
     * @ORM\ManyToOne(targetEntity="EstadoCivil", inversedBy="candidatos")
     * @ORM\JoinColumn(name="estado_civil_id", referencedColumnName="id", nullable=false)
     */
    protected $estadoCivil;

    /**
     * @ORM\ManyToOne(targetEntity="TelefonoCodigoArea", inversedBy="candidatos")
     * @ORM\JoinColumn(name="telefono_codigo_area_id", referencedColumnName="id", nullable=false)
     */
    protected $telefonoCodigoArea;

    /**
     * @ORM\ManyToOne(targetEntity="Estado", inversedBy="candidatos")
     * @ORM\JoinColumn(name="estado_residencia_id", referencedColumnName="id")
     */
    protected $estado;

    /**
     * @ORM\ManyToOne(targetEntity="Etnia", inversedBy="candidatos")
     * @ORM\JoinColumn(name="etnia_id", referencedColumnName="id")
     */
    protected $etnia;

    /**
     * @ORM\ManyToOne(targetEntity="Programa", inversedBy="candidatos")
     * @ORM\JoinColumn(name="programa_id", referencedColumnName="id", nullable=false)
     */
    protected $programa;

    /**
     * @ORM\ManyToOne(targetEntity="Aldea", inversedBy="candidatos")
     * @ORM\JoinColumn(name="aldea_id", referencedColumnName="id", nullable=false)
     */
    protected $aldea;

    /**
     * @ORM\ManyToOne(targetEntity="Convenio", inversedBy="candidatos")
     * @ORM\JoinColumn(name="convenio_id", referencedColumnName="id")
     */
    protected $convenio;
    
    /**
     * @ORM\ManyToOne(targetEntity="CorreoTipo", inversedBy="candidatos")
     * @ORM\JoinColumn(name="correo_tipo_id", referencedColumnName="id", nullable=false)
     */
    protected $correoTipo;
    
    /**
     * @ORM\ManyToOne(targetEntity="Discapacidad", inversedBy="candidatos")
     * @ORM\JoinColumn(name="discapacidad_id", referencedColumnName="id", nullable=false)
     */
    protected $discapacidad;
    
    /**
     * @ORM\ManyToOne(targetEntity="PeriodoAcademico", inversedBy="candidatos")
     * @ORM\JoinColumn(name="periodo_academico_id", referencedColumnName="id", nullable=false)
     */
    protected $periodoAcademico;

    public function __construct()
    {
    }

    public function __sleep()
    {
        return array('id', 'primer_nombre', 'segundo_nombre', 'primer_apellido', 'segundo_apellido', 'identificacion', 'aspirante_tipo_id', 'aspirante_estatus_id', 'documento_identidad_tipo_id', 'genero_id', 'estado_civil_id', 'fecha_nacimiento', 'telefono', 'telefono_codigo_area_id', 'correo', 'estado_residencia_id', 'etnia_id', 'id_opsu', 'ano_grado', 'trabaja', 'promedio_nota', 'programa_id', 'periodo_asignado', 'aldea_id', 'convenio_id');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set primer_nombre
     *
     * @param string $primerNombre
     * @return Candidato
     */
    public function setPrimerNombre($primerNombre)
    {
        $this->primer_nombre = $primerNombre;

        return $this;
    }

    /**
     * Get primer_nombre
     *
     * @return string 
     */
    public function getPrimerNombre()
    {
        return $this->primer_nombre;
    }

    /**
     * Set segundo_nombre
     *
     * @param string $segundoNombre
     * @return Candidato
     */
    public function setSegundoNombre($segundoNombre)
    {
        $this->segundo_nombre = $segundoNombre;

        return $this;
    }

    /**
     * Get segundo_nombre
     *
     * @return string 
     */
    public function getSegundoNombre()
    {
        return $this->segundo_nombre;
    }

    /**
     * Set primer_apellido
     *
     * @param string $primerApellido
     * @return Candidato
     */
    public function setPrimerApellido($primerApellido)
    {
        $this->primer_apellido = $primerApellido;

        return $this;
    }

    /**
     * Get primer_apellido
     *
     * @return string 
     */
    public function getPrimerApellido()
    {
        return $this->primer_apellido;
    }

    /**
     * Set segundo_apellido
     *
     * @param string $segundoApellido
     * @return Candidato
     */
    public function setSegundoApellido($segundoApellido)
    {
        $this->segundo_apellido = $segundoApellido;

        return $this;
    }

    /**
     * Get segundo_apellido
     *
     * @return string 
     */
    public function getSegundoApellido()
    {
        return $this->segundo_apellido;
    }

    /**
     * Set identificacion
     *
     * @param string $identificacion
     * @return Candidato
     */
    public function setIdentificacion($identificacion)
    {
        $this->identificacion = $identificacion;

        return $this;
    }

    /**
     * Get identificacion
     *
     * @return string 
     */
    public function getIdentificacion()
    {
        return $this->identificacion;
    }

    /**
     * Set fecha_nacimiento
     *
     * @param \DateTime $fechaNacimiento
     * @return Candidato
     */
    public function setFechaNacimiento($fechaNacimiento)
    {
        $this->fecha_nacimiento = $fechaNacimiento;

        return $this;
    }

    /**
     * Get fecha_nacimiento
     *
     * @return \DateTime 
     */
    public function getFechaNacimiento()
    {
        return $this->fecha_nacimiento;
    }

    /**
     * Set telefono
     *
     * @param string $telefono
     * @return Candidato
     */
    public function setTelefono($telefono)
    {
        $this->telefono = $telefono;

        return $this;
    }

    /**
     * Get telefono
     *
     * @return string 
     */
    public function getTelefono()
    {
        return $this->telefono;
    }

    /**
     * Set correo
     *
     * @param string $correo
     * @return Candidato
     */
    public function setCorreo($correo)
    {
        $this->correo = $correo;

        return $this;
    }

    /**
     * Get correo
     *
     * @return string 
     */
    public function getCorreo()
    {
        return $this->correo;
    }

    /**
     * Set id_opsu
     *
     * @param string $idOpsu
     * @return Candidato
     */
    public function setIdOpsu($idOpsu)
    {
        $this->id_opsu = $idOpsu;

        return $this;
    }

    /**
     * Get id_opsu
     *
     * @return string 
     */
    public function getIdOpsu()
    {
        return $this->id_opsu;
    }

    /**
     * Set ano_grado
     *
     * @param \DateTime $anoGrado
     * @return Candidato
     */
    public function setAnoGrado($anoGrado)
    {
        $this->ano_grado = $anoGrado;

        return $this;
    }

    /**
     * Get ano_grado
     *
     * @return \DateTime 
     */
    public function getAnoGrado()
    {
        return $this->ano_grado;
    }

    /**
     * Set trabaja
     *
     * @param boolean $trabaja
     * @return Candidato
     */
    public function setTrabaja($trabaja)
    {
        $this->trabaja = $trabaja;

        return $this;
    }

    /**
     * Get trabaja
     *
     * @return boolean 
     */
    public function getTrabaja()
    {
        return $this->trabaja;
    }

    /**
     * Set promedio_nota
     *
     * @param string $promedioNota
     * @return Candidato
     */
    public function setPromedioNota($promedioNota)
    {
        $this->promedio_nota = $promedioNota;

        return $this;
    }

    /**
     * Get promedio_nota
     *
     * @return string 
     */
    public function getPromedioNota()
    {
        return $this->promedio_nota;
    }

    /**
     * Set aspiranteTipo
     *
     * @param \UBV\SurUbvBundle\Entity\AspiranteTipo $aspiranteTipo
     * @return Candidato
     */
    public function setAspiranteTipo(\UBV\SurUbvBundle\Entity\AspiranteTipo $aspiranteTipo)
    {
        $this->aspiranteTipo = $aspiranteTipo;

        return $this;
    }

    /**
     * Get aspiranteTipo
     *
     * @return \UBV\SurUbvBundle\Entity\AspiranteTipo 
     */
    public function getAspiranteTipo()
    {
        return $this->aspiranteTipo;
    }

    /**
     * Set aspiranteEstatus
     *
     * @param \UBV\SurUbvBundle\Entity\AspiranteEstatus $aspiranteEstatus
     * @return Candidato
     */
    public function setAspiranteEstatus(\UBV\SurUbvBundle\Entity\AspiranteEstatus $aspiranteEstatus)
    {
        $this->aspiranteEstatus = $aspiranteEstatus;

        return $this;
    }

    /**
     * Get aspiranteEstatus
     *
     * @return \UBV\SurUbvBundle\Entity\AspiranteEstatus 
     */
    public function getAspiranteEstatus()
    {
        return $this->aspiranteEstatus;
    }

    /**
     * Set documentoIdentidadTipo
     *
     * @param \UBV\SurUbvBundle\Entity\DocumentoIdentidadTipo $documentoIdentidadTipo
     * @return Candidato
     */
    public function setDocumentoIdentidadTipo(\UBV\SurUbvBundle\Entity\DocumentoIdentidadTipo $documentoIdentidadTipo)
    {
        $this->documentoIdentidadTipo = $documentoIdentidadTipo;

        return $this;
    }

    /**
     * Get documentoIdentidadTipo
     *
     * @return \UBV\SurUbvBundle\Entity\DocumentoIdentidadTipo 
     */
    public function getDocumentoIdentidadTipo()
    {
        return $this->documentoIdentidadTipo;
    }

    /**
     * Set genero
     *
     * @param \UBV\SurUbvBundle\Entity\Genero $genero
     * @return Candidato
     */
    public function setGenero(\UBV\SurUbvBundle\Entity\Genero $genero)
    {
        $this->genero = $genero;

        return $this;
    }

    /**
     * Get genero
     *
     * @return \UBV\SurUbvBundle\Entity\Genero 
     */
    public function getGenero()
    {
        return $this->genero;
    }

    /**
     * Set estadoCivil
     *
     * @param \UBV\SurUbvBundle\Entity\EstadoCivil $estadoCivil
     * @return Candidato
     */
    public function setEstadoCivil(\UBV\SurUbvBundle\Entity\EstadoCivil $estadoCivil)
    {
        $this->estadoCivil = $estadoCivil;

        return $this;
    }

    /**
     * Get estadoCivil
     *
     * @return \UBV\SurUbvBundle\Entity\EstadoCivil 
     */
    public function getEstadoCivil()
    {
        return $this->estadoCivil;
    }

    /**
     * Set telefonoCodigoArea
     *
     * @param \UBV\SurUbvBundle\Entity\TelefonoCodigoArea $telefonoCodigoArea
     * @return Candidato
     */
    public function setTelefonoCodigoArea(\UBV\SurUbvBundle\Entity\TelefonoCodigoArea $telefonoCodigoArea)
    {
        $this->telefonoCodigoArea = $telefonoCodigoArea;

        return $this;
    }

    /**
     * Get telefonoCodigoArea
     *
     * @return \UBV\SurUbvBundle\Entity\TelefonoCodigoArea 
     */
    public function getTelefonoCodigoArea()
    {
        return $this->telefonoCodigoArea;
    }

    /**
     * Set estado
     *
     * @param \UBV\SurUbvBundle\Entity\Estado $estado
     * @return Candidato
     */
    public function setEstado(\UBV\SurUbvBundle\Entity\Estado $estado = null)
    {
        $this->estado = $estado;

        return $this;
    }

    /**
     * Get estado
     *
     * @return \UBV\SurUbvBundle\Entity\Estado 
     */
    public function getEstado()
    {
        return $this->estado;
    }

    /**
     * Set etnia
     *
     * @param \UBV\SurUbvBundle\Entity\Etnia $etnia
     * @return Candidato
     */
    public function setEtnia(\UBV\SurUbvBundle\Entity\Etnia $etnia = null)
    {
        $this->etnia = $etnia;

        return $this;
    }

    /**
     * Get etnia
     *
     * @return \UBV\SurUbvBundle\Entity\Etnia 
     */
    public function getEtnia()
    {
        return $this->etnia;
    }

    /**
     * Set programa
     *
     * @param \UBV\SurUbvBundle\Entity\Programa $programa
     * @return Candidato
     */
    public function setPrograma(\UBV\SurUbvBundle\Entity\Programa $programa)
    {
        $this->programa = $programa;

        return $this;
    }

    /**
     * Get programa
     *
     * @return \UBV\SurUbvBundle\Entity\Programa 
     */
    public function getPrograma()
    {
        return $this->programa;
    }

    /**
     * Set aldea
     *
     * @param \UBV\SurUbvBundle\Entity\Aldea $aldea
     * @return Candidato
     */
    public function setAldea(\UBV\SurUbvBundle\Entity\Aldea $aldea)
    {
        $this->aldea = $aldea;

        return $this;
    }

    /**
     * Get aldea
     *
     * @return \UBV\SurUbvBundle\Entity\Aldea 
     */
    public function getAldea()
    {
        return $this->aldea;
    }

    /**
     * Set convenio
     *
     * @param \UBV\SurUbvBundle\Entity\Convenio $convenio
     * @return Candidato
     */
    public function setConvenio(\UBV\SurUbvBundle\Entity\Convenio $convenio = null)
    {
        $this->convenio = $convenio;

        return $this;
    }

    /**
     * Get convenio
     *
     * @return \UBV\SurUbvBundle\Entity\Convenio 
     */
    public function getConvenio()
    {
        return $this->convenio;
    }

    /**
     * Set correoTipo
     *
     * @param \UBV\SurUbvBundle\Entity\CorreoTipo $correoTipo
     * @return Candidato
     */
    public function setCorreoTipo(\UBV\SurUbvBundle\Entity\CorreoTipo $correoTipo)
    {
        $this->correoTipo = $correoTipo;

        return $this;
    }

    /**
     * Get correoTipo
     *
     * @return \UBV\SurUbvBundle\Entity\CorreoTipo 
     */
    public function getCorreoTipo()
    {
        return $this->correoTipo;
    }

    /**
     * Set discapacidad
     *
     * @param \UBV\SurUbvBundle\Entity\Discapacidad $discapacidad
     * @return Candidato
     */
    public function setDiscapacidad(\UBV\SurUbvBundle\Entity\Discapacidad $discapacidad)
    {
        $this->discapacidad = $discapacidad;

        return $this;
    }

    /**
     * Get discapacidad
     *
     * @return \UBV\SurUbvBundle\Entity\Discapacidad 
     */
    public function getDiscapacidad()
    {
        return $this->discapacidad;
    }

    /**
     * Set periodoAcademico
     *
     * @param \UBV\SurUbvBundle\Entity\PeriodoAcademico $periodoAcademico
     * @return Candidato
     */
    public function setPeriodoAcademico(\UBV\SurUbvBundle\Entity\PeriodoAcademico $periodoAcademico)
    {
        $this->periodoAcademico = $periodoAcademico;

        return $this;
    }

    /**
     * Get periodoAcademico
     *
     * @return \UBV\SurUbvBundle\Entity\PeriodoAcademico 
     */
    public function getPeriodoAcademico()
    {
        return $this->periodoAcademico;
    }
}
