<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * UBV\SurUbvBundle\Entity\CargaAcademica
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\CargaAcademicaRepository")
 * @ORM\Table(name="carga_academica", indexes={@ORM\Index(name="fk_carga_academica_oferta_academica_detalle1_idx", columns={"oferta_academica_detalle_id"}), @ORM\Index(name="fk_carga_academica_seccion1_idx", columns={"seccion_id"}), @ORM\Index(name="fk_carga_academica_ambiente_espacio1_idx", columns={"ambiente_espacio_id"}), @ORM\Index(name="fk_carga_academica_docente1_idx", columns={"docente_id"})}, uniqueConstraints={@ORM\UniqueConstraint(name="id_carga_academica_UNIQUE", columns={"id"})})
 */
class CargaAcademica
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="carga_academica_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\OneToMany(targetEntity="Horario", mappedBy="cargaAcademica")
     * @ORM\JoinColumn(name="id", referencedColumnName="carga_academica_id", nullable=false)
     */
    protected $horarios;

    /**
     * @ORM\OneToMany(targetEntity="InscripcionDetalle", mappedBy="cargaAcademica")
     * @ORM\JoinColumn(name="id", referencedColumnName="carga_academica_id", nullable=false)
     */
    protected $inscripcionDetalles;

    /**
     * @ORM\ManyToOne(targetEntity="OfertaAcademicaDetalle", inversedBy="cargaAcademicas")
     * @ORM\JoinColumn(name="oferta_academica_detalle_id", referencedColumnName="id", nullable=false)
     */
    protected $ofertaAcademicaDetalle;

    /**
     * @ORM\ManyToOne(targetEntity="Seccion", inversedBy="cargaAcademicas")
     * @ORM\JoinColumn(name="seccion_id", referencedColumnName="id", nullable=false)
     */
    protected $seccion;

    /**
     * @ORM\ManyToOne(targetEntity="AmbienteEspacio", inversedBy="cargaAcademicas")
     * @ORM\JoinColumn(name="ambiente_espacio_id", referencedColumnName="id", nullable=false)
     */
    protected $ambienteEspacio;

    /**
     * @ORM\ManyToOne(targetEntity="Docente", inversedBy="cargaAcademicas")
     * @ORM\JoinColumn(name="docente_id", referencedColumnName="id", nullable=false)
     */
    protected $docente;

    public function __construct()
    {
        $this->horarios = new ArrayCollection();
        $this->inscripcionDetalles = new ArrayCollection();
    }

    public function __sleep()
    {
        return array('id', 'oferta_academica_detalle_id', 'seccion_id', 'ambiente_espacio_id', 'docente_id');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Add horarios
     *
     * @param \UBV\SurUbvBundle\Entity\Horario $horarios
     * @return CargaAcademica
     */
    public function addHorario(\UBV\SurUbvBundle\Entity\Horario $horarios)
    {
        $this->horarios[] = $horarios;

        return $this;
    }

    /**
     * Remove horarios
     *
     * @param \UBV\SurUbvBundle\Entity\Horario $horarios
     */
    public function removeHorario(\UBV\SurUbvBundle\Entity\Horario $horarios)
    {
        $this->horarios->removeElement($horarios);
    }

    /**
     * Get horarios
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getHorarios()
    {
        return $this->horarios;
    }

    /**
     * Add inscripcionDetalles
     *
     * @param \UBV\SurUbvBundle\Entity\InscripcionDetalle $inscripcionDetalles
     * @return CargaAcademica
     */
    public function addInscripcionDetalle(\UBV\SurUbvBundle\Entity\InscripcionDetalle $inscripcionDetalles)
    {
        $this->inscripcionDetalles[] = $inscripcionDetalles;

        return $this;
    }

    /**
     * Remove inscripcionDetalles
     *
     * @param \UBV\SurUbvBundle\Entity\InscripcionDetalle $inscripcionDetalles
     */
    public function removeInscripcionDetalle(\UBV\SurUbvBundle\Entity\InscripcionDetalle $inscripcionDetalles)
    {
        $this->inscripcionDetalles->removeElement($inscripcionDetalles);
    }

    /**
     * Get inscripcionDetalles
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getInscripcionDetalles()
    {
        return $this->inscripcionDetalles;
    }

    /**
     * Set ofertaAcademicaDetalle
     *
     * @param \UBV\SurUbvBundle\Entity\OfertaAcademicaDetalle $ofertaAcademicaDetalle
     * @return CargaAcademica
     */
    public function setOfertaAcademicaDetalle(\UBV\SurUbvBundle\Entity\OfertaAcademicaDetalle $ofertaAcademicaDetalle)
    {
        $this->ofertaAcademicaDetalle = $ofertaAcademicaDetalle;

        return $this;
    }

    /**
     * Get ofertaAcademicaDetalle
     *
     * @return \UBV\SurUbvBundle\Entity\OfertaAcademicaDetalle 
     */
    public function getOfertaAcademicaDetalle()
    {
        return $this->ofertaAcademicaDetalle;
    }

    /**
     * Set seccion
     *
     * @param \UBV\SurUbvBundle\Entity\Seccion $seccion
     * @return CargaAcademica
     */
    public function setSeccion(\UBV\SurUbvBundle\Entity\Seccion $seccion)
    {
        $this->seccion = $seccion;

        return $this;
    }

    /**
     * Get seccion
     *
     * @return \UBV\SurUbvBundle\Entity\Seccion 
     */
    public function getSeccion()
    {
        return $this->seccion;
    }

    /**
     * Set ambienteEspacio
     *
     * @param \UBV\SurUbvBundle\Entity\AmbienteEspacio $ambienteEspacio
     * @return CargaAcademica
     */
    public function setAmbienteEspacio(\UBV\SurUbvBundle\Entity\AmbienteEspacio $ambienteEspacio)
    {
        $this->ambienteEspacio = $ambienteEspacio;

        return $this;
    }

    /**
     * Get ambienteEspacio
     *
     * @return \UBV\SurUbvBundle\Entity\AmbienteEspacio 
     */
    public function getAmbienteEspacio()
    {
        return $this->ambienteEspacio;
    }

    /**
     * Set docente
     *
     * @param \UBV\SurUbvBundle\Entity\Docente $docente
     * @return CargaAcademica
     */
    public function setDocente(\UBV\SurUbvBundle\Entity\Docente $docente)
    {
        $this->docente = $docente;

        return $this;
    }

    /**
     * Get docente
     *
     * @return \UBV\SurUbvBundle\Entity\Docente 
     */
    public function getDocente()
    {
        return $this->docente;
    }
}
