<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * UBV\SurUbvBundle\Entity\Ciudad
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\CiudadRepository")
 * @ORM\Table(name="ciudad", indexes={@ORM\Index(name="fk_ciudad_estado1_idx", columns={"estado_id"})}, uniqueConstraints={@ORM\UniqueConstraint(name="id_ciudad_UNIQUE", columns={"id"})})
 */
class Ciudad
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="ciudad_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="string", length=70, nullable=true)
     */
    protected $descripcion;

    /**
     * @ORM\OneToMany(targetEntity="DomicilioPersona", mappedBy="ciudad")
     * @ORM\JoinColumn(name="id", referencedColumnName="ciudad_id", nullable=false)
     */
    protected $domicilioPersonas;

    /**
     * @ORM\ManyToOne(targetEntity="Estado", inversedBy="ciudads")
     * @ORM\JoinColumn(name="estado_id", referencedColumnName="id", nullable=false)
     */
    protected $estado;

    public function __construct()
    {
        $this->domicilioPersonas = new ArrayCollection();
    }

    public function __sleep()
    {
        return array('id', 'descripcion', 'estado_id');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set descripcion
     *
     * @param string $descripcion
     * @return Ciudad
     */
    public function setDescripcion($descripcion)
    {
        $this->descripcion = $descripcion;

        return $this;
    }

    /**
     * Get descripcion
     *
     * @return string 
     */
    public function getDescripcion()
    {
        return $this->descripcion;
    }

    /**
     * Add domicilioPersonas
     *
     * @param \UBV\SurUbvBundle\Entity\DomicilioPersona $domicilioPersonas
     * @return Ciudad
     */
    public function addDomicilioPersona(\UBV\SurUbvBundle\Entity\DomicilioPersona $domicilioPersonas)
    {
        $this->domicilioPersonas[] = $domicilioPersonas;

        return $this;
    }

    /**
     * Remove domicilioPersonas
     *
     * @param \UBV\SurUbvBundle\Entity\DomicilioPersona $domicilioPersonas
     */
    public function removeDomicilioPersona(\UBV\SurUbvBundle\Entity\DomicilioPersona $domicilioPersonas)
    {
        $this->domicilioPersonas->removeElement($domicilioPersonas);
    }

    /**
     * Get domicilioPersonas
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getDomicilioPersonas()
    {
        return $this->domicilioPersonas;
    }

    /**
     * Set estado
     *
     * @param \UBV\SurUbvBundle\Entity\Estado $estado
     * @return Ciudad
     */
    public function setEstado(\UBV\SurUbvBundle\Entity\Estado $estado)
    {
        $this->estado = $estado;

        return $this;
    }

    /**
     * Get estado
     *
     * @return \UBV\SurUbvBundle\Entity\Estado 
     */
    public function getEstado()
    {
        return $this->estado;
    }
}
