<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * UBV\SurUbvBundle\Entity\ComiteTipo
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\ComiteTipoRepository")
 * @ORM\Table(name="comite_tipo", uniqueConstraints={@ORM\UniqueConstraint(name="id_comite_tipo_UNIQUE", columns={"id"})})
 */
class ComiteTipo
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="comite_tipo_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="string", length=45)
     */
    protected $descripcion;

    /**
     * @ORM\OneToMany(targetEntity="ComitepfaIntegrante", mappedBy="comiteTipo")
     * @ORM\JoinColumn(name="id", referencedColumnName="comite_tipo_id", nullable=false)
     */
    protected $comitepfaIntegrantes;

    public function __construct()
    {
        $this->comitepfaIntegrantes = new ArrayCollection();
    }

    public function __sleep()
    {
        return array('id', 'descripcion');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set descripcion
     *
     * @param string $descripcion
     * @return ComiteTipo
     */
    public function setDescripcion($descripcion)
    {
        $this->descripcion = $descripcion;

        return $this;
    }

    /**
     * Get descripcion
     *
     * @return string 
     */
    public function getDescripcion()
    {
        return $this->descripcion;
    }

    /**
     * Add comitepfaIntegrantes
     *
     * @param \UBV\SurUbvBundle\Entity\ComitepfaIntegrante $comitepfaIntegrantes
     * @return ComiteTipo
     */
    public function addComitepfaIntegrante(\UBV\SurUbvBundle\Entity\ComitepfaIntegrante $comitepfaIntegrantes)
    {
        $this->comitepfaIntegrantes[] = $comitepfaIntegrantes;

        return $this;
    }

    /**
     * Remove comitepfaIntegrantes
     *
     * @param \UBV\SurUbvBundle\Entity\ComitepfaIntegrante $comitepfaIntegrantes
     */
    public function removeComitepfaIntegrante(\UBV\SurUbvBundle\Entity\ComitepfaIntegrante $comitepfaIntegrantes)
    {
        $this->comitepfaIntegrantes->removeElement($comitepfaIntegrantes);
    }

    /**
     * Get comitepfaIntegrantes
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getComitepfaIntegrantes()
    {
        return $this->comitepfaIntegrantes;
    }
}
