<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * UBV\SurUbvBundle\Entity\ComitepfaIntegrante
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\ComitepfaIntegranteRepository")
 * @ORM\Table(name="comitepfa_integrante", indexes={@ORM\Index(name="fk_comitepfa_integrante_programa1_idx", columns={"programa_id"}), @ORM\Index(name="fk_comitepfa_integrante_docente1_idx", columns={"docente_id"}), @ORM\Index(name="fk_comitepfa_integrante_comite_tipo1_idx", columns={"comite_tipo_id"})}, uniqueConstraints={@ORM\UniqueConstraint(name="id_comitepfa_integrante_UNIQUE", columns={"id"})})
 */
class ComitepfaIntegrante
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="comitepfa_integrante_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="date")
     */
    protected $fecha_inicio;

    /**
     * @ORM\Column(type="date")
     */
    protected $fecha_fin;

    /**
     * @ORM\Column(type="boolean")
     */
    protected $estatus;

    /**
     * @ORM\ManyToOne(targetEntity="Programa", inversedBy="comitepfaIntegrantes")
     * @ORM\JoinColumn(name="programa_id", referencedColumnName="id", nullable=false)
     */
    protected $programa;

    /**
     * @ORM\ManyToOne(targetEntity="Docente", inversedBy="comitepfaIntegrantes")
     * @ORM\JoinColumn(name="docente_id", referencedColumnName="id", nullable=false)
     */
    protected $docente;

    /**
     * @ORM\ManyToOne(targetEntity="ComiteTipo", inversedBy="comitepfaIntegrantes")
     * @ORM\JoinColumn(name="comite_tipo_id", referencedColumnName="id", nullable=false)
     */
    protected $comiteTipo;

    public function __construct()
    {
    }

    public function __sleep()
    {
        return array('id', 'fecha_inicio', 'fecha_fin', 'estatus', 'programa_id', 'docente_id', 'comite_tipo_id');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set fecha_inicio
     *
     * @param \DateTime $fechaInicio
     * @return ComitepfaIntegrante
     */
    public function setFechaInicio($fechaInicio)
    {
        $this->fecha_inicio = $fechaInicio;

        return $this;
    }

    /**
     * Get fecha_inicio
     *
     * @return \DateTime 
     */
    public function getFechaInicio()
    {
        return $this->fecha_inicio;
    }

    /**
     * Set fecha_fin
     *
     * @param \DateTime $fechaFin
     * @return ComitepfaIntegrante
     */
    public function setFechaFin($fechaFin)
    {
        $this->fecha_fin = $fechaFin;

        return $this;
    }

    /**
     * Get fecha_fin
     *
     * @return \DateTime 
     */
    public function getFechaFin()
    {
        return $this->fecha_fin;
    }

    /**
     * Set estatus
     *
     * @param boolean $estatus
     * @return ComitepfaIntegrante
     */
    public function setEstatus($estatus)
    {
        $this->estatus = $estatus;

        return $this;
    }

    /**
     * Get estatus
     *
     * @return boolean 
     */
    public function getEstatus()
    {
        return $this->estatus;
    }

    /**
     * Set programa
     *
     * @param \UBV\SurUbvBundle\Entity\Programa $programa
     * @return ComitepfaIntegrante
     */
    public function setPrograma(\UBV\SurUbvBundle\Entity\Programa $programa)
    {
        $this->programa = $programa;

        return $this;
    }

    /**
     * Get programa
     *
     * @return \UBV\SurUbvBundle\Entity\Programa 
     */
    public function getPrograma()
    {
        return $this->programa;
    }

    /**
     * Set docente
     *
     * @param \UBV\SurUbvBundle\Entity\Docente $docente
     * @return ComitepfaIntegrante
     */
    public function setDocente(\UBV\SurUbvBundle\Entity\Docente $docente)
    {
        $this->docente = $docente;

        return $this;
    }

    /**
     * Get docente
     *
     * @return \UBV\SurUbvBundle\Entity\Docente 
     */
    public function getDocente()
    {
        return $this->docente;
    }

    /**
     * Set comiteTipo
     *
     * @param \UBV\SurUbvBundle\Entity\ComiteTipo $comiteTipo
     * @return ComitepfaIntegrante
     */
    public function setComiteTipo(\UBV\SurUbvBundle\Entity\ComiteTipo $comiteTipo)
    {
        $this->comiteTipo = $comiteTipo;

        return $this;
    }

    /**
     * Get comiteTipo
     *
     * @return \UBV\SurUbvBundle\Entity\ComiteTipo 
     */
    public function getComiteTipo()
    {
        return $this->comiteTipo;
    }
}
