<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * UBV\SurUbvBundle\Entity\CuentaBancaria
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\CuentaBancariaRepository")
 * @ORM\Table(name="cuenta_bancaria", indexes={@ORM\Index(name="fk_cuenta_bancaria_tipo_cuenta_bancaria1_idx", columns={"tipo_cuenta_bancaria_id"}), @ORM\Index(name="fk_cuenta_bancaria_banco1_idx", columns={"banco_id"}), @ORM\Index(name="fk_cuenta_bancaria_unidad_administrativa1_idx", columns={"unidad_administrativa_id"})}, uniqueConstraints={@ORM\UniqueConstraint(name="id_cuenta_bancaria_UNIQUE", columns={"id"})})
 */
class CuentaBancaria
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="cuenta_bancaria_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="string", length=45)
     */
    protected $descripcion;

    /**
     * @ORM\OneToMany(targetEntity="Deposito", mappedBy="cuentaBancaria")
     * @ORM\JoinColumn(name="id", referencedColumnName="cuenta_bancaria_id", nullable=false)
     */
    protected $depositos;

    /**
     * @ORM\ManyToOne(targetEntity="CuentaBancariaTipo", inversedBy="cuentaBancarias")
     * @ORM\JoinColumn(name="tipo_cuenta_bancaria_id", referencedColumnName="id", nullable=false)
     */
    protected $cuentaBancariaTipo;

    /**
     * @ORM\ManyToOne(targetEntity="Banco", inversedBy="cuentaBancarias")
     * @ORM\JoinColumn(name="banco_id", referencedColumnName="id", nullable=false)
     */
    protected $banco;

    /**
     * @ORM\ManyToOne(targetEntity="UnidadAdministrativa", inversedBy="cuentaBancarias")
     * @ORM\JoinColumn(name="unidad_administrativa_id", referencedColumnName="id", nullable=false)
     */
    protected $unidadAdministrativa;

    public function __construct()
    {
        $this->depositos = new ArrayCollection();
    }

    public function __sleep()
    {
        return array('id', 'descripcion', 'tipo_cuenta_bancaria_id', 'banco_id', 'unidad_administrativa_id');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set descripcion
     *
     * @param string $descripcion
     * @return CuentaBancaria
     */
    public function setDescripcion($descripcion)
    {
        $this->descripcion = $descripcion;

        return $this;
    }

    /**
     * Get descripcion
     *
     * @return string 
     */
    public function getDescripcion()
    {
        return $this->descripcion;
    }

    /**
     * Add depositos
     *
     * @param \UBV\SurUbvBundle\Entity\Deposito $depositos
     * @return CuentaBancaria
     */
    public function addDeposito(\UBV\SurUbvBundle\Entity\Deposito $depositos)
    {
        $this->depositos[] = $depositos;

        return $this;
    }

    /**
     * Remove depositos
     *
     * @param \UBV\SurUbvBundle\Entity\Deposito $depositos
     */
    public function removeDeposito(\UBV\SurUbvBundle\Entity\Deposito $depositos)
    {
        $this->depositos->removeElement($depositos);
    }

    /**
     * Get depositos
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getDepositos()
    {
        return $this->depositos;
    }

    /**
     * Set cuentaBancariaTipo
     *
     * @param \UBV\SurUbvBundle\Entity\CuentaBancariaTipo $cuentaBancariaTipo
     * @return CuentaBancaria
     */
    public function setCuentaBancariaTipo(\UBV\SurUbvBundle\Entity\CuentaBancariaTipo $cuentaBancariaTipo)
    {
        $this->cuentaBancariaTipo = $cuentaBancariaTipo;

        return $this;
    }

    /**
     * Get cuentaBancariaTipo
     *
     * @return \UBV\SurUbvBundle\Entity\CuentaBancariaTipo 
     */
    public function getCuentaBancariaTipo()
    {
        return $this->cuentaBancariaTipo;
    }

    /**
     * Set banco
     *
     * @param \UBV\SurUbvBundle\Entity\Banco $banco
     * @return CuentaBancaria
     */
    public function setBanco(\UBV\SurUbvBundle\Entity\Banco $banco)
    {
        $this->banco = $banco;

        return $this;
    }

    /**
     * Get banco
     *
     * @return \UBV\SurUbvBundle\Entity\Banco 
     */
    public function getBanco()
    {
        return $this->banco;
    }

    /**
     * Set unidadAdministrativa
     *
     * @param \UBV\SurUbvBundle\Entity\UnidadAdministrativa $unidadAdministrativa
     * @return CuentaBancaria
     */
    public function setUnidadAdministrativa(\UBV\SurUbvBundle\Entity\UnidadAdministrativa $unidadAdministrativa)
    {
        $this->unidadAdministrativa = $unidadAdministrativa;

        return $this;
    }

    /**
     * Get unidadAdministrativa
     *
     * @return \UBV\SurUbvBundle\Entity\UnidadAdministrativa 
     */
    public function getUnidadAdministrativa()
    {
        return $this->unidadAdministrativa;
    }
    
    public function __toString() {
      return $this->getDescripcion();
    }
}
