<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * UBV\SurUbvBundle\Entity\DepositoDetalle
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\DepositoDetalleRepository")
 * @ORM\Table(name="deposito_detalle", indexes={@ORM\Index(name="fk_deposito_detalle_banco1_idx", columns={"banco_id"}), @ORM\Index(name="fk_deposito_detalle_deposito1_idx", columns={"deposito_id"})})
 */
class DepositoDetalle
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="AUTO")
     * @ORM\SequenceGenerator(sequenceName="deposito_detalle_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="string", length=45)
     */
    protected $cta_bancaria_origen;

    /**
     * @ORM\ManyToOne(targetEntity="Banco", inversedBy="depositoDetalles")
     * @ORM\JoinColumn(name="banco_id", referencedColumnName="id", nullable=false)
     */
    protected $banco;

    /**
     * @ORM\ManyToOne(targetEntity="Deposito", inversedBy="depositoDetalles")
     * @ORM\JoinColumn(name="deposito_id", referencedColumnName="id", nullable=false)
     */
    protected $deposito;

    public function __construct()
    {
    }

    public function __sleep()
    {
        return array('id', 'cta_bancaria_origen', 'banco_id', 'deposito_id');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set cta_bancaria_origen
     *
     * @param string $ctaBancariaOrigen
     * @return DepositoDetalle
     */
    public function setCtaBancariaOrigen($ctaBancariaOrigen)
    {
        $this->cta_bancaria_origen = $ctaBancariaOrigen;

        return $this;
    }

    /**
     * Get cta_bancaria_origen
     *
     * @return string 
     */
    public function getCtaBancariaOrigen()
    {
        return $this->cta_bancaria_origen;
    }

    /**
     * Set banco
     *
     * @param \UBV\SurUbvBundle\Entity\Banco $banco
     * @return DepositoDetalle
     */
    public function setBanco(\UBV\SurUbvBundle\Entity\Banco $banco)
    {
        $this->banco = $banco;

        return $this;
    }

    /**
     * Get banco
     *
     * @return \UBV\SurUbvBundle\Entity\Banco 
     */
    public function getBanco()
    {
        return $this->banco;
    }

    /**
     * Set deposito
     *
     * @param \UBV\SurUbvBundle\Entity\Deposito $deposito
     * @return DepositoDetalle
     */
    public function setDeposito(\UBV\SurUbvBundle\Entity\Deposito $deposito)
    {
        $this->deposito = $deposito;

        return $this;
    }

    /**
     * Get deposito
     *
     * @return \UBV\SurUbvBundle\Entity\Deposito 
     */
    public function getDeposito()
    {
        return $this->deposito;
    }
}
