<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * UBV\SurUbvBundle\Entity\DepositoTipo
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\DepositoTipoRepository")
 * @ORM\Table(name="deposito_tipo")
 */
class DepositoTipo
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="deposito_tipo_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="string", length=45)
     */
    protected $descripcion;

    /**
     * @ORM\Column(type="boolean")
     */
    protected $estatus;

    /**
     * @ORM\OneToMany(targetEntity="Deposito", mappedBy="depositoTipo")
     * @ORM\JoinColumn(name="id", referencedColumnName="deposito_tipo_id", nullable=false)
     */
    protected $depositos;

    public function __construct()
    {
        $this->depositos = new ArrayCollection();
    }

    public function __sleep()
    {
        return array('id', 'descripcion', 'estatus');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set descripcion
     *
     * @param string $descripcion
     * @return DepositoTipo
     */
    public function setDescripcion($descripcion)
    {
        $this->descripcion = $descripcion;

        return $this;
    }

    /**
     * Get descripcion
     *
     * @return string 
     */
    public function getDescripcion()
    {
        return $this->descripcion;
    }

    /**
     * Set estatus
     *
     * @param boolean $estatus
     * @return DepositoTipo
     */
    public function setEstatus($estatus)
    {
        $this->estatus = $estatus;

        return $this;
    }

    /**
     * Get estatus
     *
     * @return boolean 
     */
    public function getEstatus()
    {
        return $this->estatus;
    }

    /**
     * Add depositos
     *
     * @param \UBV\SurUbvBundle\Entity\Deposito $depositos
     * @return DepositoTipo
     */
    public function addDeposito(\UBV\SurUbvBundle\Entity\Deposito $depositos)
    {
        $this->depositos[] = $depositos;

        return $this;
    }

    /**
     * Remove depositos
     *
     * @param \UBV\SurUbvBundle\Entity\Deposito $depositos
     */
    public function removeDeposito(\UBV\SurUbvBundle\Entity\Deposito $depositos)
    {
        $this->depositos->removeElement($depositos);
    }

    /**
     * Get depositos
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getDepositos()
    {
        return $this->depositos;
    }
    
    public function __toString() {
      return $this->getDescripcion();
    }
}
