<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * UBV\SurUbvBundle\Entity\DiaSemana
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\DiaSemanaRepository")
 * @ORM\Table(name="dia_semana", uniqueConstraints={@ORM\UniqueConstraint(name="id_dia_semana_UNIQUE", columns={"id"})})
 */
class DiaSemana
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="dia_semana_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="string", length=10)
     */
    protected $descripcion;

    /**
     * @ORM\OneToMany(targetEntity="Horario", mappedBy="diaSemana")
     * @ORM\JoinColumn(name="id", referencedColumnName="dia_semana_id", nullable=false)
     */
    protected $horarios;

    public function __construct()
    {
        $this->horarios = new ArrayCollection();
    }

    public function __sleep()
    {
        return array('id', 'descripcion');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set descripcion
     *
     * @param string $descripcion
     * @return DiaSemana
     */
    public function setDescripcion($descripcion)
    {
        $this->descripcion = $descripcion;

        return $this;
    }

    /**
     * Get descripcion
     *
     * @return string 
     */
    public function getDescripcion()
    {
        return $this->descripcion;
    }

    /**
     * Add horarios
     *
     * @param \UBV\SurUbvBundle\Entity\Horario $horarios
     * @return DiaSemana
     */
    public function addHorario(\UBV\SurUbvBundle\Entity\Horario $horarios)
    {
        $this->horarios[] = $horarios;

        return $this;
    }

    /**
     * Remove horarios
     *
     * @param \UBV\SurUbvBundle\Entity\Horario $horarios
     */
    public function removeHorario(\UBV\SurUbvBundle\Entity\Horario $horarios)
    {
        $this->horarios->removeElement($horarios);
    }

    /**
     * Get horarios
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getHorarios()
    {
        return $this->horarios;
    }
}
