<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * UBV\SurUbvBundle\Entity\Discapacidad
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\DiscapacidadRepository")
 * @ORM\Table(name="discapacidad", uniqueConstraints={@ORM\UniqueConstraint(name="id_discapacidad_UNIQUE", columns={"id"})})
 */
class Discapacidad
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="discapacidad_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="string", length=60)
     */
    protected $descripcion;

    /**
     * @ORM\OneToMany(targetEntity="PersonaDiscapacidad", mappedBy="discapacidad")
     * @ORM\JoinColumn(name="id", referencedColumnName="discapacidad_id", nullable=false)
     */
    protected $personaDiscapacidads;
    
    /**
     * @ORM\OneToMany(targetEntity="Candidato", mappedBy="discapacidad")
     * @ORM\JoinColumn(name="id", referencedColumnName="discapacidad_id", nullable=false)
     */
    protected $candidatos;

    public function __construct()
    {
        $this->personaDiscapacidads = new ArrayCollection();
        $this->candidatos = new ArrayCollection();
    }

    public function __sleep()
    {
        return array('id', 'descripcion');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set descripcion
     *
     * @param string $descripcion
     * @return Discapacidad
     */
    public function setDescripcion($descripcion)
    {
        $this->descripcion = $descripcion;

        return $this;
    }

    /**
     * Get descripcion
     *
     * @return string 
     */
    public function getDescripcion()
    {
        return $this->descripcion;
    }

    /**
     * Add personaDiscapacidads
     *
     * @param \UBV\SurUbvBundle\Entity\PersonaDiscapacidad $personaDiscapacidads
     * @return Discapacidad
     */
    public function addPersonaDiscapacidad(\UBV\SurUbvBundle\Entity\PersonaDiscapacidad $personaDiscapacidads)
    {
        $this->personaDiscapacidads[] = $personaDiscapacidads;

        return $this;
    }

    /**
     * Remove personaDiscapacidads
     *
     * @param \UBV\SurUbvBundle\Entity\PersonaDiscapacidad $personaDiscapacidads
     */
    public function removePersonaDiscapacidad(\UBV\SurUbvBundle\Entity\PersonaDiscapacidad $personaDiscapacidads)
    {
        $this->personaDiscapacidads->removeElement($personaDiscapacidads);
    }

    /**
     * Get personaDiscapacidads
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getPersonaDiscapacidads()
    {
        return $this->personaDiscapacidads;
    }

    /**
     * Add candidatos
     *
     * @param \UBV\SurUbvBundle\Entity\Candidato $candidatos
     * @return Discapacidad
     */
    public function addCandidato(\UBV\SurUbvBundle\Entity\Candidato $candidatos)
    {
        $this->candidatos[] = $candidatos;

        return $this;
    }

    /**
     * Remove candidatos
     *
     * @param \UBV\SurUbvBundle\Entity\Candidato $candidatos
     */
    public function removeCandidato(\UBV\SurUbvBundle\Entity\Candidato $candidatos)
    {
        $this->candidatos->removeElement($candidatos);
    }

    /**
     * Get candidatos
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getCandidatos()
    {
        return $this->candidatos;
    }
}
