<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * UBV\SurUbvBundle\Entity\Docente
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\DocenteRepository")
 * @ORM\Table(name="docente", indexes={@ORM\Index(name="fk_docente_programa1_idx", columns={"programa_id"}), @ORM\Index(name="fk_docente_centro_estudio1_idx", columns={"centro_estudio_id"}), @ORM\Index(name="fk_docente_persona1_idx", columns={"persona_id"}), @ORM\Index(name="fk_docente_eje_regional1_idx", columns={"eje_regional_id"}), @ORM\Index(name="fk_docente_dedicacion1_idx", columns={"dedicacion_id"}), @ORM\Index(name="fk_docente_docente_estatus1_idx", columns={"docente_estatus_id"})}, uniqueConstraints={@ORM\UniqueConstraint(name="id_docente_UNIQUE", columns={"id"})})
 */
class Docente
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="docente_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\OneToMany(targetEntity="CargaAcademica", mappedBy="docente")
     * @ORM\JoinColumn(name="id", referencedColumnName="docente_id", nullable=false)
     */
    protected $cargaAcademicas;

    /**
     * @ORM\OneToMany(targetEntity="ComitepfaIntegrante", mappedBy="docente")
     * @ORM\JoinColumn(name="id", referencedColumnName="docente_id", nullable=false)
     */
    protected $comitepfaIntegrantes;

    /**
     * @ORM\OneToMany(targetEntity="DocenteAldea", mappedBy="docente")
     * @ORM\JoinColumn(name="id", referencedColumnName="docente_id", nullable=false)
     */
    protected $docenteAldeas;

    /**
     * @ORM\ManyToOne(targetEntity="Programa", inversedBy="docentes")
     * @ORM\JoinColumn(name="programa_id", referencedColumnName="id", nullable=false)
     */
    protected $programa;

    /**
     * @ORM\ManyToOne(targetEntity="CentroEstudio", inversedBy="docentes")
     * @ORM\JoinColumn(name="centro_estudio_id", referencedColumnName="id", nullable=false)
     */
    protected $centroEstudio;

    /**
     * @ORM\OneToOne(targetEntity="Persona", inversedBy="docente")
     * @ORM\JoinColumn(name="persona_id", referencedColumnName="id", nullable=false)
     */
    protected $persona;

    /**
     * @ORM\OneToOne(targetEntity="EjeRegional", inversedBy="docente")
     * @ORM\JoinColumn(name="eje_regional_id", referencedColumnName="id", nullable=false)
     */
    protected $ejeRegional;

    /**
     * @ORM\ManyToOne(targetEntity="DocenteDedicacion", inversedBy="docentes")
     * @ORM\JoinColumn(name="dedicacion_id", referencedColumnName="id", nullable=false)
     */
    protected $docenteDedicacion;

    /**
     * @ORM\ManyToOne(targetEntity="DocenteEstatus", inversedBy="docentes")
     * @ORM\JoinColumn(name="docente_estatus_id", referencedColumnName="id", nullable=false)
     */
    protected $docenteEstatus;

    public function __construct()
    {
        $this->cargaAcademicas = new ArrayCollection();
        $this->comitepfaIntegrantes = new ArrayCollection();
        $this->docenteAldeas = new ArrayCollection();
    }

    public function __sleep()
    {
        return array('id', 'programa_id', 'centro_estudio_id', 'persona_id', 'eje_regional_id', 'dedicacion_id', 'docente_estatus_id');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Add cargaAcademicas
     *
     * @param \UBV\SurUbvBundle\Entity\CargaAcademica $cargaAcademicas
     * @return Docente
     */
    public function addCargaAcademica(\UBV\SurUbvBundle\Entity\CargaAcademica $cargaAcademicas)
    {
        $this->cargaAcademicas[] = $cargaAcademicas;

        return $this;
    }

    /**
     * Remove cargaAcademicas
     *
     * @param \UBV\SurUbvBundle\Entity\CargaAcademica $cargaAcademicas
     */
    public function removeCargaAcademica(\UBV\SurUbvBundle\Entity\CargaAcademica $cargaAcademicas)
    {
        $this->cargaAcademicas->removeElement($cargaAcademicas);
    }

    /**
     * Get cargaAcademicas
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getCargaAcademicas()
    {
        return $this->cargaAcademicas;
    }

    /**
     * Add comitepfaIntegrantes
     *
     * @param \UBV\SurUbvBundle\Entity\ComitepfaIntegrante $comitepfaIntegrantes
     * @return Docente
     */
    public function addComitepfaIntegrante(\UBV\SurUbvBundle\Entity\ComitepfaIntegrante $comitepfaIntegrantes)
    {
        $this->comitepfaIntegrantes[] = $comitepfaIntegrantes;

        return $this;
    }

    /**
     * Remove comitepfaIntegrantes
     *
     * @param \UBV\SurUbvBundle\Entity\ComitepfaIntegrante $comitepfaIntegrantes
     */
    public function removeComitepfaIntegrante(\UBV\SurUbvBundle\Entity\ComitepfaIntegrante $comitepfaIntegrantes)
    {
        $this->comitepfaIntegrantes->removeElement($comitepfaIntegrantes);
    }

    /**
     * Get comitepfaIntegrantes
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getComitepfaIntegrantes()
    {
        return $this->comitepfaIntegrantes;
    }

    /**
     * Add docenteAldeas
     *
     * @param \UBV\SurUbvBundle\Entity\DocenteAldea $docenteAldeas
     * @return Docente
     */
    public function addDocenteAldea(\UBV\SurUbvBundle\Entity\DocenteAldea $docenteAldeas)
    {
        $this->docenteAldeas[] = $docenteAldeas;

        return $this;
    }

    /**
     * Remove docenteAldeas
     *
     * @param \UBV\SurUbvBundle\Entity\DocenteAldea $docenteAldeas
     */
    public function removeDocenteAldea(\UBV\SurUbvBundle\Entity\DocenteAldea $docenteAldeas)
    {
        $this->docenteAldeas->removeElement($docenteAldeas);
    }

    /**
     * Get docenteAldeas
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getDocenteAldeas()
    {
        return $this->docenteAldeas;
    }

    /**
     * Set programa
     *
     * @param \UBV\SurUbvBundle\Entity\Programa $programa
     * @return Docente
     */
    public function setPrograma(\UBV\SurUbvBundle\Entity\Programa $programa)
    {
        $this->programa = $programa;

        return $this;
    }

    /**
     * Get programa
     *
     * @return \UBV\SurUbvBundle\Entity\Programa 
     */
    public function getPrograma()
    {
        return $this->programa;
    }

    /**
     * Set centroEstudio
     *
     * @param \UBV\SurUbvBundle\Entity\CentroEstudio $centroEstudio
     * @return Docente
     */
    public function setCentroEstudio(\UBV\SurUbvBundle\Entity\CentroEstudio $centroEstudio)
    {
        $this->centroEstudio = $centroEstudio;

        return $this;
    }

    /**
     * Get centroEstudio
     *
     * @return \UBV\SurUbvBundle\Entity\CentroEstudio 
     */
    public function getCentroEstudio()
    {
        return $this->centroEstudio;
    }

    /**
     * Set persona
     *
     * @param \UBV\SurUbvBundle\Entity\Persona $persona
     * @return Docente
     */
    public function setPersona(\UBV\SurUbvBundle\Entity\Persona $persona)
    {
        $this->persona = $persona;

        return $this;
    }

    /**
     * Get persona
     *
     * @return \UBV\SurUbvBundle\Entity\Persona 
     */
    public function getPersona()
    {
        return $this->persona;
    }

    /**
     * Set ejeRegional
     *
     * @param \UBV\SurUbvBundle\Entity\EjeRegional $ejeRegional
     * @return Docente
     */
    public function setEjeRegional(\UBV\SurUbvBundle\Entity\EjeRegional $ejeRegional)
    {
        $this->ejeRegional = $ejeRegional;

        return $this;
    }

    /**
     * Get ejeRegional
     *
     * @return \UBV\SurUbvBundle\Entity\EjeRegional 
     */
    public function getEjeRegional()
    {
        return $this->ejeRegional;
    }

    /**
     * Set docenteDedicacion
     *
     * @param \UBV\SurUbvBundle\Entity\DocenteDedicacion $docenteDedicacion
     * @return Docente
     */
    public function setDocenteDedicacion(\UBV\SurUbvBundle\Entity\DocenteDedicacion $docenteDedicacion)
    {
        $this->docenteDedicacion = $docenteDedicacion;

        return $this;
    }

    /**
     * Get docenteDedicacion
     *
     * @return \UBV\SurUbvBundle\Entity\DocenteDedicacion 
     */
    public function getDocenteDedicacion()
    {
        return $this->docenteDedicacion;
    }

    /**
     * Set docenteEstatus
     *
     * @param \UBV\SurUbvBundle\Entity\DocenteEstatus $docenteEstatus
     * @return Docente
     */
    public function setDocenteEstatus(\UBV\SurUbvBundle\Entity\DocenteEstatus $docenteEstatus)
    {
        $this->docenteEstatus = $docenteEstatus;

        return $this;
    }

    /**
     * Get docenteEstatus
     *
     * @return \UBV\SurUbvBundle\Entity\DocenteEstatus 
     */
    public function getDocenteEstatus()
    {
        return $this->docenteEstatus;
    }
}
