<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * UBV\SurUbvBundle\Entity\DocenteAldea
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\DocenteAldeaRepository")
 * @ORM\Table(name="docente_aldea", indexes={@ORM\Index(name="fk_docente_aldea_docente1_idx", columns={"docente_id"}), @ORM\Index(name="fk_docente_aldea_aldea1_idx", columns={"aldea_id"})}, uniqueConstraints={@ORM\UniqueConstraint(name="id_docente_aldea_UNIQUE", columns={"id"})})
 */
class DocenteAldea
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="docente_aldea_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\ManyToOne(targetEntity="Docente", inversedBy="docenteAldeas")
     * @ORM\JoinColumn(name="docente_id", referencedColumnName="id", nullable=false)
     */
    protected $docente;

    /**
     * @ORM\ManyToOne(targetEntity="Aldea", inversedBy="docenteAldeas")
     * @ORM\JoinColumn(name="aldea_id", referencedColumnName="id", nullable=false)
     */
    protected $aldea;

    public function __construct()
    {
    }

    public function __sleep()
    {
        return array('id', 'docente_id', 'aldea_id');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set docente
     *
     * @param \UBV\SurUbvBundle\Entity\Docente $docente
     * @return DocenteAldea
     */
    public function setDocente(\UBV\SurUbvBundle\Entity\Docente $docente)
    {
        $this->docente = $docente;

        return $this;
    }

    /**
     * Get docente
     *
     * @return \UBV\SurUbvBundle\Entity\Docente 
     */
    public function getDocente()
    {
        return $this->docente;
    }

    /**
     * Set aldea
     *
     * @param \UBV\SurUbvBundle\Entity\Aldea $aldea
     * @return DocenteAldea
     */
    public function setAldea(\UBV\SurUbvBundle\Entity\Aldea $aldea)
    {
        $this->aldea = $aldea;

        return $this;
    }

    /**
     * Get aldea
     *
     * @return \UBV\SurUbvBundle\Entity\Aldea 
     */
    public function getAldea()
    {
        return $this->aldea;
    }
}
