<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * UBV\SurUbvBundle\Entity\DocenteDedicacion
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\DocenteDedicacionRepository")
 * @ORM\Table(name="docente_dedicacion", uniqueConstraints={@ORM\UniqueConstraint(name="id_docente_dedicacion_UNIQUE", columns={"id"})})
 */
class DocenteDedicacion
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="docente_dedicacion_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="string", length=45)
     */
    protected $descripcion;

    /**
     * @ORM\Column(type="integer")
     */
    protected $total_horas;

    /**
     * @ORM\Column(type="integer")
     */
    protected $hora_docencia_minima;

    /**
     * @ORM\Column(type="integer")
     */
    protected $hora_docencia_maxima;

    /**
     * @ORM\OneToMany(targetEntity="Docente", mappedBy="docenteDedicacion")
     * @ORM\JoinColumn(name="id", referencedColumnName="dedicacion_id", nullable=false)
     */
    protected $docentes;

    public function __construct()
    {
        $this->docentes = new ArrayCollection();
    }

    public function __sleep()
    {
        return array('id', 'descripcion', 'total_horas', 'hora_docencia_minima', 'hora_docencia_maxima');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set descripcion
     *
     * @param string $descripcion
     * @return DocenteDedicacion
     */
    public function setDescripcion($descripcion)
    {
        $this->descripcion = $descripcion;

        return $this;
    }

    /**
     * Get descripcion
     *
     * @return string 
     */
    public function getDescripcion()
    {
        return $this->descripcion;
    }

    /**
     * Set total_horas
     *
     * @param integer $totalHoras
     * @return DocenteDedicacion
     */
    public function setTotalHoras($totalHoras)
    {
        $this->total_horas = $totalHoras;

        return $this;
    }

    /**
     * Get total_horas
     *
     * @return integer 
     */
    public function getTotalHoras()
    {
        return $this->total_horas;
    }

    /**
     * Set hora_docencia_minima
     *
     * @param integer $horaDocenciaMinima
     * @return DocenteDedicacion
     */
    public function setHoraDocenciaMinima($horaDocenciaMinima)
    {
        $this->hora_docencia_minima = $horaDocenciaMinima;

        return $this;
    }

    /**
     * Get hora_docencia_minima
     *
     * @return integer 
     */
    public function getHoraDocenciaMinima()
    {
        return $this->hora_docencia_minima;
    }

    /**
     * Set hora_docencia_maxima
     *
     * @param integer $horaDocenciaMaxima
     * @return DocenteDedicacion
     */
    public function setHoraDocenciaMaxima($horaDocenciaMaxima)
    {
        $this->hora_docencia_maxima = $horaDocenciaMaxima;

        return $this;
    }

    /**
     * Get hora_docencia_maxima
     *
     * @return integer 
     */
    public function getHoraDocenciaMaxima()
    {
        return $this->hora_docencia_maxima;
    }

    /**
     * Add docentes
     *
     * @param \UBV\SurUbvBundle\Entity\Docente $docentes
     * @return DocenteDedicacion
     */
    public function addDocente(\UBV\SurUbvBundle\Entity\Docente $docentes)
    {
        $this->docentes[] = $docentes;

        return $this;
    }

    /**
     * Remove docentes
     *
     * @param \UBV\SurUbvBundle\Entity\Docente $docentes
     */
    public function removeDocente(\UBV\SurUbvBundle\Entity\Docente $docentes)
    {
        $this->docentes->removeElement($docentes);
    }

    /**
     * Get docentes
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getDocentes()
    {
        return $this->docentes;
    }
}
