<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * UBV\SurUbvBundle\Entity\DocenteEstatus
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\DocenteEstatusRepository")
 * @ORM\Table(name="docente_estatus", uniqueConstraints={@ORM\UniqueConstraint(name="id_docente_estatus_UNIQUE", columns={"id"})})
 */
class DocenteEstatus
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="docente_estatus_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="string", length=45)
     */
    protected $descripcion;

    /**
     * @ORM\OneToMany(targetEntity="Docente", mappedBy="docenteEstatus")
     * @ORM\JoinColumn(name="id", referencedColumnName="docente_estatus_id", nullable=false)
     */
    protected $docentes;

    public function __construct()
    {
        $this->docentes = new ArrayCollection();
    }

    public function __sleep()
    {
        return array('id', 'descripcion');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set descripcion
     *
     * @param string $descripcion
     * @return DocenteEstatus
     */
    public function setDescripcion($descripcion)
    {
        $this->descripcion = $descripcion;

        return $this;
    }

    /**
     * Get descripcion
     *
     * @return string 
     */
    public function getDescripcion()
    {
        return $this->descripcion;
    }

    /**
     * Add docentes
     *
     * @param \UBV\SurUbvBundle\Entity\Docente $docentes
     * @return DocenteEstatus
     */
    public function addDocente(\UBV\SurUbvBundle\Entity\Docente $docentes)
    {
        $this->docentes[] = $docentes;

        return $this;
    }

    /**
     * Remove docentes
     *
     * @param \UBV\SurUbvBundle\Entity\Docente $docentes
     */
    public function removeDocente(\UBV\SurUbvBundle\Entity\Docente $docentes)
    {
        $this->docentes->removeElement($docentes);
    }

    /**
     * Get docentes
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getDocentes()
    {
        return $this->docentes;
    }
}
