<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * UBV\SurUbvBundle\Entity\DomicilioDetalle
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\DomicilioDetalleRepository")
 * @ORM\Table(name="domicilio_detalle", indexes={@ORM\Index(name="fk_domicilio_detalle_domicilio_persona1_idx", columns={"domicilio_persona_id"}), @ORM\Index(name="fk_domicilio_detalle_domicilio_detalle_tipo1_idx", columns={"domicilio_detalle_tipo_id"})}, uniqueConstraints={@ORM\UniqueConstraint(name="id_dominilio_detalle_UNIQUE", columns={"id"})})
 */
class DomicilioDetalle
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="domicilio_detalle_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="string", length=45)
     */
    protected $descripcion;

    /**
     * @ORM\ManyToOne(targetEntity="DomicilioPersona", inversedBy="domicilioDetalles")
     * @ORM\JoinColumn(name="domicilio_persona_id", referencedColumnName="id", nullable=false)
     */
    protected $domicilioPersona;

    /**
     * @ORM\ManyToOne(targetEntity="DomicilioDetalleTipo", inversedBy="domicilioDetalles")
     * @ORM\JoinColumn(name="domicilio_detalle_tipo_id", referencedColumnName="id", nullable=false)
     */
    protected $domicilioDetalleTipo;

    public function __construct()
    {
    }

    public function __sleep()
    {
        return array('id', 'domicilio_persona_id', 'descripcion', 'domicilio_detalle_tipo_id');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set descripcion
     *
     * @param string $descripcion
     * @return DomicilioDetalle
     */
    public function setDescripcion($descripcion)
    {
        $this->descripcion = $descripcion;

        return $this;
    }

    /**
     * Get descripcion
     *
     * @return string 
     */
    public function getDescripcion()
    {
        return $this->descripcion;
    }

    /**
     * Set domicilioPersona
     *
     * @param \UBV\SurUbvBundle\Entity\DomicilioPersona $domicilioPersona
     * @return DomicilioDetalle
     */
    public function setDomicilioPersona(\UBV\SurUbvBundle\Entity\DomicilioPersona $domicilioPersona)
    {
        $this->domicilioPersona = $domicilioPersona;

        return $this;
    }

    /**
     * Get domicilioPersona
     *
     * @return \UBV\SurUbvBundle\Entity\DomicilioPersona 
     */
    public function getDomicilioPersona()
    {
        return $this->domicilioPersona;
    }

    /**
     * Set domicilioDetalleTipo
     *
     * @param \UBV\SurUbvBundle\Entity\DomicilioDetalleTipo $domicilioDetalleTipo
     * @return DomicilioDetalle
     */
    public function setDomicilioDetalleTipo(\UBV\SurUbvBundle\Entity\DomicilioDetalleTipo $domicilioDetalleTipo)
    {
        $this->domicilioDetalleTipo = $domicilioDetalleTipo;

        return $this;
    }

    /**
     * Get domicilioDetalleTipo
     *
     * @return \UBV\SurUbvBundle\Entity\DomicilioDetalleTipo 
     */
    public function getDomicilioDetalleTipo()
    {
        return $this->domicilioDetalleTipo;
    }
}
