<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * UBV\SurUbvBundle\Entity\DomicilioDetalleTipo
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\DomicilioDetalleTipoRepository")
 * @ORM\Table(name="domicilio_detalle_tipo", uniqueConstraints={@ORM\UniqueConstraint(name="id_domicilio_detalle_tipo_UNIQUE", columns={"id"})})
 */
class DomicilioDetalleTipo
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="domicilio_detalle_tipo_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="string", length=45)
     */
    protected $descripcion;

    /**
     * @ORM\OneToMany(targetEntity="DomicilioDetalle", mappedBy="domicilioDetalleTipo")
     * @ORM\JoinColumn(name="id", referencedColumnName="domicilio_detalle_tipo_id", nullable=false)
     */
    protected $domicilioDetalles;

    public function __construct()
    {
        $this->domicilioDetalles = new ArrayCollection();
    }

    public function __sleep()
    {
        return array('id', 'descripcion');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set descripcion
     *
     * @param string $descripcion
     * @return DomicilioDetalleTipo
     */
    public function setDescripcion($descripcion)
    {
        $this->descripcion = $descripcion;

        return $this;
    }

    /**
     * Get descripcion
     *
     * @return string 
     */
    public function getDescripcion()
    {
        return $this->descripcion;
    }

    /**
     * Add domicilioDetalles
     *
     * @param \UBV\SurUbvBundle\Entity\DomicilioDetalle $domicilioDetalles
     * @return DomicilioDetalleTipo
     */
    public function addDomicilioDetalle(\UBV\SurUbvBundle\Entity\DomicilioDetalle $domicilioDetalles)
    {
        $this->domicilioDetalles[] = $domicilioDetalles;

        return $this;
    }

    /**
     * Remove domicilioDetalles
     *
     * @param \UBV\SurUbvBundle\Entity\DomicilioDetalle $domicilioDetalles
     */
    public function removeDomicilioDetalle(\UBV\SurUbvBundle\Entity\DomicilioDetalle $domicilioDetalles)
    {
        $this->domicilioDetalles->removeElement($domicilioDetalles);
    }

    /**
     * Get domicilioDetalles
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getDomicilioDetalles()
    {
        return $this->domicilioDetalles;
    }
}
