<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * UBV\SurUbvBundle\Entity\DomicilioPersona
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\DomicilioPersonaRepository")
 * @ORM\Table(name="domicilio_persona", indexes={@ORM\Index(name="fk_domicilio_persona_ciudad1_idx", columns={"ciudad_id"}), @ORM\Index(name="fk_domicilio_persona_parroquia1_idx", columns={"parroquia_id"}), @ORM\Index(name="fk_domicilio_persona_persona1_idx", columns={"persona_id"})}, uniqueConstraints={@ORM\UniqueConstraint(name="id_domicilio_persona_UNIQUE", columns={"id"})})
 */
class DomicilioPersona
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="domicilio_persona_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\OneToMany(targetEntity="DomicilioDetalle", mappedBy="domicilioPersona")
     * @ORM\JoinColumn(name="id", referencedColumnName="domicilio_persona_id", nullable=false)
     */
    protected $domicilioDetalles;

    /**
     * @ORM\ManyToOne(targetEntity="Ciudad", inversedBy="domicilioPersonas")
     * @ORM\JoinColumn(name="ciudad_id", referencedColumnName="id", nullable=false)
     */
    protected $ciudad;

    /**
     * @ORM\ManyToOne(targetEntity="Parroquia", inversedBy="domicilioPersonas")
     * @ORM\JoinColumn(name="parroquia_id", referencedColumnName="id", nullable=false)
     */
    protected $parroquia;

    /**
     * @ORM\ManyToOne(targetEntity="Persona", inversedBy="domicilioPersonas")
     * @ORM\JoinColumn(name="persona_id", referencedColumnName="id", nullable=false)
     */
    protected $persona;

    public function __construct()
    {
        $this->domicilioDetalles = new ArrayCollection();
    }

    public function __sleep()
    {
        return array('id', 'ciudad_id', 'parroquia_id', 'persona_id');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Add domicilioDetalles
     *
     * @param \UBV\SurUbvBundle\Entity\DomicilioDetalle $domicilioDetalles
     * @return DomicilioPersona
     */
    public function addDomicilioDetalle(\UBV\SurUbvBundle\Entity\DomicilioDetalle $domicilioDetalles)
    {
        $this->domicilioDetalles[] = $domicilioDetalles;

        return $this;
    }

    /**
     * Remove domicilioDetalles
     *
     * @param \UBV\SurUbvBundle\Entity\DomicilioDetalle $domicilioDetalles
     */
    public function removeDomicilioDetalle(\UBV\SurUbvBundle\Entity\DomicilioDetalle $domicilioDetalles)
    {
        $this->domicilioDetalles->removeElement($domicilioDetalles);
    }

    /**
     * Get domicilioDetalles
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getDomicilioDetalles()
    {
        return $this->domicilioDetalles;
    }

    /**
     * Set ciudad
     *
     * @param \UBV\SurUbvBundle\Entity\Ciudad $ciudad
     * @return DomicilioPersona
     */
    public function setCiudad(\UBV\SurUbvBundle\Entity\Ciudad $ciudad)
    {
        $this->ciudad = $ciudad;

        return $this;
    }

    /**
     * Get ciudad
     *
     * @return \UBV\SurUbvBundle\Entity\Ciudad 
     */
    public function getCiudad()
    {
        return $this->ciudad;
    }

    /**
     * Set parroquia
     *
     * @param \UBV\SurUbvBundle\Entity\Parroquia $parroquia
     * @return DomicilioPersona
     */
    public function setParroquia(\UBV\SurUbvBundle\Entity\Parroquia $parroquia)
    {
        $this->parroquia = $parroquia;

        return $this;
    }

    /**
     * Get parroquia
     *
     * @return \UBV\SurUbvBundle\Entity\Parroquia 
     */
    public function getParroquia()
    {
        return $this->parroquia;
    }

    /**
     * Set persona
     *
     * @param \UBV\SurUbvBundle\Entity\Persona $persona
     * @return DomicilioPersona
     */
    public function setPersona(\UBV\SurUbvBundle\Entity\Persona $persona)
    {
        $this->persona = $persona;

        return $this;
    }

    /**
     * Get persona
     *
     * @return \UBV\SurUbvBundle\Entity\Persona 
     */
    public function getPersona()
    {
        return $this->persona;
    }
}
