<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * UBV\SurUbvBundle\Entity\EjeFormacion
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\EjeFormacionRepository")
 * @ORM\Table(name="eje_formacion", uniqueConstraints={@ORM\UniqueConstraint(name="id_eje_formacion_UNIQUE", columns={"id"})})
 */
class EjeFormacion
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="eje_formacion_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="string", length=70)
     */
    protected $descripcion;

    /**
     * @ORM\OneToMany(targetEntity="UnidadCurricularDetalle", mappedBy="ejeFormacion")
     * @ORM\JoinColumn(name="id", referencedColumnName="eje_formacion_id", nullable=false)
     */
    protected $unidadCurricularDetalles;

    public function __construct()
    {
        $this->unidadCurricularDetalles = new ArrayCollection();
    }

    public function __sleep()
    {
        return array('id', 'descripcion');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set descripcion
     *
     * @param string $descripcion
     * @return EjeFormacion
     */
    public function setDescripcion($descripcion)
    {
        $this->descripcion = $descripcion;

        return $this;
    }

    /**
     * Get descripcion
     *
     * @return string 
     */
    public function getDescripcion()
    {
        return $this->descripcion;
    }

    /**
     * Add unidadCurricularDetalles
     *
     * @param \UBV\SurUbvBundle\Entity\UnidadCurricularDetalle $unidadCurricularDetalles
     * @return EjeFormacion
     */
    public function addUnidadCurricularDetalle(\UBV\SurUbvBundle\Entity\UnidadCurricularDetalle $unidadCurricularDetalles)
    {
        $this->unidadCurricularDetalles[] = $unidadCurricularDetalles;

        return $this;
    }

    /**
     * Remove unidadCurricularDetalles
     *
     * @param \UBV\SurUbvBundle\Entity\UnidadCurricularDetalle $unidadCurricularDetalles
     */
    public function removeUnidadCurricularDetalle(\UBV\SurUbvBundle\Entity\UnidadCurricularDetalle $unidadCurricularDetalles)
    {
        $this->unidadCurricularDetalles->removeElement($unidadCurricularDetalles);
    }

    /**
     * Get unidadCurricularDetalles
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getUnidadCurricularDetalles()
    {
        return $this->unidadCurricularDetalles;
    }
}
