<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * UBV\SurUbvBundle\Entity\EjeMunicipal
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\EjeMunicipalRepository")
 * @ORM\Table(name="eje_municipal", indexes={@ORM\Index(name="fk_eje_municipal_eje_regional1_idx", columns={"eje_regional_id"})}, uniqueConstraints={@ORM\UniqueConstraint(name="id_eje_municipal_UNIQUE", columns={"id"})})
 */
class EjeMunicipal
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="eje_municipal_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="string", length=70)
     */
    protected $descripcion;

    /**
     * @ORM\Column(type="string", length=15)
     */
    protected $codigo;

    /**
     * @ORM\OneToMany(targetEntity="Parroquia", mappedBy="ejeMunicipal")
     * @ORM\JoinColumn(name="id", referencedColumnName="eje_municipal_id", nullable=false)
     */
    protected $parroquias;

    /**
     * @ORM\ManyToOne(targetEntity="EjeRegional", inversedBy="ejeMunicipals", cascade={"persist", "remove"})
     * @ORM\JoinColumn(name="eje_regional_id", referencedColumnName="id", nullable=false)
     */
    protected $ejeRegional;

    public function __construct()
    {
        $this->parroquias = new ArrayCollection();
    }

    public function __sleep()
    {
        return array('id', 'descripcion', 'codigo', 'eje_regional_id');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set descripcion
     *
     * @param string $descripcion
     * @return EjeMunicipal
     */
    public function setDescripcion($descripcion)
    {
        $this->descripcion = $descripcion;

        return $this;
    }

    /**
     * Get descripcion
     *
     * @return string 
     */
    public function getDescripcion()
    {
        return $this->descripcion;
    }

    /**
     * Set codigo
     *
     * @param string $codigo
     * @return EjeMunicipal
     */
    public function setCodigo($codigo)
    {
        $this->codigo = $codigo;

        return $this;
    }

    /**
     * Get codigo
     *
     * @return string 
     */
    public function getCodigo()
    {
        return $this->codigo;
    }

    /**
     * Add parroquias
     *
     * @param \UBV\SurUbvBundle\Entity\Parroquia $parroquias
     * @return EjeMunicipal
     */
    public function addParroquia(\UBV\SurUbvBundle\Entity\Parroquia $parroquias)
    {
        $this->parroquias[] = $parroquias;

        return $this;
    }

    /**
     * Remove parroquias
     *
     * @param \UBV\SurUbvBundle\Entity\Parroquia $parroquias
     */
    public function removeParroquia(\UBV\SurUbvBundle\Entity\Parroquia $parroquias)
    {
        $this->parroquias->removeElement($parroquias);
    }

    /**
     * Get parroquias
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getParroquias()
    {
        return $this->parroquias;
    }
    
    public function __toString() {
      return $this->getDescripcion();
    }

    /**
     * Set ejeRegional
     *
     * @param \UBV\SurUbvBundle\Entity\EjeRegional $ejeRegional
     * @return EjeMunicipal
     */
    public function setEjeRegional(\UBV\SurUbvBundle\Entity\EjeRegional $ejeRegional)
    {
        $this->ejeRegional = $ejeRegional;

        return $this;
    }

    /**
     * Get ejeRegional
     *
     * @return \UBV\SurUbvBundle\Entity\EjeRegional 
     */
    public function getEjeRegional()
    {
        return $this->ejeRegional;
    }
}
