<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * UBV\SurUbvBundle\Entity\EjeRegional
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\EjeRegionalRepository")
 * @ORM\Table(name="eje_regional", uniqueConstraints={@ORM\UniqueConstraint(name="id_eje_regional_UNIQUE", columns={"id"})})
 */
class EjeRegional
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="eje_regional_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="string", length=70)
     */
    protected $descripcion;

    /**
     * @ORM\Column(type="string", length=15)
     */
    protected $codigo;

    /**
     * @ORM\OneToOne(targetEntity="Docente", mappedBy="ejeRegional")
     */
    protected $docente;

    /**
     * @ORM\OneToMany(targetEntity="EjeMunicipal", mappedBy="ejeRegional", cascade={"persist", "remove"})
     * @ORM\JoinColumn(name="id", referencedColumnName="eje_regional_id", nullable=false)
     */
    protected $ejeMunicipals;

    public function __construct()
    {
        $this->docentes = new ArrayCollection();
        $this->ejeMunicipals = new ArrayCollection();
    }

    public function __sleep()
    {
        return array('id', 'descripcion', 'codigo');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set descripcion
     *
     * @param string $descripcion
     * @return EjeRegional
     */
    public function setDescripcion($descripcion)
    {
        $this->descripcion = $descripcion;

        return $this;
    }

    /**
     * Get descripcion
     *
     * @return string 
     */
    public function getDescripcion()
    {
        return $this->descripcion;
    }

    /**
     * Set codigo
     *
     * @param string $codigo
     * @return EjeRegional
     */
    public function setCodigo($codigo)
    {
        $this->codigo = $codigo;

        return $this;
    }

    /**
     * Get codigo
     *
     * @return string 
     */
    public function getCodigo()
    {
        return $this->codigo;
    }

    /**
     * Set docente
     *
     * @param \UBV\SurUbvBundle\Entity\Docente $docente
     * @return EjeRegional
     */
    public function setDocente(\UBV\SurUbvBundle\Entity\Docente $docente = null)
    {
        $this->docente = $docente;

        return $this;
    }

    /**
     * Get docente
     *
     * @return \UBV\SurUbvBundle\Entity\Docente 
     */
    public function getDocente()
    {
        return $this->docente;
    }

    /**
     * Add ejeMunicipals
     *
     * @param \UBV\SurUbvBundle\Entity\EjeMunicipal $ejeMunicipals
     * @return EjeRegional
     */
    public function addEjeMunicipal(\UBV\SurUbvBundle\Entity\EjeMunicipal $ejeMunicipals)
    {
        $this->ejeMunicipals[] = $ejeMunicipals;

        return $this;
    }

    /**
     * Remove ejeMunicipals
     *
     * @param \UBV\SurUbvBundle\Entity\EjeMunicipal $ejeMunicipals
     */
    public function removeEjeMunicipal(\UBV\SurUbvBundle\Entity\EjeMunicipal $ejeMunicipals)
    {
        $this->ejeMunicipals->removeElement($ejeMunicipals);
    }

    /**
     * Get ejeMunicipals
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getEjeMunicipals()
    {
        return $this->ejeMunicipals;
    }
    
    public function __toString() {
      return $this->getDescripcion();
    }
}
