<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * UBV\SurUbvBundle\Entity\EstudianteDetalle
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\EstudianteDetalleRepository")
 * @ORM\Table(name="estudiante_detalle", indexes={@ORM\Index(name="fk_estudiante_detalle_estudiante1_idx", columns={"estudiante_id"}), @ORM\Index(name="fk_estudiante_detalle_periodo_academico1_idx", columns={"periodo_academico_id"}), @ORM\Index(name="fk_estudiante_detalle_aldea_malla_curricula1_idx", columns={"aldea_malla_curricula_id"}), @ORM\Index(name="fk_estudiante_detalle_turno1_idx", columns={"turno_id"})}, uniqueConstraints={@ORM\UniqueConstraint(name="id_estudiante_detalle_UNIQUE", columns={"id"})})
 */
class EstudianteDetalle
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="estudiante_detalle_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="string", length=2)
     */
    protected $estatus;

    /**
     * @ORM\Column(type="date")
     */
    protected $fecha_ingreso;

    /**
     * @ORM\Column(type="string", length=15)
     */
    protected $numero_expediente;

    /**
     * @ORM\OneToMany(targetEntity="ExpedienteDocumento", mappedBy="estudianteDetalle")
     * @ORM\JoinColumn(name="id", referencedColumnName="estudiante_detalle_id", nullable=false)
     */
    protected $expedienteDocumentos;

    /**
     * @ORM\ManyToOne(targetEntity="Estudiante", inversedBy="estudianteDetalles")
     * @ORM\JoinColumn(name="estudiante_id", referencedColumnName="id", nullable=false)
     */
    protected $estudiante;

    /**
     * @ORM\ManyToOne(targetEntity="PeriodoAcademico", inversedBy="estudianteDetalles")
     * @ORM\JoinColumn(name="periodo_academico_id", referencedColumnName="id", nullable=false)
     */
    protected $periodoAcademico;

    /**
     * @ORM\ManyToOne(targetEntity="AldeaMallaCurricula", inversedBy="estudianteDetalles")
     * @ORM\JoinColumn(name="aldea_malla_curricula_id", referencedColumnName="id", nullable=false)
     */
    protected $aldeaMallaCurricula;

    /**
     * @ORM\ManyToOne(targetEntity="Turno", inversedBy="estudianteDetalles")
     * @ORM\JoinColumn(name="turno_id", referencedColumnName="id", nullable=false)
     */
    protected $turno;

    public function __construct()
    {
        $this->expedienteDocumentos = new ArrayCollection();
    }

    public function __sleep()
    {
        return array('id', 'estatus', 'fecha_ingreso', 'numero_expediente', 'estudiante_id', 'periodo_academico_id', 'aldea_malla_curricula_id', 'turno_id');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set estatus
     *
     * @param string $estatus
     * @return EstudianteDetalle
     */
    public function setEstatus($estatus)
    {
        $this->estatus = $estatus;

        return $this;
    }

    /**
     * Get estatus
     *
     * @return string 
     */
    public function getEstatus()
    {
        return $this->estatus;
    }

    /**
     * Set fecha_ingreso
     *
     * @param \DateTime $fechaIngreso
     * @return EstudianteDetalle
     */
    public function setFechaIngreso($fechaIngreso)
    {
        $this->fecha_ingreso = $fechaIngreso;

        return $this;
    }

    /**
     * Get fecha_ingreso
     *
     * @return \DateTime 
     */
    public function getFechaIngreso()
    {
        return $this->fecha_ingreso;
    }

    /**
     * Set numero_expediente
     *
     * @param string $numeroExpediente
     * @return EstudianteDetalle
     */
    public function setNumeroExpediente($numeroExpediente)
    {
        $this->numero_expediente = $numeroExpediente;

        return $this;
    }

    /**
     * Get numero_expediente
     *
     * @return string 
     */
    public function getNumeroExpediente()
    {
        return $this->numero_expediente;
    }

    /**
     * Add expedienteDocumentos
     *
     * @param \UBV\SurUbvBundle\Entity\ExpedienteDocumento $expedienteDocumentos
     * @return EstudianteDetalle
     */
    public function addExpedienteDocumento(\UBV\SurUbvBundle\Entity\ExpedienteDocumento $expedienteDocumentos)
    {
        $this->expedienteDocumentos[] = $expedienteDocumentos;

        return $this;
    }

    /**
     * Remove expedienteDocumentos
     *
     * @param \UBV\SurUbvBundle\Entity\ExpedienteDocumento $expedienteDocumentos
     */
    public function removeExpedienteDocumento(\UBV\SurUbvBundle\Entity\ExpedienteDocumento $expedienteDocumentos)
    {
        $this->expedienteDocumentos->removeElement($expedienteDocumentos);
    }

    /**
     * Get expedienteDocumentos
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getExpedienteDocumentos()
    {
        return $this->expedienteDocumentos;
    }

    /**
     * Set estudiante
     *
     * @param \UBV\SurUbvBundle\Entity\Estudiante $estudiante
     * @return EstudianteDetalle
     */
    public function setEstudiante(\UBV\SurUbvBundle\Entity\Estudiante $estudiante)
    {
        $this->estudiante = $estudiante;

        return $this;
    }

    /**
     * Get estudiante
     *
     * @return \UBV\SurUbvBundle\Entity\Estudiante 
     */
    public function getEstudiante()
    {
        return $this->estudiante;
    }

    /**
     * Set periodoAcademico
     *
     * @param \UBV\SurUbvBundle\Entity\PeriodoAcademico $periodoAcademico
     * @return EstudianteDetalle
     */
    public function setPeriodoAcademico(\UBV\SurUbvBundle\Entity\PeriodoAcademico $periodoAcademico)
    {
        $this->periodoAcademico = $periodoAcademico;

        return $this;
    }

    /**
     * Get periodoAcademico
     *
     * @return \UBV\SurUbvBundle\Entity\PeriodoAcademico 
     */
    public function getPeriodoAcademico()
    {
        return $this->periodoAcademico;
    }

    /**
     * Set aldeaMallaCurricula
     *
     * @param \UBV\SurUbvBundle\Entity\AldeaMallaCurricula $aldeaMallaCurricula
     * @return EstudianteDetalle
     */
    public function setAldeaMallaCurricula(\UBV\SurUbvBundle\Entity\AldeaMallaCurricula $aldeaMallaCurricula)
    {
        $this->aldeaMallaCurricula = $aldeaMallaCurricula;

        return $this;
    }

    /**
     * Get aldeaMallaCurricula
     *
     * @return \UBV\SurUbvBundle\Entity\AldeaMallaCurricula 
     */
    public function getAldeaMallaCurricula()
    {
        return $this->aldeaMallaCurricula;
    }

    /**
     * Set turno
     *
     * @param \UBV\SurUbvBundle\Entity\Turno $turno
     * @return EstudianteDetalle
     */
    public function setTurno(\UBV\SurUbvBundle\Entity\Turno $turno)
    {
        $this->turno = $turno;

        return $this;
    }

    /**
     * Get turno
     *
     * @return \UBV\SurUbvBundle\Entity\Turno 
     */
    public function getTurno()
    {
        return $this->turno;
    }
}
