<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * UBV\SurUbvBundle\Entity\Etnia
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\EtniaRepository")
 * @ORM\Table(name="etnia", uniqueConstraints={@ORM\UniqueConstraint(name="id_etnia_UNIQUE", columns={"id"})})
 */
class Etnia
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="etnia_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="string", length=35)
     */
    protected $descripcion;

    /**
     * @ORM\OneToMany(targetEntity="PersonaEtnia", mappedBy="etnia")
     * @ORM\JoinColumn(name="id", referencedColumnName="etnia_id", nullable=false)
     */
    protected $personaEtnias;
    
    /**
     * @ORM\OneToMany(targetEntity="Candidato", mappedBy="etnia")
     * @ORM\JoinColumn(name="id", referencedColumnName="etnia_id", nullable=false)
     */
    protected $candidatos;

    public function __construct()
    {
        $this->personaEtnias = new ArrayCollection();
        $this->candidatos = new ArrayCollection();
    }

    public function __sleep()
    {
        return array('id', 'descripcion');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set descripcion
     *
     * @param string $descripcion
     * @return Etnia
     */
    public function setDescripcion($descripcion)
    {
        $this->descripcion = $descripcion;

        return $this;
    }

    /**
     * Get descripcion
     *
     * @return string 
     */
    public function getDescripcion()
    {
        return $this->descripcion;
    }

    /**
     * Add personaEtnias
     *
     * @param \UBV\SurUbvBundle\Entity\PersonaEtnia $personaEtnias
     * @return Etnia
     */
    public function addPersonaEtnia(\UBV\SurUbvBundle\Entity\PersonaEtnia $personaEtnias)
    {
        $this->personaEtnias[] = $personaEtnias;

        return $this;
    }

    /**
     * Remove personaEtnias
     *
     * @param \UBV\SurUbvBundle\Entity\PersonaEtnia $personaEtnias
     */
    public function removePersonaEtnia(\UBV\SurUbvBundle\Entity\PersonaEtnia $personaEtnias)
    {
        $this->personaEtnias->removeElement($personaEtnias);
    }

    /**
     * Get personaEtnias
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getPersonaEtnias()
    {
        return $this->personaEtnias;
    }
    
    public function __toString()
    {
        return $this->getDescripcion();
    }

    /**
     * Add candidatos
     *
     * @param \UBV\SurUbvBundle\Entity\Candidato $candidatos
     * @return Etnia
     */
    public function addCandidato(\UBV\SurUbvBundle\Entity\Candidato $candidatos)
    {
        $this->candidatos[] = $candidatos;

        return $this;
    }

    /**
     * Remove candidatos
     *
     * @param \UBV\SurUbvBundle\Entity\Candidato $candidatos
     */
    public function removeCandidato(\UBV\SurUbvBundle\Entity\Candidato $candidatos)
    {
        $this->candidatos->removeElement($candidatos);
    }

    /**
     * Get candidatos
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getCandidatos()
    {
        return $this->candidatos;
    }
}
