<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * UBV\SurUbvBundle\Entity\ExpedienteDocumento
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\ExpedienteDocumentoRepository")
 * @ORM\Table(name="expediente_documento", indexes={@ORM\Index(name="fk_expediente_documento_estudiante_documento1_idx", columns={"estudiante_documento_id"}), @ORM\Index(name="fk_expediente_documento_estudiante_detalle1_idx", columns={"estudiante_detalle_id"})}, uniqueConstraints={@ORM\UniqueConstraint(name="id_expediente_documento_UNIQUE", columns={"id"})})
 */
class ExpedienteDocumento
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="expediente_documento_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\ManyToOne(targetEntity="EstudianteDocumento", inversedBy="expedienteDocumentos")
     * @ORM\JoinColumn(name="estudiante_documento_id", referencedColumnName="id", nullable=false)
     */
    protected $estudianteDocumento;

    /**
     * @ORM\ManyToOne(targetEntity="EstudianteDetalle", inversedBy="expedienteDocumentos")
     * @ORM\JoinColumn(name="estudiante_detalle_id", referencedColumnName="id", nullable=false)
     */
    protected $estudianteDetalle;

    public function __construct()
    {
    }

    public function __sleep()
    {
        return array('id', 'estudiante_documento_id', 'estudiante_detalle_id');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set estudianteDocumento
     *
     * @param \UBV\SurUbvBundle\Entity\EstudianteDocumento $estudianteDocumento
     * @return ExpedienteDocumento
     */
    public function setEstudianteDocumento(\UBV\SurUbvBundle\Entity\EstudianteDocumento $estudianteDocumento)
    {
        $this->estudianteDocumento = $estudianteDocumento;

        return $this;
    }

    /**
     * Get estudianteDocumento
     *
     * @return \UBV\SurUbvBundle\Entity\EstudianteDocumento 
     */
    public function getEstudianteDocumento()
    {
        return $this->estudianteDocumento;
    }

    /**
     * Set estudianteDetalle
     *
     * @param \UBV\SurUbvBundle\Entity\EstudianteDetalle $estudianteDetalle
     * @return ExpedienteDocumento
     */
    public function setEstudianteDetalle(\UBV\SurUbvBundle\Entity\EstudianteDetalle $estudianteDetalle)
    {
        $this->estudianteDetalle = $estudianteDetalle;

        return $this;
    }

    /**
     * Get estudianteDetalle
     *
     * @return \UBV\SurUbvBundle\Entity\EstudianteDetalle 
     */
    public function getEstudianteDetalle()
    {
        return $this->estudianteDetalle;
    }
}
