<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * UBV\SurUbvBundle\Entity\GradoAcademico
 *
 * @ORM\Entity()
 * @ORM\Table(name="grado_academico", indexes={@ORM\Index(name="fk_grado_academico_nivel_academico1_idx", columns={"nivel_academico_id"})}, uniqueConstraints={@ORM\UniqueConstraint(name="id_grado_academico_UNIQUE", columns={"id"})})
 */
class GradoAcademico
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="grado_academico_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="string", length=70, nullable=true)
     */
    protected $descripcion;

    /**
     * @ORM\OneToMany(targetEntity="Aspirante", mappedBy="gradoAcademico")
     * @ORM\JoinColumn(name="id", referencedColumnName="grado_academico_id", nullable=false)
     */
    protected $aspirantes;

    /**
     * @ORM\OneToMany(targetEntity="RequisitoGrado", mappedBy="gradoAcademico")
     * @ORM\JoinColumn(name="id", referencedColumnName="grado_academico_id", nullable=false)
     */
    protected $requisitoGrados;

    /**
     * @ORM\ManyToOne(targetEntity="NivelAcademico", inversedBy="gradoAcademicos")
     * @ORM\JoinColumn(name="nivel_academico_id", referencedColumnName="id", nullable=false)
     */
    protected $nivelAcademico;

    public function __construct()
    {
        $this->aspirantes = new ArrayCollection();
        $this->requisitoGrados = new ArrayCollection();
    }

    public function __sleep()
    {
        return array('id', 'descripcion', 'nivel_academico_id');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set descripcion
     *
     * @param string $descripcion
     * @return GradoAcademico
     */
    public function setDescripcion($descripcion)
    {
        $this->descripcion = $descripcion;

        return $this;
    }

    /**
     * Get descripcion
     *
     * @return string 
     */
    public function getDescripcion()
    {
        return $this->descripcion;
    }

    /**
     * Add aspirantes
     *
     * @param \UBV\SurUbvBundle\Entity\Aspirante $aspirantes
     * @return GradoAcademico
     */
    public function addAspirante(\UBV\SurUbvBundle\Entity\Aspirante $aspirantes)
    {
        $this->aspirantes[] = $aspirantes;

        return $this;
    }

    /**
     * Remove aspirantes
     *
     * @param \UBV\SurUbvBundle\Entity\Aspirante $aspirantes
     */
    public function removeAspirante(\UBV\SurUbvBundle\Entity\Aspirante $aspirantes)
    {
        $this->aspirantes->removeElement($aspirantes);
    }

    /**
     * Get aspirantes
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getAspirantes()
    {
        return $this->aspirantes;
    }

    /**
     * Add requisitoGrados
     *
     * @param \UBV\SurUbvBundle\Entity\RequisitoGrado $requisitoGrados
     * @return GradoAcademico
     */
    public function addRequisitoGrado(\UBV\SurUbvBundle\Entity\RequisitoGrado $requisitoGrados)
    {
        $this->requisitoGrados[] = $requisitoGrados;

        return $this;
    }

    /**
     * Remove requisitoGrados
     *
     * @param \UBV\SurUbvBundle\Entity\RequisitoGrado $requisitoGrados
     */
    public function removeRequisitoGrado(\UBV\SurUbvBundle\Entity\RequisitoGrado $requisitoGrados)
    {
        $this->requisitoGrados->removeElement($requisitoGrados);
    }

    /**
     * Get requisitoGrados
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getRequisitoGrados()
    {
        return $this->requisitoGrados;
    }

    /**
     * Set nivelAcademico
     *
     * @param \UBV\SurUbvBundle\Entity\NivelAcademico $nivelAcademico
     * @return GradoAcademico
     */
    public function setNivelAcademico(\UBV\SurUbvBundle\Entity\NivelAcademico $nivelAcademico)
    {
        $this->nivelAcademico = $nivelAcademico;

        return $this;
    }

    /**
     * Get nivelAcademico
     *
     * @return \UBV\SurUbvBundle\Entity\NivelAcademico 
     */
    public function getNivelAcademico()
    {
        return $this->nivelAcademico;
    }
				
				public function __toString(){
						return $this->getDescripcion();
				}
}
