<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * UBV\SurUbvBundle\Entity\Horario
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\HorarioRepository")
 * @ORM\Table(name="horario", indexes={@ORM\Index(name="fk_horario_dia_semana1_idx", columns={"dia_semana_id"}), @ORM\Index(name="fk_horario_carga_academica1_idx", columns={"carga_academica_id"})}, uniqueConstraints={@ORM\UniqueConstraint(name="id_horario_UNIQUE", columns={"id"})})
 */
class Horario
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="horario_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="string", length=45, nullable=true)
     */
    protected $bloque_inicio;

    /**
     * @ORM\Column(type="string", length=45, nullable=true)
     */
    protected $bloque_fin;

    /**
     * @ORM\ManyToOne(targetEntity="DiaSemana", inversedBy="horarios")
     * @ORM\JoinColumn(name="dia_semana_id", referencedColumnName="id", nullable=false)
     */
    protected $diaSemana;

    /**
     * @ORM\ManyToOne(targetEntity="CargaAcademica", inversedBy="horarios")
     * @ORM\JoinColumn(name="carga_academica_id", referencedColumnName="id", nullable=false)
     */
    protected $cargaAcademica;

    public function __construct()
    {
    }

    public function __sleep()
    {
        return array('id', 'bloque_inicio', 'bloque_fin', 'dia_semana_id', 'carga_academica_id');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set bloque_inicio
     *
     * @param string $bloqueInicio
     * @return Horario
     */
    public function setBloqueInicio($bloqueInicio)
    {
        $this->bloque_inicio = $bloqueInicio;

        return $this;
    }

    /**
     * Get bloque_inicio
     *
     * @return string 
     */
    public function getBloqueInicio()
    {
        return $this->bloque_inicio;
    }

    /**
     * Set bloque_fin
     *
     * @param string $bloqueFin
     * @return Horario
     */
    public function setBloqueFin($bloqueFin)
    {
        $this->bloque_fin = $bloqueFin;

        return $this;
    }

    /**
     * Get bloque_fin
     *
     * @return string 
     */
    public function getBloqueFin()
    {
        return $this->bloque_fin;
    }

    /**
     * Set diaSemana
     *
     * @param \UBV\SurUbvBundle\Entity\DiaSemana $diaSemana
     * @return Horario
     */
    public function setDiaSemana(\UBV\SurUbvBundle\Entity\DiaSemana $diaSemana)
    {
        $this->diaSemana = $diaSemana;

        return $this;
    }

    /**
     * Get diaSemana
     *
     * @return \UBV\SurUbvBundle\Entity\DiaSemana 
     */
    public function getDiaSemana()
    {
        return $this->diaSemana;
    }

    /**
     * Set cargaAcademica
     *
     * @param \UBV\SurUbvBundle\Entity\CargaAcademica $cargaAcademica
     * @return Horario
     */
    public function setCargaAcademica(\UBV\SurUbvBundle\Entity\CargaAcademica $cargaAcademica)
    {
        $this->cargaAcademica = $cargaAcademica;

        return $this;
    }

    /**
     * Get cargaAcademica
     *
     * @return \UBV\SurUbvBundle\Entity\CargaAcademica 
     */
    public function getCargaAcademica()
    {
        return $this->cargaAcademica;
    }
}
