<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * UBV\SurUbvBundle\Entity\Inscripcion
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\InscripcionRepository")
 * @ORM\Table(name="inscripcion", indexes={@ORM\Index(name="fk_inscripcion_estudiante1_idx", columns={"estudiante_id"})}, uniqueConstraints={@ORM\UniqueConstraint(name="id_inscripcion_UNIQUE", columns={"id"})})
 */
class Inscripcion
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="inscripcion_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\OneToMany(targetEntity="InscripcionDetalle", mappedBy="inscripcion")
     * @ORM\JoinColumn(name="id", referencedColumnName="inscripcion_id", nullable=false)
     */
    protected $inscripcionDetalles;

    /**
     * @ORM\ManyToOne(targetEntity="Estudiante", inversedBy="inscripcions")
     * @ORM\JoinColumn(name="estudiante_id", referencedColumnName="id", nullable=false)
     */
    protected $estudiante;

    public function __construct()
    {
        $this->inscripcionDetalles = new ArrayCollection();
    }

    public function __sleep()
    {
        return array('id', 'estudiante_id');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Add inscripcionDetalles
     *
     * @param \UBV\SurUbvBundle\Entity\InscripcionDetalle $inscripcionDetalles
     * @return Inscripcion
     */
    public function addInscripcionDetalle(\UBV\SurUbvBundle\Entity\InscripcionDetalle $inscripcionDetalles)
    {
        $this->inscripcionDetalles[] = $inscripcionDetalles;

        return $this;
    }

    /**
     * Remove inscripcionDetalles
     *
     * @param \UBV\SurUbvBundle\Entity\InscripcionDetalle $inscripcionDetalles
     */
    public function removeInscripcionDetalle(\UBV\SurUbvBundle\Entity\InscripcionDetalle $inscripcionDetalles)
    {
        $this->inscripcionDetalles->removeElement($inscripcionDetalles);
    }

    /**
     * Get inscripcionDetalles
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getInscripcionDetalles()
    {
        return $this->inscripcionDetalles;
    }

    /**
     * Set estudiante
     *
     * @param \UBV\SurUbvBundle\Entity\Estudiante $estudiante
     * @return Inscripcion
     */
    public function setEstudiante(\UBV\SurUbvBundle\Entity\Estudiante $estudiante)
    {
        $this->estudiante = $estudiante;

        return $this;
    }

    /**
     * Get estudiante
     *
     * @return \UBV\SurUbvBundle\Entity\Estudiante 
     */
    public function getEstudiante()
    {
        return $this->estudiante;
    }
}
