<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * UBV\SurUbvBundle\Entity\InscripcionDetalle
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\InscripcionDetalleRepository")
 * @ORM\Table(name="inscripcion_detalle", indexes={@ORM\Index(name="fk_inscripcion_detalle_inscripcion1_idx", columns={"inscripcion_id"}), @ORM\Index(name="fk_inscripcion_detalle_carga_academica1_idx", columns={"carga_academica_id"})}, uniqueConstraints={@ORM\UniqueConstraint(name="id_inscripcion_detalle_UNIQUE", columns={"id"})})
 */
class InscripcionDetalle
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="inscripcion_detalle_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="string", length=6)
     */
    protected $codigo;

    /**
     * @ORM\Column(type="string", length=1)
     */
    protected $estatus;

    /**
     * @ORM\Column(type="date")
     */
    protected $fecha_ingreso;

    /**
     * @ORM\ManyToOne(targetEntity="Inscripcion", inversedBy="inscripcionDetalles")
     * @ORM\JoinColumn(name="inscripcion_id", referencedColumnName="id", nullable=false)
     */
    protected $inscripcion;

    /**
     * @ORM\ManyToOne(targetEntity="CargaAcademica", inversedBy="inscripcionDetalles")
     * @ORM\JoinColumn(name="carga_academica_id", referencedColumnName="id", nullable=false)
     */
    protected $cargaAcademica;

    public function __construct()
    {
    }

    public function __sleep()
    {
        return array('id', 'codigo', 'estatus', 'fecha_ingreso', 'inscripcion_id', 'carga_academica_id');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set codigo
     *
     * @param string $codigo
     * @return InscripcionDetalle
     */
    public function setCodigo($codigo)
    {
        $this->codigo = $codigo;

        return $this;
    }

    /**
     * Get codigo
     *
     * @return string 
     */
    public function getCodigo()
    {
        return $this->codigo;
    }

    /**
     * Set estatus
     *
     * @param string $estatus
     * @return InscripcionDetalle
     */
    public function setEstatus($estatus)
    {
        $this->estatus = $estatus;

        return $this;
    }

    /**
     * Get estatus
     *
     * @return string 
     */
    public function getEstatus()
    {
        return $this->estatus;
    }

    /**
     * Set fecha_ingreso
     *
     * @param \DateTime $fechaIngreso
     * @return InscripcionDetalle
     */
    public function setFechaIngreso($fechaIngreso)
    {
        $this->fecha_ingreso = $fechaIngreso;

        return $this;
    }

    /**
     * Get fecha_ingreso
     *
     * @return \DateTime 
     */
    public function getFechaIngreso()
    {
        return $this->fecha_ingreso;
    }

    /**
     * Set inscripcion
     *
     * @param \UBV\SurUbvBundle\Entity\Inscripcion $inscripcion
     * @return InscripcionDetalle
     */
    public function setInscripcion(\UBV\SurUbvBundle\Entity\Inscripcion $inscripcion)
    {
        $this->inscripcion = $inscripcion;

        return $this;
    }

    /**
     * Get inscripcion
     *
     * @return \UBV\SurUbvBundle\Entity\Inscripcion 
     */
    public function getInscripcion()
    {
        return $this->inscripcion;
    }

    /**
     * Set cargaAcademica
     *
     * @param \UBV\SurUbvBundle\Entity\CargaAcademica $cargaAcademica
     * @return InscripcionDetalle
     */
    public function setCargaAcademica(\UBV\SurUbvBundle\Entity\CargaAcademica $cargaAcademica)
    {
        $this->cargaAcademica = $cargaAcademica;

        return $this;
    }

    /**
     * Get cargaAcademica
     *
     * @return \UBV\SurUbvBundle\Entity\CargaAcademica 
     */
    public function getCargaAcademica()
    {
        return $this->cargaAcademica;
    }
}
