<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * UBV\SurUbvBundle\Entity\LineaInvestigacion
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\LineaInvestigacionRepository")
 * @ORM\Table(name="linea_investigacion", indexes={@ORM\Index(name="fk_linea_investigacion_programa1_idx", columns={"programa_id"})}, uniqueConstraints={@ORM\UniqueConstraint(name="codigo_linea_investigacion_UNIQUE", columns={"codigo"}), @ORM\UniqueConstraint(name="id_linea_investigacion_UNIQUE", columns={"id"})})
 */
class LineaInvestigacion
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="linea_investigacion_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="string", length=45)
     */
    protected $descripcion;

    /**
     * @ORM\Column(type="string", length=5)
     */
    protected $codigo;

    /**
     * @ORM\Column(type="string", length=255)
     */
    protected $especificacion;

    /**
     * @ORM\ManyToOne(targetEntity="Programa", inversedBy="lineaInvestigacions")
     * @ORM\JoinColumn(name="programa_id", referencedColumnName="id", nullable=false)
     */
    protected $programa;

    public function __construct()
    {
    }

    public function __sleep()
    {
        return array('id', 'descripcion', 'codigo', 'especificacion', 'programa_id');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set descripcion
     *
     * @param string $descripcion
     * @return LineaInvestigacion
     */
    public function setDescripcion($descripcion)
    {
        $this->descripcion = $descripcion;

        return $this;
    }

    /**
     * Get descripcion
     *
     * @return string 
     */
    public function getDescripcion()
    {
        return $this->descripcion;
    }

    /**
     * Set codigo
     *
     * @param string $codigo
     * @return LineaInvestigacion
     */
    public function setCodigo($codigo)
    {
        $this->codigo = $codigo;

        return $this;
    }

    /**
     * Get codigo
     *
     * @return string 
     */
    public function getCodigo()
    {
        return $this->codigo;
    }

    /**
     * Set especificacion
     *
     * @param string $especificacion
     * @return LineaInvestigacion
     */
    public function setEspecificacion($especificacion)
    {
        $this->especificacion = $especificacion;

        return $this;
    }

    /**
     * Get especificacion
     *
     * @return string 
     */
    public function getEspecificacion()
    {
        return $this->especificacion;
    }

    /**
     * Set programa
     *
     * @param \UBV\SurUbvBundle\Entity\Programa $programa
     * @return LineaInvestigacion
     */
    public function setPrograma(\UBV\SurUbvBundle\Entity\Programa $programa)
    {
        $this->programa = $programa;

        return $this;
    }

    /**
     * Get programa
     *
     * @return \UBV\SurUbvBundle\Entity\Programa 
     */
    public function getPrograma()
    {
        return $this->programa;
    }
}
