<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * UBV\SurUbvBundle\Entity\MallaCurricular
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\MallaCurricularRepository")
 * @ORM\Table(name="malla_curricular", indexes={@ORM\Index(name="fk_malla_curricular_malla_modalidad1_idx", columns={"malla_modalidad_id"}), @ORM\Index(name="fk_malla_curricular_programa1_idx", columns={"programa_id"})}, uniqueConstraints={@ORM\UniqueConstraint(name="id_malla_curricular_UNIQUE", columns={"id"})})
 */
class MallaCurricular
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="malla_curricular_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="string", length=150)
     */
    protected $descripcion;

    /**
     * @ORM\Column(type="string", length=15)
     */
    protected $codigo;

    /**
     * @ORM\Column(type="boolean")
     */
    protected $salida_intermedia;

    /**
     * @ORM\OneToMany(targetEntity="AldeaMallaCurricula", mappedBy="mallaCurricular")
     * @ORM\JoinColumn(name="id", referencedColumnName="malla_curricular_id", nullable=false)
     */
    protected $aldeaMallaCurriculas;

    /**
     * @ORM\OneToMany(targetEntity="MallaCurricularDetalle", mappedBy="mallaCurricular")
     * @ORM\JoinColumn(name="id", referencedColumnName="malla_curricular_id", nullable=false)
     */
    protected $mallaCurricularDetalles;

    /**
     * @ORM\OneToMany(targetEntity="RequisitoGrado", mappedBy="mallaCurricular")
     * @ORM\JoinColumn(name="id", referencedColumnName="malla_curricular_id", nullable=false)
     */
    protected $requisitoGrados;

    /**
     * @ORM\ManyToOne(targetEntity="ModalidadMalla", inversedBy="mallaCurriculars")
     * @ORM\JoinColumn(name="malla_modalidad_id", referencedColumnName="id", nullable=false)
     */
    protected $modalidadMalla;

    /**
     * @ORM\ManyToOne(targetEntity="Programa", inversedBy="mallaCurriculars")
     * @ORM\JoinColumn(name="programa_id", referencedColumnName="id", nullable=false)
     */
    protected $programa;

    public function __construct()
    {
        $this->aldeaMallaCurriculas = new ArrayCollection();
        $this->mallaCurricularDetalles = new ArrayCollection();
        $this->requisitoGrados = new ArrayCollection();
    }

    public function __sleep()
    {
        return array('id', 'descripcion', 'codigo', 'salida_intermedia', 'malla_modalidad_id', 'programa_id');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set descripcion
     *
     * @param string $descripcion
     * @return MallaCurricular
     */
    public function setDescripcion($descripcion)
    {
        $this->descripcion = $descripcion;

        return $this;
    }

    /**
     * Get descripcion
     *
     * @return string 
     */
    public function getDescripcion()
    {
        return $this->descripcion;
    }

    /**
     * Set codigo
     *
     * @param string $codigo
     * @return MallaCurricular
     */
    public function setCodigo($codigo)
    {
        $this->codigo = $codigo;

        return $this;
    }

    /**
     * Get codigo
     *
     * @return string 
     */
    public function getCodigo()
    {
        return $this->codigo;
    }

    /**
     * Set salida_intermedia
     *
     * @param boolean $salidaIntermedia
     * @return MallaCurricular
     */
    public function setSalidaIntermedia($salidaIntermedia)
    {
        $this->salida_intermedia = $salidaIntermedia;

        return $this;
    }

    /**
     * Get salida_intermedia
     *
     * @return boolean 
     */
    public function getSalidaIntermedia()
    {
        return $this->salida_intermedia;
    }

    /**
     * Add aldeaMallaCurriculas
     *
     * @param \UBV\SurUbvBundle\Entity\AldeaMallaCurricula $aldeaMallaCurriculas
     * @return MallaCurricular
     */
    public function addAldeaMallaCurricula(\UBV\SurUbvBundle\Entity\AldeaMallaCurricula $aldeaMallaCurriculas)
    {
        $this->aldeaMallaCurriculas[] = $aldeaMallaCurriculas;

        return $this;
    }

    /**
     * Remove aldeaMallaCurriculas
     *
     * @param \UBV\SurUbvBundle\Entity\AldeaMallaCurricula $aldeaMallaCurriculas
     */
    public function removeAldeaMallaCurricula(\UBV\SurUbvBundle\Entity\AldeaMallaCurricula $aldeaMallaCurriculas)
    {
        $this->aldeaMallaCurriculas->removeElement($aldeaMallaCurriculas);
    }

    /**
     * Get aldeaMallaCurriculas
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getAldeaMallaCurriculas()
    {
        return $this->aldeaMallaCurriculas;
    }

    /**
     * Add mallaCurricularDetalles
     *
     * @param \UBV\SurUbvBundle\Entity\MallaCurricularDetalle $mallaCurricularDetalles
     * @return MallaCurricular
     */
    public function addMallaCurricularDetalle(\UBV\SurUbvBundle\Entity\MallaCurricularDetalle $mallaCurricularDetalles)
    {
        $this->mallaCurricularDetalles[] = $mallaCurricularDetalles;

        return $this;
    }

    /**
     * Remove mallaCurricularDetalles
     *
     * @param \UBV\SurUbvBundle\Entity\MallaCurricularDetalle $mallaCurricularDetalles
     */
    public function removeMallaCurricularDetalle(\UBV\SurUbvBundle\Entity\MallaCurricularDetalle $mallaCurricularDetalles)
    {
        $this->mallaCurricularDetalles->removeElement($mallaCurricularDetalles);
    }

    /**
     * Get mallaCurricularDetalles
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getMallaCurricularDetalles()
    {
        return $this->mallaCurricularDetalles;
    }

    /**
     * Add requisitoGrados
     *
     * @param \UBV\SurUbvBundle\Entity\RequisitoGrado $requisitoGrados
     * @return MallaCurricular
     */
    public function addRequisitoGrado(\UBV\SurUbvBundle\Entity\RequisitoGrado $requisitoGrados)
    {
        $this->requisitoGrados[] = $requisitoGrados;

        return $this;
    }

    /**
     * Remove requisitoGrados
     *
     * @param \UBV\SurUbvBundle\Entity\RequisitoGrado $requisitoGrados
     */
    public function removeRequisitoGrado(\UBV\SurUbvBundle\Entity\RequisitoGrado $requisitoGrados)
    {
        $this->requisitoGrados->removeElement($requisitoGrados);
    }

    /**
     * Get requisitoGrados
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getRequisitoGrados()
    {
        return $this->requisitoGrados;
    }

    /**
     * Set modalidadMalla
     *
     * @param \UBV\SurUbvBundle\Entity\ModalidadMalla $modalidadMalla
     * @return MallaCurricular
     */
    public function setModalidadMalla(\UBV\SurUbvBundle\Entity\ModalidadMalla $modalidadMalla)
    {
        $this->modalidadMalla = $modalidadMalla;

        return $this;
    }

    /**
     * Get modalidadMalla
     *
     * @return \UBV\SurUbvBundle\Entity\ModalidadMalla 
     */
    public function getModalidadMalla()
    {
        return $this->modalidadMalla;
    }

    /**
     * Set programa
     *
     * @param \UBV\SurUbvBundle\Entity\Programa $programa
     * @return MallaCurricular
     */
    public function setPrograma(\UBV\SurUbvBundle\Entity\Programa $programa)
    {
        $this->programa = $programa;

        return $this;
    }

    /**
     * Get programa
     *
     * @return \UBV\SurUbvBundle\Entity\Programa 
     */
    public function getPrograma()
    {
        return $this->programa;
    }
}
