<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * UBV\SurUbvBundle\Entity\MallaCurricularDetalle
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\MallaCurricularDetalleRepository")
 * @ORM\Table(name="malla_curricular_detalle", indexes={@ORM\Index(name="fk_malla_curricular_detalle_tramo1_idx", columns={"tramo_id"}), @ORM\Index(name="fk_malla_curricular_detalle_malla_curricular1_idx", columns={"malla_curricular_id"}), @ORM\Index(name="fk_malla_curricular_detalle_trayecto1_idx", columns={"trayecto_id"}), @ORM\Index(name="fk_malla_curricular_detalle_unidad_curricular_detalle1_idx", columns={"unidad_curricular_detalle_id"})}, uniqueConstraints={@ORM\UniqueConstraint(name="id_malla_curricular_detalle_UNIQUE", columns={"id"})})
 */
class MallaCurricularDetalle
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="malla_curricular_detalle_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="integer", nullable=true)
     */
    protected $cantidad_tramo;

    /**
     * @ORM\OneToMany(targetEntity="Competencia", mappedBy="mallaCurricularDetalleRelatedByMallaCurricularDetalleId")
     * @ORM\JoinColumn(name="id", referencedColumnName="malla_curricular_detalle_id", nullable=false)
     */
    protected $competenciaRelatedByMallaCurricularDetalleIds;

    /**
     * @ORM\OneToMany(targetEntity="Competencia", mappedBy="mallaCurricularDetalleRelatedByMallaCurricularDetalleId1")
     * @ORM\JoinColumn(name="id", referencedColumnName="malla_curricular_detalle_id1", nullable=false)
     */
    protected $competenciaRelatedByMallaCurricularDetalleId1s;

    /**
     * @ORM\OneToMany(targetEntity="OfertaAcademicaDetalle", mappedBy="mallaCurricularDetalle")
     * @ORM\JoinColumn(name="id", referencedColumnName="malla_curricular_detalle_id", nullable=false)
     */
    protected $ofertaAcademicaDetalles;

    /**
     * @ORM\ManyToOne(targetEntity="Tramo", inversedBy="mallaCurricularDetalles")
     * @ORM\JoinColumn(name="tramo_id", referencedColumnName="id", nullable=false)
     */
    protected $tramo;

    /**
     * @ORM\ManyToOne(targetEntity="MallaCurricular", inversedBy="mallaCurricularDetalles")
     * @ORM\JoinColumn(name="malla_curricular_id", referencedColumnName="id", nullable=false)
     */
    protected $mallaCurricular;

    /**
     * @ORM\ManyToOne(targetEntity="Trayecto", inversedBy="mallaCurricularDetalles")
     * @ORM\JoinColumn(name="trayecto_id", referencedColumnName="id", nullable=false)
     */
    protected $trayecto;

    /**
     * @ORM\ManyToOne(targetEntity="UnidadCurricularDetalle", inversedBy="mallaCurricularDetalles")
     * @ORM\JoinColumn(name="unidad_curricular_detalle_id", referencedColumnName="id", nullable=false)
     */
    protected $unidadCurricularDetalle;

    public function __construct()
    {
        $this->competenciaRelatedByMallaCurricularDetalleIds = new ArrayCollection();
        $this->competenciaRelatedByMallaCurricularDetalleId1s = new ArrayCollection();
        $this->ofertaAcademicaDetalles = new ArrayCollection();
    }

    public function __sleep()
    {
        return array('id', 'cantidad_tramo', 'tramo_id', 'malla_curricular_id', 'trayecto_id', 'unidad_curricular_detalle_id');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set cantidad_tramo
     *
     * @param integer $cantidadTramo
     * @return MallaCurricularDetalle
     */
    public function setCantidadTramo($cantidadTramo)
    {
        $this->cantidad_tramo = $cantidadTramo;

        return $this;
    }

    /**
     * Get cantidad_tramo
     *
     * @return integer 
     */
    public function getCantidadTramo()
    {
        return $this->cantidad_tramo;
    }

    /**
     * Add competenciaRelatedByMallaCurricularDetalleIds
     *
     * @param \UBV\SurUbvBundle\Entity\Competencia $competenciaRelatedByMallaCurricularDetalleIds
     * @return MallaCurricularDetalle
     */
    public function addCompetenciaRelatedByMallaCurricularDetalleId(\UBV\SurUbvBundle\Entity\Competencia $competenciaRelatedByMallaCurricularDetalleIds)
    {
        $this->competenciaRelatedByMallaCurricularDetalleIds[] = $competenciaRelatedByMallaCurricularDetalleIds;

        return $this;
    }

    /**
     * Remove competenciaRelatedByMallaCurricularDetalleIds
     *
     * @param \UBV\SurUbvBundle\Entity\Competencia $competenciaRelatedByMallaCurricularDetalleIds
     */
    public function removeCompetenciaRelatedByMallaCurricularDetalleId(\UBV\SurUbvBundle\Entity\Competencia $competenciaRelatedByMallaCurricularDetalleIds)
    {
        $this->competenciaRelatedByMallaCurricularDetalleIds->removeElement($competenciaRelatedByMallaCurricularDetalleIds);
    }

    /**
     * Get competenciaRelatedByMallaCurricularDetalleIds
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getCompetenciaRelatedByMallaCurricularDetalleIds()
    {
        return $this->competenciaRelatedByMallaCurricularDetalleIds;
    }

    /**
     * Add competenciaRelatedByMallaCurricularDetalleId1s
     *
     * @param \UBV\SurUbvBundle\Entity\Competencia $competenciaRelatedByMallaCurricularDetalleId1s
     * @return MallaCurricularDetalle
     */
    public function addCompetenciaRelatedByMallaCurricularDetalleId1(\UBV\SurUbvBundle\Entity\Competencia $competenciaRelatedByMallaCurricularDetalleId1s)
    {
        $this->competenciaRelatedByMallaCurricularDetalleId1s[] = $competenciaRelatedByMallaCurricularDetalleId1s;

        return $this;
    }

    /**
     * Remove competenciaRelatedByMallaCurricularDetalleId1s
     *
     * @param \UBV\SurUbvBundle\Entity\Competencia $competenciaRelatedByMallaCurricularDetalleId1s
     */
    public function removeCompetenciaRelatedByMallaCurricularDetalleId1(\UBV\SurUbvBundle\Entity\Competencia $competenciaRelatedByMallaCurricularDetalleId1s)
    {
        $this->competenciaRelatedByMallaCurricularDetalleId1s->removeElement($competenciaRelatedByMallaCurricularDetalleId1s);
    }

    /**
     * Get competenciaRelatedByMallaCurricularDetalleId1s
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getCompetenciaRelatedByMallaCurricularDetalleId1s()
    {
        return $this->competenciaRelatedByMallaCurricularDetalleId1s;
    }

    /**
     * Add ofertaAcademicaDetalles
     *
     * @param \UBV\SurUbvBundle\Entity\OfertaAcademicaDetalle $ofertaAcademicaDetalles
     * @return MallaCurricularDetalle
     */
    public function addOfertaAcademicaDetalle(\UBV\SurUbvBundle\Entity\OfertaAcademicaDetalle $ofertaAcademicaDetalles)
    {
        $this->ofertaAcademicaDetalles[] = $ofertaAcademicaDetalles;

        return $this;
    }

    /**
     * Remove ofertaAcademicaDetalles
     *
     * @param \UBV\SurUbvBundle\Entity\OfertaAcademicaDetalle $ofertaAcademicaDetalles
     */
    public function removeOfertaAcademicaDetalle(\UBV\SurUbvBundle\Entity\OfertaAcademicaDetalle $ofertaAcademicaDetalles)
    {
        $this->ofertaAcademicaDetalles->removeElement($ofertaAcademicaDetalles);
    }

    /**
     * Get ofertaAcademicaDetalles
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getOfertaAcademicaDetalles()
    {
        return $this->ofertaAcademicaDetalles;
    }

    /**
     * Set tramo
     *
     * @param \UBV\SurUbvBundle\Entity\Tramo $tramo
     * @return MallaCurricularDetalle
     */
    public function setTramo(\UBV\SurUbvBundle\Entity\Tramo $tramo)
    {
        $this->tramo = $tramo;

        return $this;
    }

    /**
     * Get tramo
     *
     * @return \UBV\SurUbvBundle\Entity\Tramo 
     */
    public function getTramo()
    {
        return $this->tramo;
    }

    /**
     * Set mallaCurricular
     *
     * @param \UBV\SurUbvBundle\Entity\MallaCurricular $mallaCurricular
     * @return MallaCurricularDetalle
     */
    public function setMallaCurricular(\UBV\SurUbvBundle\Entity\MallaCurricular $mallaCurricular)
    {
        $this->mallaCurricular = $mallaCurricular;

        return $this;
    }

    /**
     * Get mallaCurricular
     *
     * @return \UBV\SurUbvBundle\Entity\MallaCurricular 
     */
    public function getMallaCurricular()
    {
        return $this->mallaCurricular;
    }

    /**
     * Set trayecto
     *
     * @param \UBV\SurUbvBundle\Entity\Trayecto $trayecto
     * @return MallaCurricularDetalle
     */
    public function setTrayecto(\UBV\SurUbvBundle\Entity\Trayecto $trayecto)
    {
        $this->trayecto = $trayecto;

        return $this;
    }

    /**
     * Get trayecto
     *
     * @return \UBV\SurUbvBundle\Entity\Trayecto 
     */
    public function getTrayecto()
    {
        return $this->trayecto;
    }

    /**
     * Set unidadCurricularDetalle
     *
     * @param \UBV\SurUbvBundle\Entity\UnidadCurricularDetalle $unidadCurricularDetalle
     * @return MallaCurricularDetalle
     */
    public function setUnidadCurricularDetalle(\UBV\SurUbvBundle\Entity\UnidadCurricularDetalle $unidadCurricularDetalle)
    {
        $this->unidadCurricularDetalle = $unidadCurricularDetalle;

        return $this;
    }

    /**
     * Get unidadCurricularDetalle
     *
     * @return \UBV\SurUbvBundle\Entity\UnidadCurricularDetalle 
     */
    public function getUnidadCurricularDetalle()
    {
        return $this->unidadCurricularDetalle;
    }
}
