<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * UBV\SurUbvBundle\Entity\ModalidadMalla
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\ModalidadMallaRepository")
 * @ORM\Table(name="modalidad_malla", uniqueConstraints={@ORM\UniqueConstraint(name="id_modalidad_UNIQUE", columns={"id"})})
 */
class ModalidadMalla
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="modalidad_malla_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="string", length=45)
     */
    protected $descripcion;

    /**
     * @ORM\OneToMany(targetEntity="MallaCurricular", mappedBy="modalidadMalla")
     * @ORM\JoinColumn(name="id", referencedColumnName="malla_modalidad_id", nullable=false)
     */
    protected $mallaCurriculars;

    public function __construct()
    {
        $this->mallaCurriculars = new ArrayCollection();
    }

    public function __sleep()
    {
        return array('id', 'descripcion');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set descripcion
     *
     * @param string $descripcion
     * @return ModalidadMalla
     */
    public function setDescripcion($descripcion)
    {
        $this->descripcion = $descripcion;

        return $this;
    }

    /**
     * Get descripcion
     *
     * @return string 
     */
    public function getDescripcion()
    {
        return $this->descripcion;
    }

    /**
     * Add mallaCurriculars
     *
     * @param \UBV\SurUbvBundle\Entity\MallaCurricular $mallaCurriculars
     * @return ModalidadMalla
     */
    public function addMallaCurricular(\UBV\SurUbvBundle\Entity\MallaCurricular $mallaCurriculars)
    {
        $this->mallaCurriculars[] = $mallaCurriculars;

        return $this;
    }

    /**
     * Remove mallaCurriculars
     *
     * @param \UBV\SurUbvBundle\Entity\MallaCurricular $mallaCurriculars
     */
    public function removeMallaCurricular(\UBV\SurUbvBundle\Entity\MallaCurricular $mallaCurriculars)
    {
        $this->mallaCurriculars->removeElement($mallaCurriculars);
    }

    /**
     * Get mallaCurriculars
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getMallaCurriculars()
    {
        return $this->mallaCurriculars;
    }
}
