<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * UBV\SurUbvBundle\Entity\Nacionalidad
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\NacionalidadRepository")
 * @ORM\Table(name="nacionalidad", indexes={@ORM\Index(name="fk_nacionalidad_pais1_idx", columns={"pais_id"})}, uniqueConstraints={@ORM\UniqueConstraint(name="id_nacionalidad_UNIQUE", columns={"id"})})
 */
class Nacionalidad
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="nacionalidad_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="string", length=45)
     */
    protected $descripcion;

    /**
     * @ORM\OneToMany(targetEntity="PersonaNacionalidad", mappedBy="nacionalidad")
     * @ORM\JoinColumn(name="id", referencedColumnName="nacionalidad_id", nullable=false)
     */
    protected $personaNacionalidads;

    /**
     * @ORM\OneToOne(targetEntity="Pais", inversedBy="nacionalidad")
     * @ORM\JoinColumn(name="pais_id", referencedColumnName="id", nullable=false)
     */
    protected $pais;

    public function __construct()
    {
        $this->personaNacionalidads = new ArrayCollection();
    }

    public function __sleep()
    {
        return array('id', 'descripcion', 'pais_id');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set descripcion
     *
     * @param string $descripcion
     * @return Nacionalidad
     */
    public function setDescripcion($descripcion)
    {
        $this->descripcion = $descripcion;

        return $this;
    }

    /**
     * Get descripcion
     *
     * @return string 
     */
    public function getDescripcion()
    {
        return $this->descripcion;
    }

    /**
     * Add personaNacionalidads
     *
     * @param \UBV\SurUbvBundle\Entity\PersonaNacionalidad $personaNacionalidads
     * @return Nacionalidad
     */
    public function addPersonaNacionalidad(\UBV\SurUbvBundle\Entity\PersonaNacionalidad $personaNacionalidads)
    {
        $this->personaNacionalidads[] = $personaNacionalidads;

        return $this;
    }

    /**
     * Remove personaNacionalidads
     *
     * @param \UBV\SurUbvBundle\Entity\PersonaNacionalidad $personaNacionalidads
     */
    public function removePersonaNacionalidad(\UBV\SurUbvBundle\Entity\PersonaNacionalidad $personaNacionalidads)
    {
        $this->personaNacionalidads->removeElement($personaNacionalidads);
    }

    /**
     * Get personaNacionalidads
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getPersonaNacionalidads()
    {
        return $this->personaNacionalidads;
    }

    /**
     * Set pais
     *
     * @param \UBV\SurUbvBundle\Entity\Pais $pais
     * @return Nacionalidad
     */
    public function setPais(\UBV\SurUbvBundle\Entity\Pais $pais)
    {
        $this->pais = $pais;

        return $this;
    }

    /**
     * Get pais
     *
     * @return \UBV\SurUbvBundle\Entity\Pais 
     */
    public function getPais()
    {
        return $this->pais;
    }
				
				public function __toString(){
						return $this->getDescripcion();
				}
}
