<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * UBV\SurUbvBundle\Entity\NivelAcademico
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\NivelAcademicoRepository")
 * @ORM\Table(name="nivel_academico", uniqueConstraints={@ORM\UniqueConstraint(name="id_nivel_academico_UNIQUE", columns={"id"})})
 */
class NivelAcademico
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="nivel_academico_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="string", length=70)
     */
    protected $descripcion;

    /**
     * @ORM\OneToMany(targetEntity="GradoAcademico", mappedBy="nivelAcademico")
     * @ORM\JoinColumn(name="id", referencedColumnName="nivel_academico_id", nullable=false)
     */
    protected $gradoAcademicos;
    
    /**
     * @ORM\OneToMany(targetEntity="Programa", mappedBy="nivelAcademico")
     * @ORM\JoinColumn(name="id", referencedColumnName="nivel_academico_id", nullable=false)
     */
    protected $programas;

    public function __construct()
    {
        $this->gradoAcademicos = new ArrayCollection();
        $this->programas = new ArrayCollection();
    }

    public function __sleep()
    {
        return array('id', 'descripcion');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set descripcion
     *
     * @param string $descripcion
     * @return NivelAcademico
     */
    public function setDescripcion($descripcion)
    {
        $this->descripcion = $descripcion;

        return $this;
    }

    /**
     * Get descripcion
     *
     * @return string 
     */
    public function getDescripcion()
    {
        return $this->descripcion;
    }

    /**
     * Add gradoAcademicos
     *
     * @param \UBV\SurUbvBundle\Entity\GradoAcademico $gradoAcademicos
     * @return NivelAcademico
     */
    public function addGradoAcademico(\UBV\SurUbvBundle\Entity\GradoAcademico $gradoAcademicos)
    {
        $this->gradoAcademicos[] = $gradoAcademicos;

        return $this;
    }

    /**
     * Remove gradoAcademicos
     *
     * @param \UBV\SurUbvBundle\Entity\GradoAcademico $gradoAcademicos
     */
    public function removeGradoAcademico(\UBV\SurUbvBundle\Entity\GradoAcademico $gradoAcademicos)
    {
        $this->gradoAcademicos->removeElement($gradoAcademicos);
    }

    /**
     * Get gradoAcademicos
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getGradoAcademicos()
    {
        return $this->gradoAcademicos;
    }

    /**
     * Add programas
     *
     * @param \UBV\SurUbvBundle\Entity\Programa $programas
     * @return NivelAcademico
     */
    public function addPrograma(\UBV\SurUbvBundle\Entity\Programa $programas)
    {
        $this->programas[] = $programas;

        return $this;
    }

    /**
     * Remove programas
     *
     * @param \UBV\SurUbvBundle\Entity\Programa $programas
     */
    public function removePrograma(\UBV\SurUbvBundle\Entity\Programa $programas)
    {
        $this->programas->removeElement($programas);
    }

    /**
     * Get programas
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getProgramas()
    {
        return $this->programas;
    }
}
