<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * UBV\SurUbvBundle\Entity\OfertaAcademica
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\OfertaAcademicaRepository")
 * @ORM\Table(name="oferta_academica", indexes={@ORM\Index(name="fk_oferta_academica_periodo_academico1_idx", columns={"periodo_academico_id"}), @ORM\Index(name="fk_oferta_academica_aldea_malla_curricula1_idx", columns={"aldea_malla_curricula_id"})}, uniqueConstraints={@ORM\UniqueConstraint(name="id_oferta_academica_UNIQUE", columns={"id"})})
 */
class OfertaAcademica
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="oferta_academica_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="boolean")
     */
    protected $estatus;

    /**
     * @ORM\OneToMany(targetEntity="OfertaAcademicaDetalle", mappedBy="ofertaAcademica")
     * @ORM\JoinColumn(name="id", referencedColumnName="oferta_academica_id", nullable=false)
     */
    protected $ofertaAcademicaDetalles;

    /**
     * @ORM\OneToMany(targetEntity="Seccion", mappedBy="ofertaAcademica")
     * @ORM\JoinColumn(name="id", referencedColumnName="oferta_academica_id", nullable=false)
     */
    protected $seccions;

    /**
     * @ORM\ManyToOne(targetEntity="PeriodoAcademico", inversedBy="ofertaAcademicas")
     * @ORM\JoinColumn(name="periodo_academico_id", referencedColumnName="id", nullable=false)
     */
    protected $periodoAcademico;

    /**
     * @ORM\ManyToOne(targetEntity="AldeaMallaCurricula", inversedBy="ofertaAcademicas")
     * @ORM\JoinColumn(name="aldea_malla_curricula_id", referencedColumnName="id", nullable=false)
     */
    protected $aldeaMallaCurricula;

    public function __construct()
    {
        $this->ofertaAcademicaDetalles = new ArrayCollection();
        $this->seccions = new ArrayCollection();
    }

    public function __sleep()
    {
        return array('id', 'periodo_academico_id', 'aldea_malla_curricula_id', 'estatus');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set estatus
     *
     * @param boolean $estatus
     * @return OfertaAcademica
     */
    public function setEstatus($estatus)
    {
        $this->estatus = $estatus;

        return $this;
    }

    /**
     * Get estatus
     *
     * @return boolean 
     */
    public function getEstatus()
    {
        return $this->estatus;
    }

    /**
     * Add ofertaAcademicaDetalles
     *
     * @param \UBV\SurUbvBundle\Entity\OfertaAcademicaDetalle $ofertaAcademicaDetalles
     * @return OfertaAcademica
     */
    public function addOfertaAcademicaDetalle(\UBV\SurUbvBundle\Entity\OfertaAcademicaDetalle $ofertaAcademicaDetalles)
    {
        $this->ofertaAcademicaDetalles[] = $ofertaAcademicaDetalles;

        return $this;
    }

    /**
     * Remove ofertaAcademicaDetalles
     *
     * @param \UBV\SurUbvBundle\Entity\OfertaAcademicaDetalle $ofertaAcademicaDetalles
     */
    public function removeOfertaAcademicaDetalle(\UBV\SurUbvBundle\Entity\OfertaAcademicaDetalle $ofertaAcademicaDetalles)
    {
        $this->ofertaAcademicaDetalles->removeElement($ofertaAcademicaDetalles);
    }

    /**
     * Get ofertaAcademicaDetalles
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getOfertaAcademicaDetalles()
    {
        return $this->ofertaAcademicaDetalles;
    }

    /**
     * Add seccions
     *
     * @param \UBV\SurUbvBundle\Entity\Seccion $seccions
     * @return OfertaAcademica
     */
    public function addSeccion(\UBV\SurUbvBundle\Entity\Seccion $seccions)
    {
        $this->seccions[] = $seccions;

        return $this;
    }

    /**
     * Remove seccions
     *
     * @param \UBV\SurUbvBundle\Entity\Seccion $seccions
     */
    public function removeSeccion(\UBV\SurUbvBundle\Entity\Seccion $seccions)
    {
        $this->seccions->removeElement($seccions);
    }

    /**
     * Get seccions
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getSeccions()
    {
        return $this->seccions;
    }

    /**
     * Set periodoAcademico
     *
     * @param \UBV\SurUbvBundle\Entity\PeriodoAcademico $periodoAcademico
     * @return OfertaAcademica
     */
    public function setPeriodoAcademico(\UBV\SurUbvBundle\Entity\PeriodoAcademico $periodoAcademico)
    {
        $this->periodoAcademico = $periodoAcademico;

        return $this;
    }

    /**
     * Get periodoAcademico
     *
     * @return \UBV\SurUbvBundle\Entity\PeriodoAcademico 
     */
    public function getPeriodoAcademico()
    {
        return $this->periodoAcademico;
    }

    /**
     * Set aldeaMallaCurricula
     *
     * @param \UBV\SurUbvBundle\Entity\AldeaMallaCurricula $aldeaMallaCurricula
     * @return OfertaAcademica
     */
    public function setAldeaMallaCurricula(\UBV\SurUbvBundle\Entity\AldeaMallaCurricula $aldeaMallaCurricula)
    {
        $this->aldeaMallaCurricula = $aldeaMallaCurricula;

        return $this;
    }

    /**
     * Get aldeaMallaCurricula
     *
     * @return \UBV\SurUbvBundle\Entity\AldeaMallaCurricula 
     */
    public function getAldeaMallaCurricula()
    {
        return $this->aldeaMallaCurricula;
    }
}
