<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * UBV\SurUbvBundle\Entity\OfertaAcademicaDetalle
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\OfertaAcademicaDetalleRepository")
 * @ORM\Table(name="oferta_academica_detalle", indexes={@ORM\Index(name="fk_oferta_academica_detalle_oferta_academica1_idx", columns={"oferta_academica_id"}), @ORM\Index(name="fk_oferta_academica_detalle_malla_curricular_detalle1_idx", columns={"malla_curricular_detalle_id"})}, uniqueConstraints={@ORM\UniqueConstraint(name="id_oferta_academica_detalle_UNIQUE", columns={"id"})})
 */
class OfertaAcademicaDetalle
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="oferta_academica_detalle_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\OneToMany(targetEntity="CargaAcademica", mappedBy="ofertaAcademicaDetalle")
     * @ORM\JoinColumn(name="id", referencedColumnName="oferta_academica_detalle_id", nullable=false)
     */
    protected $cargaAcademicas;

    /**
     * @ORM\ManyToOne(targetEntity="OfertaAcademica", inversedBy="ofertaAcademicaDetalles")
     * @ORM\JoinColumn(name="oferta_academica_id", referencedColumnName="id", nullable=false)
     */
    protected $ofertaAcademica;

    /**
     * @ORM\ManyToOne(targetEntity="MallaCurricularDetalle", inversedBy="ofertaAcademicaDetalles")
     * @ORM\JoinColumn(name="malla_curricular_detalle_id", referencedColumnName="id", nullable=false)
     */
    protected $mallaCurricularDetalle;

    public function __construct()
    {
        $this->cargaAcademicas = new ArrayCollection();
    }

    public function __sleep()
    {
        return array('id', 'oferta_academica_id', 'malla_curricular_detalle_id');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Add cargaAcademicas
     *
     * @param \UBV\SurUbvBundle\Entity\CargaAcademica $cargaAcademicas
     * @return OfertaAcademicaDetalle
     */
    public function addCargaAcademica(\UBV\SurUbvBundle\Entity\CargaAcademica $cargaAcademicas)
    {
        $this->cargaAcademicas[] = $cargaAcademicas;

        return $this;
    }

    /**
     * Remove cargaAcademicas
     *
     * @param \UBV\SurUbvBundle\Entity\CargaAcademica $cargaAcademicas
     */
    public function removeCargaAcademica(\UBV\SurUbvBundle\Entity\CargaAcademica $cargaAcademicas)
    {
        $this->cargaAcademicas->removeElement($cargaAcademicas);
    }

    /**
     * Get cargaAcademicas
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getCargaAcademicas()
    {
        return $this->cargaAcademicas;
    }

    /**
     * Set ofertaAcademica
     *
     * @param \UBV\SurUbvBundle\Entity\OfertaAcademica $ofertaAcademica
     * @return OfertaAcademicaDetalle
     */
    public function setOfertaAcademica(\UBV\SurUbvBundle\Entity\OfertaAcademica $ofertaAcademica)
    {
        $this->ofertaAcademica = $ofertaAcademica;

        return $this;
    }

    /**
     * Get ofertaAcademica
     *
     * @return \UBV\SurUbvBundle\Entity\OfertaAcademica 
     */
    public function getOfertaAcademica()
    {
        return $this->ofertaAcademica;
    }

    /**
     * Set mallaCurricularDetalle
     *
     * @param \UBV\SurUbvBundle\Entity\MallaCurricularDetalle $mallaCurricularDetalle
     * @return OfertaAcademicaDetalle
     */
    public function setMallaCurricularDetalle(\UBV\SurUbvBundle\Entity\MallaCurricularDetalle $mallaCurricularDetalle)
    {
        $this->mallaCurricularDetalle = $mallaCurricularDetalle;

        return $this;
    }

    /**
     * Get mallaCurricularDetalle
     *
     * @return \UBV\SurUbvBundle\Entity\MallaCurricularDetalle 
     */
    public function getMallaCurricularDetalle()
    {
        return $this->mallaCurricularDetalle;
    }
}
