<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * UBV\SurUbvBundle\Entity\Pais
 *
 * @ORM\Entity()
 * @ORM\Table(name="pais", uniqueConstraints={@ORM\UniqueConstraint(name="id_pais_UNIQUE", columns={"id"})})
 */
class Pais
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="pais_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="string", length=70)
     */
    protected $descripcion;

    /**
     * @ORM\Column(type="string", length=45, nullable=true)
     */
    protected $codigo;

    /**
     * @ORM\OneToMany(targetEntity="Estado", mappedBy="pais")
     * @ORM\JoinColumn(name="id", referencedColumnName="pais_id", nullable=false)
     */
    protected $estados;

    /**
     * @ORM\OneToOne(targetEntity="Nacionalidad", mappedBy="pais")
     */
    protected $nacionalidad;

    /**
     * @ORM\OneToMany(targetEntity="Persona", mappedBy="pais")
     * @ORM\JoinColumn(name="id", referencedColumnName="pais_id", nullable=false)
     */
    protected $personas;

    public function __construct()
    {
        $this->estados = new ArrayCollection();
        $this->nacionalidads = new ArrayCollection();
        $this->personas = new ArrayCollection();
    }

    public function __sleep()
    {
        return array('id', 'descripcion', 'codigo');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set descripcion
     *
     * @param string $descripcion
     * @return Pais
     */
    public function setDescripcion($descripcion)
    {
        $this->descripcion = $descripcion;

        return $this;
    }

    /**
     * Get descripcion
     *
     * @return string 
     */
    public function getDescripcion()
    {
        return $this->descripcion;
    }

    /**
     * Set codigo
     *
     * @param string $codigo
     * @return Pais
     */
    public function setCodigo($codigo)
    {
        $this->codigo = $codigo;

        return $this;
    }

    /**
     * Get codigo
     *
     * @return string 
     */
    public function getCodigo()
    {
        return $this->codigo;
    }

    /**
     * Add estados
     *
     * @param \UBV\SurUbvBundle\Entity\Estado $estados
     * @return Pais
     */
    public function addEstado(\UBV\SurUbvBundle\Entity\Estado $estados)
    {
        $this->estados[] = $estados;

        return $this;
    }

    /**
     * Remove estados
     *
     * @param \UBV\SurUbvBundle\Entity\Estado $estados
     */
    public function removeEstado(\UBV\SurUbvBundle\Entity\Estado $estados)
    {
        $this->estados->removeElement($estados);
    }

    /**
     * Get estados
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getEstados()
    {
        return $this->estados;
    }

    /**
     * Set nacionalidad
     *
     * @param \UBV\SurUbvBundle\Entity\Nacionalidad $nacionalidad
     * @return Pais
     */
    public function setNacionalidad(\UBV\SurUbvBundle\Entity\Nacionalidad $nacionalidad = null)
    {
        $this->nacionalidad = $nacionalidad;

        return $this;
    }

    /**
     * Get nacionalidad
     *
     * @return \UBV\SurUbvBundle\Entity\Nacionalidad 
     */
    public function getNacionalidad()
    {
        return $this->nacionalidad;
    }

    /**
     * Add personas
     *
     * @param \UBV\SurUbvBundle\Entity\Persona $personas
     * @return Pais
     */
    public function addPersona(\UBV\SurUbvBundle\Entity\Persona $personas)
    {
        $this->personas[] = $personas;

        return $this;
    }

    /**
     * Remove personas
     *
     * @param \UBV\SurUbvBundle\Entity\Persona $personas
     */
    public function removePersona(\UBV\SurUbvBundle\Entity\Persona $personas)
    {
        $this->personas->removeElement($personas);
    }

    /**
     * Get personas
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getPersonas()
    {
        return $this->personas;
    }
				
				public function __toString()
    {
        return $this->getDescripcion();
    }
}
