<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * UBV\SurUbvBundle\Entity\PeriodoEstatus
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\PeriodoEstatusRepository")
 * @ORM\Table(name="periodo_estatus")
 */
class PeriodoEstatus
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="periodo_estatus_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="string", length=45)
     */
    protected $descripcion;

    /**
     * @ORM\Column(type="boolean")
     */
    protected $estatus;

    /**
     * @ORM\OneToMany(targetEntity="PeriodoAcademico", mappedBy="periodoEstatus")
     * @ORM\JoinColumn(name="id", referencedColumnName="periodo_estatus_id", nullable=false)
     */
    protected $periodoAcademicos;

    public function __construct()
    {
        $this->periodoAcademicos = new ArrayCollection();
    }

    public function __sleep()
    {
        return array('id', 'descripcion', 'estatus');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set descripcion
     *
     * @param string $descripcion
     * @return PeriodoEstatus
     */
    public function setDescripcion($descripcion)
    {
        $this->descripcion = $descripcion;

        return $this;
    }

    /**
     * Get descripcion
     *
     * @return string 
     */
    public function getDescripcion()
    {
        return $this->descripcion;
    }

    /**
     * Set estatus
     *
     * @param boolean $estatus
     * @return PeriodoEstatus
     */
    public function setEstatus($estatus)
    {
        $this->estatus = $estatus;

        return $this;
    }

    /**
     * Get estatus
     *
     * @return boolean 
     */
    public function getEstatus()
    {
        return $this->estatus;
    }

    /**
     * Add periodoAcademicos
     *
     * @param \UBV\SurUbvBundle\Entity\PeriodoAcademico $periodoAcademicos
     * @return PeriodoEstatus
     */
    public function addPeriodoAcademico(\UBV\SurUbvBundle\Entity\PeriodoAcademico $periodoAcademicos)
    {
        $this->periodoAcademicos[] = $periodoAcademicos;

        return $this;
    }

    /**
     * Remove periodoAcademicos
     *
     * @param \UBV\SurUbvBundle\Entity\PeriodoAcademico $periodoAcademicos
     */
    public function removePeriodoAcademico(\UBV\SurUbvBundle\Entity\PeriodoAcademico $periodoAcademicos)
    {
        $this->periodoAcademicos->removeElement($periodoAcademicos);
    }

    /**
     * Get periodoAcademicos
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getPeriodoAcademicos()
    {
        return $this->periodoAcademicos;
    }
    
    public function __toString() {
      return $this->getDescripcion();
    }
}
