<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;
/**
 * UBV\SurUbvBundle\Entity\PersonaCorreo
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\PersonaCorreoRepository")
 * @ORM\Table(name="persona_correo", indexes={@ORM\Index(name="fk_persona_correo_persona1_idx", columns={"persona_id"}), @ORM\Index(name="fk_persona_correo_correo_tipo1_idx", columns={"correo_tipo_id"})}, uniqueConstraints={@ORM\UniqueConstraint(name="id_persona_correo_UNIQUE", columns={"id"})})
 */
class PersonaCorreo
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="persona_correo_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="string", length=50)
     * @Assert\NotNull(message= "Por favor introduzca un correo electrónico", groups={"Default"})
     * @Assert\NotBlank( message= "Por favor introduzca un correo electrónico", groups={"Default"})
     * @Assert\Email(
     *     message = "El correo'{{ value }}' no es valido.",
     * )
     */
    protected $correo;

    /**
     * @ORM\ManyToOne(targetEntity="Persona", inversedBy="personaCorreos")
     * @ORM\JoinColumn(name="persona_id", referencedColumnName="id", nullable=false)
     */
    protected $persona;

    /**
     * @ORM\ManyToOne(targetEntity="CorreoTipo", inversedBy="personaCorreos")
     * @ORM\JoinColumn(name="correo_tipo_id", referencedColumnName="id", nullable=false)
     */
    protected $correoTipo;

    public function __construct()
    {
    }

    public function __sleep()
    {
        return array('id', 'correo', 'persona_id', 'correo_tipo_id');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set correo
     *
     * @param string $correo
     * @return PersonaCorreo
     */
    public function setCorreo($correo)
    {
        $this->correo = $correo;

        return $this;
    }

    /**
     * Get correo
     *
     * @return string 
     */
    public function getCorreo()
    {
        return $this->correo;
    }

    /**
     * Set persona
     *
     * @param \UBV\SurUbvBundle\Entity\Persona $persona
     * @return PersonaCorreo
     */
    public function setPersona(\UBV\SurUbvBundle\Entity\Persona $persona)
    {
        $this->persona = $persona;

        return $this;
    }

    /**
     * Get persona
     *
     * @return \UBV\SurUbvBundle\Entity\Persona 
     */
    public function getPersona()
    {
        return $this->persona;
    }

    /**
     * Set correoTipo
     *
     * @param \UBV\SurUbvBundle\Entity\CorreoTipo $correoTipo
     * @return PersonaCorreo
     */
    public function setCorreoTipo(\UBV\SurUbvBundle\Entity\CorreoTipo $correoTipo)
    {
        $this->correoTipo = $correoTipo;

        return $this;
    }

    /**
     * Get correoTipo
     *
     * @return \UBV\SurUbvBundle\Entity\CorreoTipo 
     */
    public function getCorreoTipo()
    {
        return $this->correoTipo;
    }
}
