<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * UBV\SurUbvBundle\Entity\PersonaDiscapacidad
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\PersonaDiscapacidadRepository")
 * @ORM\Table(name="persona_discapacidad", indexes={@ORM\Index(name="fk_persona_has_discapacidad_discapacidad1_idx", columns={"discapacidad_id"}), @ORM\Index(name="fk_persona_has_discapacidad_persona1_idx", columns={"persona_id"})}, uniqueConstraints={@ORM\UniqueConstraint(name="codigo_conapdis_UNIQUE", columns={"codigo_conapdis"}), @ORM\UniqueConstraint(name="id_persona_discapacidad_UNIQUE", columns={"id"})})
 */
class PersonaDiscapacidad
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="persona_discapacidad_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="string", length=10)
     */
    protected $codigo_conapdis;
    
    /**
     * @ORM\Column(type="string", length=45, nullable=true)
     */
    protected $observacion;

    /**
     * @ORM\ManyToOne(targetEntity="Persona", inversedBy="personaDiscapacidads")
     * @ORM\JoinColumn(name="persona_id", referencedColumnName="id", nullable=false)
     */
    protected $persona;

    /**
     * @ORM\ManyToOne(targetEntity="Discapacidad", inversedBy="personaDiscapacidads")
     * @ORM\JoinColumn(name="discapacidad_id", referencedColumnName="id", nullable=false)
     */
    protected $discapacidad;

    public function __construct()
    {
    }

    public function __sleep()
    {
        return array('id', 'persona_id', 'discapacidad_id', 'codigo_conapdis');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set codigo_conapdis
     *
     * @param string $codigoConapdis
     * @return PersonaDiscapacidad
     */
    public function setCodigoConapdis($codigoConapdis)
    {
        $this->codigo_conapdis = $codigoConapdis;

        return $this;
    }

    /**
     * Get codigo_conapdis
     *
     * @return string 
     */
    public function getCodigoConapdis()
    {
        return $this->codigo_conapdis;
    }

    /**
     * Set persona
     *
     * @param \UBV\SurUbvBundle\Entity\Persona $persona
     * @return PersonaDiscapacidad
     */
    public function setPersona(\UBV\SurUbvBundle\Entity\Persona $persona)
    {
        $this->persona = $persona;

        return $this;
    }

    /**
     * Get persona
     *
     * @return \UBV\SurUbvBundle\Entity\Persona 
     */
    public function getPersona()
    {
        return $this->persona;
    }

    /**
     * Set discapacidad
     *
     * @param \UBV\SurUbvBundle\Entity\Discapacidad $discapacidad
     * @return PersonaDiscapacidad
     */
    public function setDiscapacidad(\UBV\SurUbvBundle\Entity\Discapacidad $discapacidad)
    {
        $this->discapacidad = $discapacidad;

        return $this;
    }

    /**
     * Get discapacidad
     *
     * @return \UBV\SurUbvBundle\Entity\Discapacidad 
     */
    public function getDiscapacidad()
    {
        return $this->discapacidad;
    }

    /**
     * Set observacion
     *
     * @param string $observacion
     * @return PersonaDiscapacidad
     */
    public function setObservacion($observacion)
    {
        $this->observacion = $observacion;

        return $this;
    }

    /**
     * Get observacion
     *
     * @return string 
     */
    public function getObservacion()
    {
        return $this->observacion;
    }
}
