<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * UBV\SurUbvBundle\Entity\PersonaEtnia
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\PersonaEtniaRepository")
 * @ORM\Table(name="persona_etnia", indexes={@ORM\Index(name="fk_persona_etnia_persona1_idx", columns={"persona_id"}), @ORM\Index(name="fk_persona_etnia_etnia1_idx", columns={"etnia_id"})}, uniqueConstraints={@ORM\UniqueConstraint(name="id_persona_etnia_UNIQUE", columns={"id"})})
 */
class PersonaEtnia
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="persona_etnia_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\ManyToOne(targetEntity="Persona", inversedBy="personaEtnias")
     * @ORM\JoinColumn(name="persona_id", referencedColumnName="id", nullable=false)
     */
    protected $persona;

    /**
     * @ORM\ManyToOne(targetEntity="Etnia", inversedBy="personaEtnias")
     * @ORM\JoinColumn(name="etnia_id", referencedColumnName="id", nullable=false)
     */
    protected $etnia;

    public function __construct()
    {
    }

    public function __sleep()
    {
        return array('id', 'persona_id', 'etnia_id');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set persona
     *
     * @param \UBV\SurUbvBundle\Entity\Persona $persona
     * @return PersonaEtnia
     */
    public function setPersona(\UBV\SurUbvBundle\Entity\Persona $persona)
    {
        $this->persona = $persona;

        return $this;
    }

    /**
     * Get persona
     *
     * @return \UBV\SurUbvBundle\Entity\Persona 
     */
    public function getPersona()
    {
        return $this->persona;
    }

    /**
     * Set etnia
     *
     * @param \UBV\SurUbvBundle\Entity\Etnia $etnia
     * @return PersonaEtnia
     */
    public function setEtnia(\UBV\SurUbvBundle\Entity\Etnia $etnia)
    {
        $this->etnia = $etnia;

        return $this;
    }

    /**
     * Get etnia
     *
     * @return \UBV\SurUbvBundle\Entity\Etnia 
     */
    public function getEtnia()
    {
        return $this->etnia;
    }
}
