<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;
/**
 * UBV\SurUbvBundle\Entity\PersonaNacionalidad
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\PersonaNacionalidadRepository")
 * @ORM\Table(name="persona_nacionalidad", indexes={@ORM\Index(name="fk_persona_nacionalidad_nacionalidad1_idx", columns={"nacionalidad_id"}), @ORM\Index(name="fk_persona_nacionalidad_documento_identidad_tipo1_idx", columns={"documento_identidad_tipo_id"}), @ORM\Index(name="fk_persona_nacionalidad_persona1_idx", columns={"persona_id"})}, uniqueConstraints={@ORM\UniqueConstraint(name="id_persona_nacionalidad_UNIQUE", columns={"id"})})
 */
class PersonaNacionalidad
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="persona_nacionalidad_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @Assert\NotBlank()
     * @Assert\Type("integer", groups={"Default"})
     * @Assert\Range(min=1)
     * @ORM\Column(type="integer")
     */
    protected $identificacion;

    /**
     * @ORM\Column(type="boolean", nullable=true)
     */
    protected $estatus;

    /**
     * @ORM\ManyToOne(targetEntity="Nacionalidad", inversedBy="personaNacionalidads")
     * @ORM\JoinColumn(name="nacionalidad_id", referencedColumnName="id", nullable=false)
     */
    protected $nacionalidad;

    /**
     * @ORM\ManyToOne(targetEntity="DocumentoIdentidadTipo", inversedBy="personaNacionalidads")
     * @ORM\JoinColumn(name="documento_identidad_tipo_id", referencedColumnName="id", nullable=false)
     */
    protected $documentoIdentidadTipo;

    /**
     * @ORM\ManyToOne(targetEntity="Persona", inversedBy="personaNacionalidads")
     * @ORM\JoinColumn(name="persona_id", referencedColumnName="id", nullable=false)
     */
    protected $persona;

    public function __construct()
    {
    }

    public function __sleep()
    {
        return array('id', 'identificacion', 'estatus', 'nacionalidad_id', 'documento_identidad_tipo_id', 'persona_id');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set identificacion
     *
     * @param integer $identificacion
     * @return PersonaNacionalidad
     */
    public function setIdentificacion($identificacion)
    {
        $this->identificacion = $identificacion;

        return $this;
    }

    /**
     * Get identificacion
     *
     * @return integer 
     */
    public function getIdentificacion()
    {
        return $this->identificacion;
    }

    /**
     * Set estatus
     *
     * @param boolean $estatus
     * @return PersonaNacionalidad
     */
    public function setEstatus($estatus)
    {
        $this->estatus = $estatus;

        return $this;
    }

    /**
     * Get estatus
     *
     * @return boolean 
     */
    public function getEstatus()
    {
        return $this->estatus;
    }

    /**
     * Set nacionalidad
     *
     * @param \UBV\SurUbvBundle\Entity\Nacionalidad $nacionalidad
     * @return PersonaNacionalidad
     */
    public function setNacionalidad(\UBV\SurUbvBundle\Entity\Nacionalidad $nacionalidad)
    {
        $this->nacionalidad = $nacionalidad;

        return $this;
    }

    /**
     * Get nacionalidad
     *
     * @return \UBV\SurUbvBundle\Entity\Nacionalidad 
     */
    public function getNacionalidad()
    {
        return $this->nacionalidad;
    }

    /**
     * Set documentoIdentidadTipo
     *
     * @param \UBV\SurUbvBundle\Entity\DocumentoIdentidadTipo $documentoIdentidadTipo
     * @return PersonaNacionalidad
     */
    public function setDocumentoIdentidadTipo(\UBV\SurUbvBundle\Entity\DocumentoIdentidadTipo $documentoIdentidadTipo)
    {
        $this->documentoIdentidadTipo = $documentoIdentidadTipo;

        return $this;
    }

    /**
     * Get documentoIdentidadTipo
     *
     * @return \UBV\SurUbvBundle\Entity\DocumentoIdentidadTipo 
     */
    public function getDocumentoIdentidadTipo()
    {
        return $this->documentoIdentidadTipo;
    }

    /**
     * Set persona
     *
     * @param \UBV\SurUbvBundle\Entity\Persona $persona
     * @return PersonaNacionalidad
     */
    public function setPersona(\UBV\SurUbvBundle\Entity\Persona $persona)
    {
        $this->persona = $persona;

        return $this;
    }

    /**
     * Get persona
     *
     * @return \UBV\SurUbvBundle\Entity\Persona 
     */
    public function getPersona()
    {
        return $this->persona;
    }
}
