<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;

/**
 * UBV\SurUbvBundle\Entity\PersonaTelefono
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\PersonaTelefonoRepository")
 * @ORM\Table(name="persona_telefono", indexes={@ORM\Index(name="fk_persona_telefono_telefono_codigo_area1_idx", columns={"telefono_codigo_area_id"}), @ORM\Index(name="fk_persona_telefono_persona1_idx", columns={"persona_id"})}, uniqueConstraints={@ORM\UniqueConstraint(name="id_persona_telefono_UNIQUE", columns={"id"})})
 */
class PersonaTelefono
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="persona_telefono_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="string", length=7)
     * @Assert\NotNull(message= "Número telefonico Invalido", groups={"Default"})
     * @Assert\NotBlank( message= "Número telefonico Invalido", groups={"Default"})
     */
    protected $telefono;

    /**
     * @ORM\ManyToOne(targetEntity="TelefonoCodigoArea", inversedBy="personaTelefonos")
     * @ORM\JoinColumn(name="telefono_codigo_area_id", referencedColumnName="id", nullable=false)
     */
    protected $telefonoCodigoArea;

    /**
     * @ORM\ManyToOne(targetEntity="Persona", inversedBy="personaTelefonos")
     * @ORM\JoinColumn(name="persona_id", referencedColumnName="id", nullable=false)
     */
    protected $persona;

    public function __construct()
    {
    }

    public function __sleep()
    {
        return array('id', 'telefono', 'telefono_codigo_area_id', 'persona_id');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set telefono
     *
     * @param string $telefono
     * @return PersonaTelefono
     */
    public function setTelefono($telefono)
    {
        $this->telefono = $telefono;

        return $this;
    }

    /**
     * Get telefono
     *
     * @return string 
     */
    public function getTelefono()
    {
        return $this->telefono;
    }

    /**
     * Set telefonoCodigoArea
     *
     * @param \UBV\SurUbvBundle\Entity\TelefonoCodigoArea $telefonoCodigoArea
     * @return PersonaTelefono
     */
    public function setTelefonoCodigoArea(\UBV\SurUbvBundle\Entity\TelefonoCodigoArea $telefonoCodigoArea)
    {
        $this->telefonoCodigoArea = $telefonoCodigoArea;

        return $this;
    }

    /**
     * Get telefonoCodigoArea
     *
     * @return \UBV\SurUbvBundle\Entity\TelefonoCodigoArea 
     */
    public function getTelefonoCodigoArea()
    {
        return $this->telefonoCodigoArea;
    }

    /**
     * Set persona
     *
     * @param \UBV\SurUbvBundle\Entity\Persona $persona
     * @return PersonaTelefono
     */
    public function setPersona(\UBV\SurUbvBundle\Entity\Persona $persona)
    {
        $this->persona = $persona;

        return $this;
    }

    /**
     * Get persona
     *
     * @return \UBV\SurUbvBundle\Entity\Persona 
     */
    public function getPersona()
    {
        return $this->persona;
    }
}
