<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * UBV\SurUbvBundle\Entity\PersonalAdministrativo
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\PersonalAdministrativoRepository")
 * @ORM\Table(name="personal_administrativo", indexes={@ORM\Index(name="fk_personal_administrativo_persona1_idx", columns={"persona_id"}), @ORM\Index(name="fk_personal_administrativo_unidad_administrativa1_idx", columns={"unidad_administrativa_id"})}, uniqueConstraints={@ORM\UniqueConstraint(name="id_personal_administrativo_UNIQUE", columns={"id"})})
 */
class PersonalAdministrativo
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="personal_administrativo_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\ManyToOne(targetEntity="Persona", inversedBy="personalAdministrativos")
     * @ORM\JoinColumn(name="persona_id", referencedColumnName="id", nullable=false)
     */
    protected $persona;

    /**
     * @ORM\ManyToOne(targetEntity="UnidadAdministrativa", inversedBy="personalAdministrativos")
     * @ORM\JoinColumn(name="unidad_administrativa_id", referencedColumnName="id", nullable=false)
     */
    protected $unidadAdministrativa;

    public function __construct()
    {
    }

    public function __sleep()
    {
        return array('id', 'persona_id', 'unidad_administrativa_id');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set persona
     *
     * @param \UBV\SurUbvBundle\Entity\Persona $persona
     * @return PersonalAdministrativo
     */
    public function setPersona(\UBV\SurUbvBundle\Entity\Persona $persona)
    {
        $this->persona = $persona;

        return $this;
    }

    /**
     * Get persona
     *
     * @return \UBV\SurUbvBundle\Entity\Persona 
     */
    public function getPersona()
    {
        return $this->persona;
    }

    /**
     * Set unidadAdministrativa
     *
     * @param \UBV\SurUbvBundle\Entity\UnidadAdministrativa $unidadAdministrativa
     * @return PersonalAdministrativo
     */
    public function setUnidadAdministrativa(\UBV\SurUbvBundle\Entity\UnidadAdministrativa $unidadAdministrativa)
    {
        $this->unidadAdministrativa = $unidadAdministrativa;

        return $this;
    }

    /**
     * Get unidadAdministrativa
     *
     * @return \UBV\SurUbvBundle\Entity\UnidadAdministrativa 
     */
    public function getUnidadAdministrativa()
    {
        return $this->unidadAdministrativa;
    }
}
