<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * UBV\SurUbvBundle\Entity\ProgramaNivel
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\ProgramaNivelRepository")
 * @ORM\Table(name="programa_nivel", uniqueConstraints={@ORM\UniqueConstraint(name="codigo_programa_nivel_UNIQUE", columns={"codigo"}), @ORM\UniqueConstraint(name="id_programa_nivel_UNIQUE", columns={"id"})})
 */
class ProgramaNivel
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="programa_nivel_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="string", length=45)
     */
    protected $descripcion;

    /**
     * @ORM\Column(type="boolean")
     */
    protected $estatus;

    /**
     * @ORM\Column(type="string", length=45, nullable=true)
     */
    protected $codigo;

    /**
     * @ORM\OneToMany(targetEntity="ProgramaTipo", mappedBy="programaNivel")
     * @ORM\JoinColumn(name="id", referencedColumnName="programa_nivel_id", nullable=false)
     */
    protected $programaTipos;

    public function __construct()
    {
        $this->programaTipos = new ArrayCollection();
    }

    public function __sleep()
    {
        return array('id', 'descripcion', 'estatus', 'codigo');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set descripcion
     *
     * @param string $descripcion
     * @return ProgramaNivel
     */
    public function setDescripcion($descripcion)
    {
        $this->descripcion = $descripcion;

        return $this;
    }

    /**
     * Get descripcion
     *
     * @return string 
     */
    public function getDescripcion()
    {
        return $this->descripcion;
    }

    /**
     * Set estatus
     *
     * @param boolean $estatus
     * @return ProgramaNivel
     */
    public function setEstatus($estatus)
    {
        $this->estatus = $estatus;

        return $this;
    }

    /**
     * Get estatus
     *
     * @return boolean 
     */
    public function getEstatus()
    {
        return $this->estatus;
    }

    /**
     * Set codigo
     *
     * @param string $codigo
     * @return ProgramaNivel
     */
    public function setCodigo($codigo)
    {
        $this->codigo = $codigo;

        return $this;
    }

    /**
     * Get codigo
     *
     * @return string 
     */
    public function getCodigo()
    {
        return $this->codigo;
    }

    /**
     * Add programaTipos
     *
     * @param \UBV\SurUbvBundle\Entity\ProgramaTipo $programaTipos
     * @return ProgramaNivel
     */
    public function addProgramaTipo(\UBV\SurUbvBundle\Entity\ProgramaTipo $programaTipos)
    {
        $this->programaTipos[] = $programaTipos;

        return $this;
    }

    /**
     * Remove programaTipos
     *
     * @param \UBV\SurUbvBundle\Entity\ProgramaTipo $programaTipos
     */
    public function removeProgramaTipo(\UBV\SurUbvBundle\Entity\ProgramaTipo $programaTipos)
    {
        $this->programaTipos->removeElement($programaTipos);
    }

    /**
     * Get programaTipos
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getProgramaTipos()
    {
        return $this->programaTipos;
    }
    
public function __toString()
    {
      return $this->getDescripcion();
    }
}
