<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * UBV\SurUbvBundle\Entity\ProgramaTipo
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\ProgramaTipoRepository")
 * @ORM\Table(name="programa_tipo", uniqueConstraints={@ORM\UniqueConstraint(name="codigo_programa_tipo_UNIQUE", columns={"codigo"}), @ORM\UniqueConstraint(name="id_programa_tipo_UNIQUE", columns={"id"})})
 */
class ProgramaTipo
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="programa_tipo_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="string", length=70)
     */
    protected $descripcion;

    /**
     * @ORM\Column(type="string", length=15)
     */
    protected $codigo;

    /**
     * @ORM\OneToMany(targetEntity="Programa", mappedBy="programaTipo")
     * @ORM\JoinColumn(name="id", referencedColumnName="programa_tipo_id", nullable=false)
     */
    protected $programas;
    
    /**
     * @ORM\ManyToOne(targetEntity="ProgramaNivel", inversedBy="programaTipos")
     * @ORM\JoinColumn(name="programa_nivel_id", referencedColumnName="id", nullable=false)
     */
    protected $programaNivel;

    public function __construct()
    {
        $this->programas = new ArrayCollection();
    }

    public function __sleep()
    {
        return array('id', 'descripcion', 'codigo', 'programa_nivel_id');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set descripcion
     *
     * @param string $descripcion
     * @return ProgramaTipo
     */
    public function setDescripcion($descripcion)
    {
        $this->descripcion = $descripcion;

        return $this;
    }

    /**
     * Get descripcion
     *
     * @return string 
     */
    public function getDescripcion()
    {
        return $this->descripcion;
    }

    /**
     * Set codigo
     *
     * @param string $codigo
     * @return ProgramaTipo
     */
    public function setCodigo($codigo)
    {
        $this->codigo = $codigo;

        return $this;
    }

    /**
     * Remove programas
     *
     * @param \UBV\SurUbvBundle\Entity\Programa $programas
     */
    public function removePrograma(\UBV\SurUbvBundle\Entity\Programa $programas)
    {
        $this->programas->removeElement($programas);
    }
    
    public function __toString()
    {
        return $this->getDescripcion()." - (".$this->codigo.")";
    }

    /**
     * Set programaNivel
     *
     * @param \UBV\SurUbvBundle\Entity\ProgramaNivel $programaNivel
     * @return ProgramaTipo
     */
    public function setProgramaNivel(\UBV\SurUbvBundle\Entity\ProgramaNivel $programaNivel)
    {
        $this->programaNivel = $programaNivel;

        return $this;
    }

    /**
     * Get programaNivel
     *
     * @return \UBV\SurUbvBundle\Entity\ProgramaNivel 
     */
    public function getProgramaNivel()
    {
        return $this->programaNivel;
    }

    /**
     * Get codigo
     *
     * @return string 
     */
    public function getCodigo()
    {
        return $this->codigo;
    }

    /**
     * Add programas
     *
     * @param \UBV\SurUbvBundle\Entity\Programa $programas
     * @return ProgramaTipo
     */
    public function addPrograma(\UBV\SurUbvBundle\Entity\Programa $programas)
    {
        $this->programas[] = $programas;

        return $this;
    }

    /**
     * Get programas
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getProgramas()
    {
        return $this->programas;
    }

    /**
     * Add requisitoInscripcions
     *
     * @param \UBV\SurUbvBundle\Entity\RequisitoInscripcion $requisitoInscripcions
     * @return ProgramaTipo
     */
    public function addRequisitoInscripcion(\UBV\SurUbvBundle\Entity\RequisitoInscripcion $requisitoInscripcions)
    {
        $this->requisitoInscripcions[] = $requisitoInscripcions;

        return $this;
    }

    /**
     * Remove requisitoInscripcions
     *
     * @param \UBV\SurUbvBundle\Entity\RequisitoInscripcion $requisitoInscripcions
     */
    public function removeRequisitoInscripcion(\UBV\SurUbvBundle\Entity\RequisitoInscripcion $requisitoInscripcions)
    {
        $this->requisitoInscripcions->removeElement($requisitoInscripcions);
    }

    /**
     * Get requisitoInscripcions
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getRequisitoInscripcions()
    {
        return $this->requisitoInscripcions;
    }
}
