<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * UBV\SurUbvBundle\Entity\RequisitoGrado
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\RequisitoGradoRepository")
 * @ORM\Table(name="requisito_grado", indexes={@ORM\Index(name="fk_requisito_grado_malla_curricular1_idx", columns={"malla_curricular_id"}), @ORM\Index(name="fk_requisito_grado_trayecto1_idx", columns={"trayecto_id"}), @ORM\Index(name="fk_requisito_grado_tramo1_idx", columns={"tramo_id"}), @ORM\Index(name="fk_requisito_grado_grado_academico1_idx", columns={"grado_academico_id"})}, uniqueConstraints={@ORM\UniqueConstraint(name="id_requeisito_grado_UNIQUE", columns={"id"})})
 */
class RequisitoGrado
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="requisito_grado_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="string", length=70)
     */
    protected $descripcion_titulo;

    /**
     * @ORM\ManyToOne(targetEntity="MallaCurricular", inversedBy="requisitoGrados")
     * @ORM\JoinColumn(name="malla_curricular_id", referencedColumnName="id", nullable=false)
     */
    protected $mallaCurricular;

    /**
     * @ORM\ManyToOne(targetEntity="Trayecto", inversedBy="requisitoGrados")
     * @ORM\JoinColumn(name="trayecto_id", referencedColumnName="id", nullable=false)
     */
    protected $trayecto;

    /**
     * @ORM\ManyToOne(targetEntity="Tramo", inversedBy="requisitoGrados")
     * @ORM\JoinColumn(name="tramo_id", referencedColumnName="id", nullable=false)
     */
    protected $tramo;

    /**
     * @ORM\ManyToOne(targetEntity="GradoAcademico", inversedBy="requisitoGrados")
     * @ORM\JoinColumn(name="grado_academico_id", referencedColumnName="id", nullable=false)
     */
    protected $gradoAcademico;

    public function __construct()
    {
    }

    public function __sleep()
    {
        return array('id', 'descripcion_titulo', 'malla_curricular_id', 'trayecto_id', 'tramo_id', 'grado_academico_id');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set descripcion_titulo
     *
     * @param string $descripcionTitulo
     * @return RequisitoGrado
     */
    public function setDescripcionTitulo($descripcionTitulo)
    {
        $this->descripcion_titulo = $descripcionTitulo;

        return $this;
    }

    /**
     * Get descripcion_titulo
     *
     * @return string 
     */
    public function getDescripcionTitulo()
    {
        return $this->descripcion_titulo;
    }

    /**
     * Set mallaCurricular
     *
     * @param \UBV\SurUbvBundle\Entity\MallaCurricular $mallaCurricular
     * @return RequisitoGrado
     */
    public function setMallaCurricular(\UBV\SurUbvBundle\Entity\MallaCurricular $mallaCurricular)
    {
        $this->mallaCurricular = $mallaCurricular;

        return $this;
    }

    /**
     * Get mallaCurricular
     *
     * @return \UBV\SurUbvBundle\Entity\MallaCurricular 
     */
    public function getMallaCurricular()
    {
        return $this->mallaCurricular;
    }

    /**
     * Set trayecto
     *
     * @param \UBV\SurUbvBundle\Entity\Trayecto $trayecto
     * @return RequisitoGrado
     */
    public function setTrayecto(\UBV\SurUbvBundle\Entity\Trayecto $trayecto)
    {
        $this->trayecto = $trayecto;

        return $this;
    }

    /**
     * Get trayecto
     *
     * @return \UBV\SurUbvBundle\Entity\Trayecto 
     */
    public function getTrayecto()
    {
        return $this->trayecto;
    }

    /**
     * Set tramo
     *
     * @param \UBV\SurUbvBundle\Entity\Tramo $tramo
     * @return RequisitoGrado
     */
    public function setTramo(\UBV\SurUbvBundle\Entity\Tramo $tramo)
    {
        $this->tramo = $tramo;

        return $this;
    }

    /**
     * Get tramo
     *
     * @return \UBV\SurUbvBundle\Entity\Tramo 
     */
    public function getTramo()
    {
        return $this->tramo;
    }

    /**
     * Set gradoAcademico
     *
     * @param \UBV\SurUbvBundle\Entity\GradoAcademico $gradoAcademico
     * @return RequisitoGrado
     */
    public function setGradoAcademico(\UBV\SurUbvBundle\Entity\GradoAcademico $gradoAcademico)
    {
        $this->gradoAcademico = $gradoAcademico;

        return $this;
    }

    /**
     * Get gradoAcademico
     *
     * @return \UBV\SurUbvBundle\Entity\GradoAcademico 
     */
    public function getGradoAcademico()
    {
        return $this->gradoAcademico;
    }
}
