<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * UBV\SurUbvBundle\Entity\Seccion
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\SeccionRepository")
 * @ORM\Table(name="seccion", indexes={@ORM\Index(name="fk_seccion_trayecto1_idx", columns={"trayecto_id"}), @ORM\Index(name="fk_seccion_tramo1_idx", columns={"tramo_id"}), @ORM\Index(name="fk_seccion_oferta_academica1_idx", columns={"oferta_academica_id"})}, uniqueConstraints={@ORM\UniqueConstraint(name="id_seccion_UNIQUE", columns={"id"})})
 */
class Seccion
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="seccion_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="string", length=45)
     */
    protected $descripcion;

    /**
     * @ORM\OneToMany(targetEntity="CargaAcademica", mappedBy="seccion")
     * @ORM\JoinColumn(name="id", referencedColumnName="seccion_id", nullable=false)
     */
    protected $cargaAcademicas;

    /**
     * @ORM\ManyToOne(targetEntity="Trayecto", inversedBy="seccions")
     * @ORM\JoinColumn(name="trayecto_id", referencedColumnName="id", nullable=false)
     */
    protected $trayecto;

    /**
     * @ORM\ManyToOne(targetEntity="Tramo", inversedBy="seccions")
     * @ORM\JoinColumn(name="tramo_id", referencedColumnName="id", nullable=false)
     */
    protected $tramo;

    /**
     * @ORM\ManyToOne(targetEntity="OfertaAcademica", inversedBy="seccions")
     * @ORM\JoinColumn(name="oferta_academica_id", referencedColumnName="id", nullable=false)
     */
    protected $ofertaAcademica;

    public function __construct()
    {
        $this->cargaAcademicas = new ArrayCollection();
    }

    public function __sleep()
    {
        return array('id', 'descripcion', 'trayecto_id', 'tramo_id', 'oferta_academica_id');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set descripcion
     *
     * @param string $descripcion
     * @return Seccion
     */
    public function setDescripcion($descripcion)
    {
        $this->descripcion = $descripcion;

        return $this;
    }

    /**
     * Get descripcion
     *
     * @return string 
     */
    public function getDescripcion()
    {
        return $this->descripcion;
    }

    /**
     * Add cargaAcademicas
     *
     * @param \UBV\SurUbvBundle\Entity\CargaAcademica $cargaAcademicas
     * @return Seccion
     */
    public function addCargaAcademica(\UBV\SurUbvBundle\Entity\CargaAcademica $cargaAcademicas)
    {
        $this->cargaAcademicas[] = $cargaAcademicas;

        return $this;
    }

    /**
     * Remove cargaAcademicas
     *
     * @param \UBV\SurUbvBundle\Entity\CargaAcademica $cargaAcademicas
     */
    public function removeCargaAcademica(\UBV\SurUbvBundle\Entity\CargaAcademica $cargaAcademicas)
    {
        $this->cargaAcademicas->removeElement($cargaAcademicas);
    }

    /**
     * Get cargaAcademicas
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getCargaAcademicas()
    {
        return $this->cargaAcademicas;
    }

    /**
     * Set trayecto
     *
     * @param \UBV\SurUbvBundle\Entity\Trayecto $trayecto
     * @return Seccion
     */
    public function setTrayecto(\UBV\SurUbvBundle\Entity\Trayecto $trayecto)
    {
        $this->trayecto = $trayecto;

        return $this;
    }

    /**
     * Get trayecto
     *
     * @return \UBV\SurUbvBundle\Entity\Trayecto 
     */
    public function getTrayecto()
    {
        return $this->trayecto;
    }

    /**
     * Set tramo
     *
     * @param \UBV\SurUbvBundle\Entity\Tramo $tramo
     * @return Seccion
     */
    public function setTramo(\UBV\SurUbvBundle\Entity\Tramo $tramo)
    {
        $this->tramo = $tramo;

        return $this;
    }

    /**
     * Get tramo
     *
     * @return \UBV\SurUbvBundle\Entity\Tramo 
     */
    public function getTramo()
    {
        return $this->tramo;
    }

    /**
     * Set ofertaAcademica
     *
     * @param \UBV\SurUbvBundle\Entity\OfertaAcademica $ofertaAcademica
     * @return Seccion
     */
    public function setOfertaAcademica(\UBV\SurUbvBundle\Entity\OfertaAcademica $ofertaAcademica)
    {
        $this->ofertaAcademica = $ofertaAcademica;

        return $this;
    }

    /**
     * Get ofertaAcademica
     *
     * @return \UBV\SurUbvBundle\Entity\OfertaAcademica 
     */
    public function getOfertaAcademica()
    {
        return $this->ofertaAcademica;
    }
}
