<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * UBV\SurUbvBundle\Entity\TelefonoCodigoArea
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\TelefonoCodigoAreaRepository")
 * @ORM\Table(name="telefono_codigo_area", indexes={@ORM\Index(name="fk_telefono_codigo_area_telefono_tipo1_idx", columns={"telefono_tipo_id"})}, uniqueConstraints={@ORM\UniqueConstraint(name="id_telefono_codigo_area_UNIQUE", columns={"id"})})
 */
class TelefonoCodigoArea
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="telefono_codigo_area_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="string", length=10)
     */
    protected $descripcion;

    /**
     * @ORM\OneToMany(targetEntity="AldeaTelefono", mappedBy="telefonoCodigoArea")
     * @ORM\JoinColumn(name="id", referencedColumnName="telefono_codigo_area_id", nullable=false)
     */
    protected $aldeaTelefonos;

    /**
     * @ORM\OneToMany(targetEntity="PersonaTelefono", mappedBy="telefonoCodigoArea")
     * @ORM\JoinColumn(name="id", referencedColumnName="telefono_codigo_area_id", nullable=false)
     */
    protected $personaTelefonos;
    
    /**
     * @ORM\OneToMany(targetEntity="Candidato", mappedBy="telefonoCodigoArea")
     * @ORM\JoinColumn(name="id", referencedColumnName="telefono_codigo_area_id", nullable=false)
     */
    protected $candidatos;

    /**
     * @ORM\OneToMany(targetEntity="UnidadAdministrativaTelefono", mappedBy="telefonoCodigoArea")
     * @ORM\JoinColumn(name="id", referencedColumnName="telefono_codigo_area_id", nullable=false)
     */
    protected $unidadAdministrativaTelefonos;

    /**
     * @ORM\ManyToOne(targetEntity="TelefonoTipo", inversedBy="telefonoCodigoAreas")
     * @ORM\JoinColumn(name="telefono_tipo_id", referencedColumnName="id", nullable=false)
     */
    protected $telefonoTipo;

    public function __construct()
    {
        $this->aldeaTelefonos = new ArrayCollection();
        $this->personaTelefonos = new ArrayCollection();
        $this->unidadAdministrativaTelefonos = new ArrayCollection();
        $this->candidatos = new ArrayCollection();
    }

    public function __sleep()
    {
        return array('id', 'descripcion', 'telefono_tipo_id','candidatos');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set descripcion
     *
     * @param string $descripcion
     * @return TelefonoCodigoArea
     */
    public function setDescripcion($descripcion)
    {
        $this->descripcion = $descripcion;

        return $this;
    }

    /**
     * Get descripcion
     *
     * @return string 
     */
    public function getDescripcion()
    {
        return $this->descripcion;
    }

    /**
     * Add aldeaTelefonos
     *
     * @param \UBV\SurUbvBundle\Entity\AldeaTelefono $aldeaTelefonos
     * @return TelefonoCodigoArea
     */
    public function addAldeaTelefono(\UBV\SurUbvBundle\Entity\AldeaTelefono $aldeaTelefonos)
    {
        $this->aldeaTelefonos[] = $aldeaTelefonos;

        return $this;
    }

    /**
     * Remove aldeaTelefonos
     *
     * @param \UBV\SurUbvBundle\Entity\AldeaTelefono $aldeaTelefonos
     */
    public function removeAldeaTelefono(\UBV\SurUbvBundle\Entity\AldeaTelefono $aldeaTelefonos)
    {
        $this->aldeaTelefonos->removeElement($aldeaTelefonos);
    }

    /**
     * Get aldeaTelefonos
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getAldeaTelefonos()
    {
        return $this->aldeaTelefonos;
    }

    /**
     * Add personaTelefonos
     *
     * @param \UBV\SurUbvBundle\Entity\PersonaTelefono $personaTelefonos
     * @return TelefonoCodigoArea
     */
    public function addPersonaTelefono(\UBV\SurUbvBundle\Entity\PersonaTelefono $personaTelefonos)
    {
        $this->personaTelefonos[] = $personaTelefonos;

        return $this;
    }

    /**
     * Remove personaTelefonos
     *
     * @param \UBV\SurUbvBundle\Entity\PersonaTelefono $personaTelefonos
     */
    public function removePersonaTelefono(\UBV\SurUbvBundle\Entity\PersonaTelefono $personaTelefonos)
    {
        $this->personaTelefonos->removeElement($personaTelefonos);
    }

    /**
     * Get personaTelefonos
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getPersonaTelefonos()
    {
        return $this->personaTelefonos;
    }

    /**
     * Add unidadAdministrativaTelefonos
     *
     * @param \UBV\SurUbvBundle\Entity\UnidadAdministrativaTelefono $unidadAdministrativaTelefonos
     * @return TelefonoCodigoArea
     */
    public function addUnidadAdministrativaTelefono(\UBV\SurUbvBundle\Entity\UnidadAdministrativaTelefono $unidadAdministrativaTelefonos)
    {
        $this->unidadAdministrativaTelefonos[] = $unidadAdministrativaTelefonos;

        return $this;
    }

    /**
     * Remove unidadAdministrativaTelefonos
     *
     * @param \UBV\SurUbvBundle\Entity\UnidadAdministrativaTelefono $unidadAdministrativaTelefonos
     */
    public function removeUnidadAdministrativaTelefono(\UBV\SurUbvBundle\Entity\UnidadAdministrativaTelefono $unidadAdministrativaTelefonos)
    {
        $this->unidadAdministrativaTelefonos->removeElement($unidadAdministrativaTelefonos);
    }

    /**
     * Get unidadAdministrativaTelefonos
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getUnidadAdministrativaTelefonos()
    {
        return $this->unidadAdministrativaTelefonos;
    }

    /**
     * Set telefonoTipo
     *
     * @param \UBV\SurUbvBundle\Entity\TelefonoTipo $telefonoTipo
     * @return TelefonoCodigoArea
     */
    public function setTelefonoTipo(\UBV\SurUbvBundle\Entity\TelefonoTipo $telefonoTipo)
    {
        $this->telefonoTipo = $telefonoTipo;

        return $this;
    }

    /**
     * Get telefonoTipo
     *
     * @return \UBV\SurUbvBundle\Entity\TelefonoTipo 
     */
    public function getTelefonoTipo()
    {
        return $this->telefonoTipo;
    }
    
    public function __toString() {
      return $this->getDescripcion();
    }

    /**
     * Add candidatos
     *
     * @param \UBV\SurUbvBundle\Entity\Candidato $candidatos
     * @return TelefonoCodigoArea
     */
    public function addCandidato(\UBV\SurUbvBundle\Entity\Candidato $candidatos)
    {
        $this->candidatos[] = $candidatos;

        return $this;
    }

    /**
     * Remove candidatos
     *
     * @param \UBV\SurUbvBundle\Entity\Candidato $candidatos
     */
    public function removeCandidato(\UBV\SurUbvBundle\Entity\Candidato $candidatos)
    {
        $this->candidatos->removeElement($candidatos);
    }

    /**
     * Get candidatos
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getCandidatos()
    {
        return $this->candidatos;
    }
}
