<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * UBV\SurUbvBundle\Entity\TipoEspacio
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\TipoEspacioRepository")
 * @ORM\Table(name="tipo_espacio", uniqueConstraints={@ORM\UniqueConstraint(name="id_tipo_espacio_UNIQUE", columns={"id"})})
 */
class TipoEspacio
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="tipo_espacio_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="string", length=70)
     */
    protected $descripcion;

    /**
     * @ORM\OneToMany(targetEntity="AmbienteEspacio", mappedBy="tipoEspacio")
     * @ORM\JoinColumn(name="id", referencedColumnName="tipo_espacio_id", nullable=false)
     */
    protected $ambienteEspacios;

    public function __construct()
    {
        $this->ambienteEspacios = new ArrayCollection();
    }

    public function __sleep()
    {
        return array('id', 'descripcion');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set descripcion
     *
     * @param string $descripcion
     * @return TipoEspacio
     */
    public function setDescripcion($descripcion)
    {
        $this->descripcion = $descripcion;

        return $this;
    }

    /**
     * Get descripcion
     *
     * @return string 
     */
    public function getDescripcion()
    {
        return $this->descripcion;
    }

    /**
     * Add ambienteEspacios
     *
     * @param \UBV\SurUbvBundle\Entity\AmbienteEspacio $ambienteEspacios
     * @return TipoEspacio
     */
    public function addAmbienteEspacio(\UBV\SurUbvBundle\Entity\AmbienteEspacio $ambienteEspacios)
    {
        $this->ambienteEspacios[] = $ambienteEspacios;

        return $this;
    }

    /**
     * Remove ambienteEspacios
     *
     * @param \UBV\SurUbvBundle\Entity\AmbienteEspacio $ambienteEspacios
     */
    public function removeAmbienteEspacio(\UBV\SurUbvBundle\Entity\AmbienteEspacio $ambienteEspacios)
    {
        $this->ambienteEspacios->removeElement($ambienteEspacios);
    }

    /**
     * Get ambienteEspacios
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getAmbienteEspacios()
    {
        return $this->ambienteEspacios;
    }
}
