<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * UBV\SurUbvBundle\Entity\Turno
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\TurnoRepository")
 * @ORM\Table(name="turno", uniqueConstraints={@ORM\UniqueConstraint(name="id_turno_UNIQUE", columns={"id"})})
 */
class Turno
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="turno_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="string", length=70)
     */
    protected $descripcion;

    /**
     * @ORM\Column(type="string", length=5)
     */
    protected $codigo;

    /**
     * @ORM\OneToMany(targetEntity="AldeaMallaCurricula", mappedBy="turno")
     * @ORM\JoinColumn(name="id", referencedColumnName="turno_id", nullable=false)
     */
    protected $aldeaMallaCurriculas;

    /**
     * @ORM\OneToMany(targetEntity="EstudianteDetalle", mappedBy="turno")
     * @ORM\JoinColumn(name="id", referencedColumnName="turno_id", nullable=false)
     */
    protected $estudianteDetalles;

    public function __construct()
    {
        $this->aldeaMallaCurriculas = new ArrayCollection();
        $this->estudianteDetalles = new ArrayCollection();
    }

    public function __sleep()
    {
        return array('id', 'descripcion', 'codigo');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set descripcion
     *
     * @param string $descripcion
     * @return Turno
     */
    public function setDescripcion($descripcion)
    {
        $this->descripcion = $descripcion;

        return $this;
    }

    /**
     * Get descripcion
     *
     * @return string 
     */
    public function getDescripcion()
    {
        return $this->descripcion;
    }

    /**
     * Set codigo
     *
     * @param string $codigo
     * @return Turno
     */
    public function setCodigo($codigo)
    {
        $this->codigo = $codigo;

        return $this;
    }

    /**
     * Get codigo
     *
     * @return string 
     */
    public function getCodigo()
    {
        return $this->codigo;
    }

    /**
     * Add aldeaMallaCurriculas
     *
     * @param \UBV\SurUbvBundle\Entity\AldeaMallaCurricula $aldeaMallaCurriculas
     * @return Turno
     */
    public function addAldeaMallaCurricula(\UBV\SurUbvBundle\Entity\AldeaMallaCurricula $aldeaMallaCurriculas)
    {
        $this->aldeaMallaCurriculas[] = $aldeaMallaCurriculas;

        return $this;
    }

    /**
     * Remove aldeaMallaCurriculas
     *
     * @param \UBV\SurUbvBundle\Entity\AldeaMallaCurricula $aldeaMallaCurriculas
     */
    public function removeAldeaMallaCurricula(\UBV\SurUbvBundle\Entity\AldeaMallaCurricula $aldeaMallaCurriculas)
    {
        $this->aldeaMallaCurriculas->removeElement($aldeaMallaCurriculas);
    }

    /**
     * Get aldeaMallaCurriculas
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getAldeaMallaCurriculas()
    {
        return $this->aldeaMallaCurriculas;
    }

    /**
     * Add estudianteDetalles
     *
     * @param \UBV\SurUbvBundle\Entity\EstudianteDetalle $estudianteDetalles
     * @return Turno
     */
    public function addEstudianteDetalle(\UBV\SurUbvBundle\Entity\EstudianteDetalle $estudianteDetalles)
    {
        $this->estudianteDetalles[] = $estudianteDetalles;

        return $this;
    }

    /**
     * Remove estudianteDetalles
     *
     * @param \UBV\SurUbvBundle\Entity\EstudianteDetalle $estudianteDetalles
     */
    public function removeEstudianteDetalle(\UBV\SurUbvBundle\Entity\EstudianteDetalle $estudianteDetalles)
    {
        $this->estudianteDetalles->removeElement($estudianteDetalles);
    }

    /**
     * Get estudianteDetalles
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getEstudianteDetalles()
    {
        return $this->estudianteDetalles;
    }
}
