<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * UBV\SurUbvBundle\Entity\UnidadAdministrativaTelefono
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\UnidadAdministrativaTelefonoRepository")
 * @ORM\Table(name="unidad_administrativa_telefono", indexes={@ORM\Index(name="fk_unidad_administrativa_telefono_unidad_administrativa1_idx", columns={"unidad_administrativa_id"}), @ORM\Index(name="fk_unidad_administrativa_telefono_telefono_codigo_area1_idx", columns={"telefono_codigo_area_id"})}, uniqueConstraints={@ORM\UniqueConstraint(name="id_unidad_administrativa_telefono_UNIQUE", columns={"id"})})
 */
class UnidadAdministrativaTelefono
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="unidad_administrativa_telefono_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="integer")
     */
    protected $descripcion;

    /**
     * @ORM\ManyToOne(targetEntity="UnidadAdministrativa", inversedBy="unidadAdministrativaTelefonos")
     * @ORM\JoinColumn(name="unidad_administrativa_id", referencedColumnName="id", nullable=false)
     */
    protected $unidadAdministrativa;

    /**
     * @ORM\ManyToOne(targetEntity="TelefonoCodigoArea", inversedBy="unidadAdministrativaTelefonos")
     * @ORM\JoinColumn(name="telefono_codigo_area_id", referencedColumnName="id", nullable=false)
     */
    protected $telefonoCodigoArea;

    public function __construct()
    {
    }

    public function __sleep()
    {
        return array('id', 'descripcion', 'unidad_administrativa_id', 'telefono_codigo_area_id');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set descripcion
     *
     * @param integer $descripcion
     * @return UnidadAdministrativaTelefono
     */
    public function setDescripcion($descripcion)
    {
        $this->descripcion = $descripcion;

        return $this;
    }

    /**
     * Get descripcion
     *
     * @return integer 
     */
    public function getDescripcion()
    {
        return $this->descripcion;
    }

    /**
     * Set unidadAdministrativa
     *
     * @param \UBV\SurUbvBundle\Entity\UnidadAdministrativa $unidadAdministrativa
     * @return UnidadAdministrativaTelefono
     */
    public function setUnidadAdministrativa(\UBV\SurUbvBundle\Entity\UnidadAdministrativa $unidadAdministrativa)
    {
        $this->unidadAdministrativa = $unidadAdministrativa;

        return $this;
    }

    /**
     * Get unidadAdministrativa
     *
     * @return \UBV\SurUbvBundle\Entity\UnidadAdministrativa 
     */
    public function getUnidadAdministrativa()
    {
        return $this->unidadAdministrativa;
    }

    /**
     * Set telefonoCodigoArea
     *
     * @param \UBV\SurUbvBundle\Entity\TelefonoCodigoArea $telefonoCodigoArea
     * @return UnidadAdministrativaTelefono
     */
    public function setTelefonoCodigoArea(\UBV\SurUbvBundle\Entity\TelefonoCodigoArea $telefonoCodigoArea)
    {
        $this->telefonoCodigoArea = $telefonoCodigoArea;

        return $this;
    }

    /**
     * Get telefonoCodigoArea
     *
     * @return \UBV\SurUbvBundle\Entity\TelefonoCodigoArea 
     */
    public function getTelefonoCodigoArea()
    {
        return $this->telefonoCodigoArea;
    }
}
