<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * UBV\SurUbvBundle\Entity\UnidadCurricular
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\UnidadCurricularRepository")
 * @ORM\Table(name="unidad_curricular", uniqueConstraints={@ORM\UniqueConstraint(name="id_unidada_curricular_UNIQUE", columns={"id"})})
 */
class UnidadCurricular
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="unidad_curricular_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="string", length=70)
     */
    protected $descripcion;

    /**
     * @ORM\Column(type="boolean")
     */
    protected $codigo;

    /**
     * @ORM\OneToMany(targetEntity="UnidadCurricularDetalle", mappedBy="unidadCurricular")
     * @ORM\JoinColumn(name="id", referencedColumnName="unidad_curricular_id", nullable=false)
     */
    protected $unidadCurricularDetalles;

    public function __construct()
    {
        $this->unidadCurricularDetalles = new ArrayCollection();
    }

    public function __sleep()
    {
        return array('id', 'descripcion', 'codigo');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set descripcion
     *
     * @param string $descripcion
     * @return UnidadCurricular
     */
    public function setDescripcion($descripcion)
    {
        $this->descripcion = $descripcion;

        return $this;
    }

    /**
     * Get descripcion
     *
     * @return string 
     */
    public function getDescripcion()
    {
        return $this->descripcion;
    }

    /**
     * Set codigo
     *
     * @param boolean $codigo
     * @return UnidadCurricular
     */
    public function setCodigo($codigo)
    {
        $this->codigo = $codigo;

        return $this;
    }

    /**
     * Get codigo
     *
     * @return boolean 
     */
    public function getCodigo()
    {
        return $this->codigo;
    }

    /**
     * Add unidadCurricularDetalles
     *
     * @param \UBV\SurUbvBundle\Entity\UnidadCurricularDetalle $unidadCurricularDetalles
     * @return UnidadCurricular
     */
    public function addUnidadCurricularDetalle(\UBV\SurUbvBundle\Entity\UnidadCurricularDetalle $unidadCurricularDetalles)
    {
        $this->unidadCurricularDetalles[] = $unidadCurricularDetalles;

        return $this;
    }

    /**
     * Remove unidadCurricularDetalles
     *
     * @param \UBV\SurUbvBundle\Entity\UnidadCurricularDetalle $unidadCurricularDetalles
     */
    public function removeUnidadCurricularDetalle(\UBV\SurUbvBundle\Entity\UnidadCurricularDetalle $unidadCurricularDetalles)
    {
        $this->unidadCurricularDetalles->removeElement($unidadCurricularDetalles);
    }

    /**
     * Get unidadCurricularDetalles
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getUnidadCurricularDetalles()
    {
        return $this->unidadCurricularDetalles;
    }
}
