<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;

/**
 * UBV\SurUbvBundle\Entity\UnidadCurricularDetalle
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\UnidadCurricularDetalleRepository")
 * @ORM\Table(name="unidad_curricular_detalle", indexes={@ORM\Index(name="fk_unidad_curricular_detalle_unidad_curricular1_idx", columns={"unidad_curricular_id"}), @ORM\Index(name="fk_unidad_curricular_detalle_unidad_curricular_tipo1_idx", columns={"unidad_curricular_tipo_id"}), @ORM\Index(name="fk_unidad_curricular_detalle_eje_formacion1_idx", columns={"eje_formacion_id"}), @ORM\Index(name="fk_unidad_curricular_detalle_frecuencia1_idx", columns={"frecuencia_id"})}, uniqueConstraints={@ORM\UniqueConstraint(name="id_unidad_curricular_detalle_UNIQUE", columns={"id"})})
 */
class UnidadCurricularDetalle
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="unidad_curricular_detalle_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="integer")
     */
    protected $num_horas_aula;

    /**
     * @ORM\Column(type="integer", nullable=true)
     */
    protected $num_horas_lab;

    /**
     * @ORM\Column(type="integer", nullable=true)
     */
    protected $unidades_credito;

    /**
     * @ORM\OneToMany(targetEntity="MallaCurricularDetalle", mappedBy="unidadCurricularDetalle")
     * @ORM\JoinColumn(name="id", referencedColumnName="unidad_curricular_detalle_id", nullable=false)
     */
    protected $mallaCurricularDetalles;

    /**
     * @ORM\ManyToOne(targetEntity="UnidadCurricular", inversedBy="unidadCurricularDetalles")
     * @ORM\JoinColumn(name="unidad_curricular_id", referencedColumnName="id", nullable=false)
     */
    protected $unidadCurricular;

    /**
     * @ORM\ManyToOne(targetEntity="UnidadCurricularTipo", inversedBy="unidadCurricularDetalles")
     * @ORM\JoinColumn(name="unidad_curricular_tipo_id", referencedColumnName="id", nullable=false)
     */
    protected $unidadCurricularTipo;

    /**
     * @ORM\ManyToOne(targetEntity="EjeFormacion", inversedBy="unidadCurricularDetalles")
     * @ORM\JoinColumn(name="eje_formacion_id", referencedColumnName="id", nullable=false)
     */
    protected $ejeFormacion;

    /**
     * @ORM\ManyToOne(targetEntity="Frecuencia", inversedBy="unidadCurricularDetalles")
     * @ORM\JoinColumn(name="frecuencia_id", referencedColumnName="id", nullable=false)
     */
    protected $frecuencia;

    public function __construct()
    {
        $this->mallaCurricularDetalles = new ArrayCollection();
    }

    public function __sleep()
    {
        return array('id', 'num_horas_aula', 'num_horas_lab', 'unidades_credito', 'unidad_curricular_id', 'unidad_curricular_tipo_id', 'eje_formacion_id', 'frecuencia_id');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set num_horas_aula
     *
     * @param integer $numHorasAula
     * @return UnidadCurricularDetalle
     */
    public function setNumHorasAula($numHorasAula)
    {
        $this->num_horas_aula = $numHorasAula;

        return $this;
    }

    /**
     * Get num_horas_aula
     *
     * @return integer 
     */
    public function getNumHorasAula()
    {
        return $this->num_horas_aula;
    }

    /**
     * Set num_horas_lab
     *
     * @param integer $numHorasLab
     * @return UnidadCurricularDetalle
     */
    public function setNumHorasLab($numHorasLab)
    {
        $this->num_horas_lab = $numHorasLab;

        return $this;
    }

    /**
     * Get num_horas_lab
     *
     * @return integer 
     */
    public function getNumHorasLab()
    {
        return $this->num_horas_lab;
    }

    /**
     * Set unidades_credito
     *
     * @param integer $unidadesCredito
     * @return UnidadCurricularDetalle
     */
    public function setUnidadesCredito($unidadesCredito)
    {
        $this->unidades_credito = $unidadesCredito;

        return $this;
    }

    /**
     * Get unidades_credito
     *
     * @return integer 
     */
    public function getUnidadesCredito()
    {
        return $this->unidades_credito;
    }

    /**
     * Add mallaCurricularDetalles
     *
     * @param \UBV\SurUbvBundle\Entity\MallaCurricularDetalle $mallaCurricularDetalles
     * @return UnidadCurricularDetalle
     */
    public function addMallaCurricularDetalle(\UBV\SurUbvBundle\Entity\MallaCurricularDetalle $mallaCurricularDetalles)
    {
        $this->mallaCurricularDetalles[] = $mallaCurricularDetalles;

        return $this;
    }

    /**
     * Remove mallaCurricularDetalles
     *
     * @param \UBV\SurUbvBundle\Entity\MallaCurricularDetalle $mallaCurricularDetalles
     */
    public function removeMallaCurricularDetalle(\UBV\SurUbvBundle\Entity\MallaCurricularDetalle $mallaCurricularDetalles)
    {
        $this->mallaCurricularDetalles->removeElement($mallaCurricularDetalles);
    }

    /**
     * Get mallaCurricularDetalles
     *
     * @return \Doctrine\Common\Collections\Collection 
     */
    public function getMallaCurricularDetalles()
    {
        return $this->mallaCurricularDetalles;
    }

    /**
     * Set unidadCurricular
     *
     * @param \UBV\SurUbvBundle\Entity\UnidadCurricular $unidadCurricular
     * @return UnidadCurricularDetalle
     */
    public function setUnidadCurricular(\UBV\SurUbvBundle\Entity\UnidadCurricular $unidadCurricular)
    {
        $this->unidadCurricular = $unidadCurricular;

        return $this;
    }

    /**
     * Get unidadCurricular
     *
     * @return \UBV\SurUbvBundle\Entity\UnidadCurricular 
     */
    public function getUnidadCurricular()
    {
        return $this->unidadCurricular;
    }

    /**
     * Set unidadCurricularTipo
     *
     * @param \UBV\SurUbvBundle\Entity\UnidadCurricularTipo $unidadCurricularTipo
     * @return UnidadCurricularDetalle
     */
    public function setUnidadCurricularTipo(\UBV\SurUbvBundle\Entity\UnidadCurricularTipo $unidadCurricularTipo)
    {
        $this->unidadCurricularTipo = $unidadCurricularTipo;

        return $this;
    }

    /**
     * Get unidadCurricularTipo
     *
     * @return \UBV\SurUbvBundle\Entity\UnidadCurricularTipo 
     */
    public function getUnidadCurricularTipo()
    {
        return $this->unidadCurricularTipo;
    }

    /**
     * Set ejeFormacion
     *
     * @param \UBV\SurUbvBundle\Entity\EjeFormacion $ejeFormacion
     * @return UnidadCurricularDetalle
     */
    public function setEjeFormacion(\UBV\SurUbvBundle\Entity\EjeFormacion $ejeFormacion)
    {
        $this->ejeFormacion = $ejeFormacion;

        return $this;
    }

    /**
     * Get ejeFormacion
     *
     * @return \UBV\SurUbvBundle\Entity\EjeFormacion 
     */
    public function getEjeFormacion()
    {
        return $this->ejeFormacion;
    }

    /**
     * Set frecuencia
     *
     * @param \UBV\SurUbvBundle\Entity\Frecuencia $frecuencia
     * @return UnidadCurricularDetalle
     */
    public function setFrecuencia(\UBV\SurUbvBundle\Entity\Frecuencia $frecuencia)
    {
        $this->frecuencia = $frecuencia;

        return $this;
    }

    /**
     * Get frecuencia
     *
     * @return \UBV\SurUbvBundle\Entity\Frecuencia 
     */
    public function getFrecuencia()
    {
        return $this->frecuencia;
    }
}
