<?php

namespace UBV\SurUbvBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * UBV\SurUbvBundle\Entity\UnidadTributaria
 *
 * @ORM\Entity(repositoryClass="UBV\SurUbvBundle\Entity\UnidadTributariaRepository")
 * @ORM\Table(name="unidad_tributaria", uniqueConstraints={@ORM\UniqueConstraint(name="id_unidad_tributaria_UNIQUE", columns={"id"})})
 */
class UnidadTributaria
{
    /**
     * @ORM\Id
     * @ORM\Column(type="integer")
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @ORM\SequenceGenerator(sequenceName="unidad_tributaria_id_seq", allocationSize=1, initialValue=1)
     */
    protected $id;

    /**
     * @ORM\Column(type="float")
     */
    protected $descripcion;

    /**
     * @ORM\Column(type="date")
     */
    protected $fecha_registro;

    /**
     * @ORM\Column(type="boolean")
     */
    protected $estatus;

    public function __construct()
    {
    }

    public function __sleep()
    {
        return array('id', 'descripcion', 'fecha_registro', 'estatus');
    }

    /**
     * Get id
     *
     * @return integer 
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Set descripcion
     *
     * @param float $descripcion
     * @return UnidadTributaria
     */
    public function setDescripcion($descripcion)
    {
        $this->descripcion = $descripcion;

        return $this;
    }

    /**
     * Get descripcion
     *
     * @return float 
     */
    public function getDescripcion()
    {
        return $this->descripcion;
    }

    /**
     * Set fecha_registro
     *
     * @param \DateTime $fechaRegistro
     * @return UnidadTributaria
     */
    public function setFechaRegistro($fechaRegistro)
    {
        $this->fecha_registro = $fechaRegistro;

        return $this;
    }

    /**
     * Get fecha_registro
     *
     * @return \DateTime 
     */
    public function getFechaRegistro()
    {
        return $this->fecha_registro;
    }

    /**
     * Set estatus
     *
     * @param boolean $estatus
     * @return UnidadTributaria
     */
    public function setEstatus($estatus)
    {
        $this->estatus = $estatus;

        return $this;
    }

    /**
     * Get estatus
     *
     * @return boolean 
     */
    public function getEstatus()
    {
        return $this->estatus;
    }
}
